/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.35 from the
 * contents of BerkeleyDB.xs. Do not edit this file, edit BerkeleyDB.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "BerkeleyDB.xs"
/*

 BerkeleyDB.xs -- Perl 5 interface to Berkeley DB version 2, 3, 4, 5 & 6

 written by Paul Marquess <pmqs@cpan.org>

 All comments/suggestions/problems are welcome

     Copyright (c) 1997-2015 Paul Marquess. All rights reserved.
     This program is free software; you can redistribute it and/or
     modify it under the same terms as Perl itself.

*/



#ifdef __cplusplus
extern "C" {
#endif

#define PERL_NO_GET_CONTEXT
#define PERL_POLLUTE
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"


/* XSUB.h defines a macro called abort 				*/
/* This clashes with the txn abort method in Berkeley DB 4.x	*/
/* This is a problem with ActivePerl (at least)			*/

#ifdef _WIN32
#  ifdef abort
#    undef abort
#  endif
#  ifdef fopen
#    undef fopen
#  endif
#  ifdef fclose
#    undef fclose
#  endif
#  ifdef rename
#    undef rename
#  endif
#  ifdef open
#    undef open
#  endif
#endif

#ifndef SvUTF8_off
# define SvUTF8_off(x)
#endif

#if PERL_REVISION == 5 && (PERL_VERSION < 8 || (PERL_VERSION == 8 && PERL_SUBVERSION < 4 ))

#    ifdef SvPVbyte_force
#        undef SvPVbyte_force
#    endif

#    define SvPVbyte_force(sv,lp) SvPV_force(sv,lp)

#endif
/* Being the Berkeley DB we prefer the <sys/cdefs.h> (which will be
 * shortly #included by the <db.h>) __attribute__ to the possibly
 * already defined __attribute__, for example by GNUC or by Perl. */

#undef __attribute__

#ifdef USE_PERLIO
#    define GetFILEptr(sv) PerlIO_exportFILE(IoIFP(sv_2io(sv)), NULL)
#else
#    define GetFILEptr(sv) IoIFP(sv_2io(sv))
#endif

#include <db.h>

/* Check the version of Berkeley DB */

#ifndef DB_VERSION_MAJOR
#ifdef HASHMAGIC
#error db.h is from Berkeley DB 1.x - need at least Berkeley DB 2.6.4
#else
#error db.h is not for Berkeley DB at all.
#endif
#endif

#if (DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6) ||\
    (DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR == 6 && DB_VERSION_PATCH < 4)
#  error db.h is from Berkeley DB 2.0-2.5 - need at least Berkeley DB 2.6.4
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_2_2
#endif


#if (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR == 0)
#  define IS_DB_3_0_x
#endif

#if DB_VERSION_MAJOR >= 3
#  define AT_LEAST_DB_3
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 1)
#  define AT_LEAST_DB_3_1
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_3_2
#endif

#if DB_VERSION_MAJOR > 3 || \
    (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR > 2) ||\
    (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR == 2 && DB_VERSION_PATCH >= 6)
#  define AT_LEAST_DB_3_2_6
#endif

#if DB_VERSION_MAJOR > 3 || (DB_VERSION_MAJOR == 3 && DB_VERSION_MINOR >= 3)
#  define AT_LEAST_DB_3_3
#endif

#if DB_VERSION_MAJOR >= 4
#  define AT_LEAST_DB_4
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 1)
#  define AT_LEAST_DB_4_1
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_4_2
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 3)
#  define AT_LEAST_DB_4_3
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 4)
#  define AT_LEAST_DB_4_4
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 5)
#  define AT_LEAST_DB_4_5
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 6)
#  define AT_LEAST_DB_4_6
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 7)
#  define AT_LEAST_DB_4_7
#endif

#if DB_VERSION_MAJOR > 4 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR >= 8)
#  define AT_LEAST_DB_4_8
#endif

#if DB_VERSION_MAJOR > 5 || (DB_VERSION_MAJOR == 5 && DB_VERSION_MINOR >= 1)
#  define AT_LEAST_DB_5_1
#endif

#if DB_VERSION_MAJOR > 5 || (DB_VERSION_MAJOR == 5 && DB_VERSION_MINOR >= 2)
#  define AT_LEAST_DB_5_2
#endif

#if DB_VERSION_MAJOR > 5 || (DB_VERSION_MAJOR == 5 && DB_VERSION_MINOR >= 3)
#  define AT_LEAST_DB_5_3
#endif

#if DB_VERSION_MAJOR >= 6 
#  define AT_LEAST_DB_6_0
#endif

#ifdef __cplusplus
}
#endif

#define DBM_FILTERING
#define STRICT_CLOSE
/* #define ALLOW_RECNO_OFFSET */
/* #define TRACE  */

#if DB_VERSION_MAJOR == 2 && ! defined(DB_LOCK_DEADLOCK)
#  define DB_LOCK_DEADLOCK	EAGAIN
#endif /* DB_VERSION_MAJOR == 2 */

#if DB_VERSION_MAJOR == 2
#  define DB_QUEUE		4
#endif /* DB_VERSION_MAJOR == 2 */

#if DB_VERSION_MAJOR == 2 
#  define BackRef	internal
#else
#  if DB_VERSION_MAJOR == 3 || (DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR == 0)
#    define BackRef	cj_internal
#  else
#    define BackRef	api_internal
#  endif
#endif

#ifdef AT_LEAST_DB_3_2
#    define DB_callback	DB * db,
#else
#    define DB_callback
#endif

#if DB_VERSION_MAJOR > 2
typedef struct {
        int              db_lorder;
        size_t           db_cachesize;
        size_t           db_pagesize;


        void *(*db_malloc) __P((size_t));

        u_int32_t        bt_maxkey;
        u_int32_t        bt_minkey;
#ifdef AT_LEAST_DB_6_0
        int (*bt_compare)
            __P((DB_callback const DBT *, const DBT *, size_t *));
        int (*dup_compare)
            __P((DB_callback const DBT *, const DBT *, size_t *));
#else
        int (*bt_compare)
            __P((DB_callback const DBT *, const DBT *));
        int (*dup_compare)
            __P((DB_callback const DBT *, const DBT *));
#endif
        size_t (*bt_prefix)
            __P((DB_callback const DBT *, const DBT *));

        u_int32_t        h_ffactor;
        u_int32_t        h_nelem;
        u_int32_t      (*h_hash)
            __P((DB_callback const void *, u_int32_t));

        int              re_pad;
        int              re_delim;
        u_int32_t        re_len;
        char            *re_source;

#define DB_DELIMITER            0x0001
#define DB_FIXEDLEN             0x0008
#define DB_PAD                  0x0010
        u_int32_t        flags;
        u_int32_t        q_extentsize;

        u_int32_t        heapsize_gbytes;
        u_int32_t        heapsize_bytes;
        u_int32_t        blob_threshold;
        char            *blob_dir;
} DB_INFO ;

#endif /* DB_VERSION_MAJOR > 2 */

typedef struct {
	int		Status ;
	/* char		ErrBuff[1000] ; */
	SV *		ErrPrefix ;
	SV *		ErrHandle ;
#ifdef AT_LEAST_DB_4_3
	SV *		MsgHandle ;
#endif
	DB_ENV *	Env ;
	int		open_dbs ;
	int		TxnMgrStatus ;
	int		active ;
	bool		txn_enabled ;
	bool		opened ;
	bool		cds_enabled;
	} BerkeleyDB_ENV_type ;


typedef struct {
        DBTYPE  	type ;
	bool		recno_or_queue ;
	char *		filename ;
	BerkeleyDB_ENV_type * parent_env ;
        DB *    	dbp ;
        SV *    	compare ;
        bool    	in_compare ;
        SV *    	dup_compare ;
        bool    	in_dup_compare ;
        SV *    	prefix ;
        bool    	in_prefix ;
        SV *   	 	hash ;
        bool    	in_hash ;
#ifdef AT_LEAST_DB_3_3
        SV *   	 	associated ;
        bool		secondary_db ;
#endif
#ifdef AT_LEAST_DB_4_8
        SV *   	 	associated_foreign ;
        SV *   	 	bt_compress ;
        SV *   	 	bt_uncompress ;
#endif
        bool		primary_recno_or_queue ;
	int		Status ;
        DB_INFO *	info ;
        DBC *   	cursor ;
	DB_TXN *	txn ;
	int		open_cursors ;
#ifdef AT_LEAST_DB_4_3
	int		open_sequences ;
#endif
	u_int32_t	partial ;
	u_int32_t	dlen ;
	u_int32_t	doff ;
	int		active ;
	bool		cds_enabled;
#ifdef ALLOW_RECNO_OFFSET
	int		array_base ;
#endif
#ifdef DBM_FILTERING
        SV *    filter_fetch_key ;
        SV *    filter_store_key ;
        SV *    filter_fetch_value ;
        SV *    filter_store_value ;
        int     filtering ;
#endif
        } BerkeleyDB_type;


typedef struct {
        DBTYPE  	type ;
	bool		recno_or_queue ;
	char *		filename ;
        DB *    	dbp ;
        SV *    	compare ;
        SV *    	dup_compare ;
        SV *    	prefix ;
        SV *   	 	hash ;
#ifdef AT_LEAST_DB_3_3
        SV *   	 	associated ;
	bool		secondary_db ;
#endif
#ifdef AT_LEAST_DB_4_8
        SV *   	 	associated_foreign ;
#endif
	bool		primary_recno_or_queue ;
	int		Status ;
        DB_INFO *	info ;
        DBC *   	cursor ;
	DB_TXN *	txn ;
	BerkeleyDB_type *		parent_db ;
	u_int32_t	partial ;
	u_int32_t	dlen ;
	u_int32_t	doff ;
	int		active ;
	bool		cds_enabled;
#ifdef ALLOW_RECNO_OFFSET
	int		array_base ;
#endif
#ifdef DBM_FILTERING
        SV *    filter_fetch_key ;
        SV *    filter_store_key ;
        SV *    filter_fetch_value ;
        SV *    filter_store_value ;
        int     filtering ;
#endif
        } BerkeleyDB_Cursor_type;

typedef struct {
	int		    Status ;
#ifdef AT_LEAST_DB_6_0
	DB_STREAM *	stream ;
#endif
	int		    active ;
	u_int32_t	partial ;
	u_int32_t	dlen ;
	u_int32_t	doff ;
#ifdef DBM_FILTERING
        SV *    filter_fetch_key ;
        SV *    filter_store_key ;
        SV *    filter_fetch_value ;
        SV *    filter_store_value ;
        int     filtering ;
#endif
	} BerkeleyDB_DbStream_type ;

typedef struct {
	BerkeleyDB_ENV_type *	env ;
	} BerkeleyDB_TxnMgr_type ;

#if 1
typedef struct {
	int		Status ;
	DB_TXN *	txn ;
	int		active ;
	} BerkeleyDB_Txn_type ;
#else
typedef DB_TXN                BerkeleyDB_Txn_type ;
#endif

#ifdef AT_LEAST_DB_4_3
typedef struct {
    int active;
    BerkeleyDB_type *db;
    DB_SEQUENCE     *seq;
} BerkeleyDB_Sequence_type;
#else
typedef int BerkeleyDB_Sequence_type;
typedef SV* db_seq_t;
#endif

#ifndef DB_DBT_APPMALLOC
#define DB_DBT_APPMALLOC 0
#endif

typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env ;
typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env__Raw ;
typedef BerkeleyDB_ENV_type *	BerkeleyDB__Env__Inner ;
typedef BerkeleyDB_type * 	BerkeleyDB ;
typedef void * 			BerkeleyDB__Raw ;
typedef BerkeleyDB_type *	BerkeleyDB__Common ;
typedef BerkeleyDB_type *	BerkeleyDB__Common__Raw ;
typedef BerkeleyDB_type *	BerkeleyDB__Common__Inner ;
typedef BerkeleyDB_type * 	BerkeleyDB__Hash ;
typedef BerkeleyDB_type * 	BerkeleyDB__Hash__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Btree ;
typedef BerkeleyDB_type * 	BerkeleyDB__Btree__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Recno ;
typedef BerkeleyDB_type * 	BerkeleyDB__Recno__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Queue ;
typedef BerkeleyDB_type * 	BerkeleyDB__Queue__Raw ;
typedef BerkeleyDB_type * 	BerkeleyDB__Heap ;
typedef BerkeleyDB_type * 	BerkeleyDB__Heap__Raw ;
typedef BerkeleyDB_Cursor_type   	BerkeleyDB__Cursor_type ;
typedef BerkeleyDB_Cursor_type * 	BerkeleyDB__Cursor ;
typedef BerkeleyDB_Cursor_type * 	BerkeleyDB__Cursor__Raw ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr__Raw ;
typedef BerkeleyDB_TxnMgr_type * BerkeleyDB__TxnMgr__Inner ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn__Raw ;
typedef BerkeleyDB_Txn_type *	BerkeleyDB__Txn__Inner ;
#ifdef AT_LEAST_DB_4_3
typedef BerkeleyDB_Sequence_type * 	BerkeleyDB__Sequence ;
#else
typedef int * 	BerkeleyDB__Sequence ;
#endif
//#ifdef AT_LEAST_DB_6_0
typedef BerkeleyDB_DbStream_type   	BerkeleyDB__DbStream_type ;
typedef BerkeleyDB_DbStream_type * 	BerkeleyDB__DbStream ;
typedef BerkeleyDB_DbStream_type * 	BerkeleyDB__DbStream__Raw ;
//#else
//typedef int   	BerkeleyDB__DbStream_type ;
//typedef int * 	BerkeleyDB__DbStream ;
//typedef int * 	BerkeleyDB__DbStream__Raw ;
//#endif
#if 0
typedef DB_LOG *      		BerkeleyDB__Log ;
typedef DB_LOCKTAB *  		BerkeleyDB__Lock ;
#endif
typedef DBT 			DBTKEY ;
typedef DBT 			DBT_OPT ;
typedef DBT 			DBT_B ;
typedef DBT 			DBTKEY_B ;
typedef DBT 			DBTKEY_B4Blob ;
typedef DBT 			DBTKEY_Br ;
typedef DBT 			DBTKEY_Bpr ;
typedef DBT 			DBTKEY_seq ;
typedef DBT 			DBT_Blob ;
typedef DBT 			DBTVALUE ;
typedef void *	      		PV_or_NULL ;
typedef PerlIO *      		IO_or_NULL ;
typedef int			DualType ;
typedef SV          SVnull;

static void
hash_delete(char * hash, char * key);

#ifdef TRACE
#  define Trace(x)	(printf("# "), printf x)
#else
#  define Trace(x)
#endif

#ifdef ALLOW_RECNO_OFFSET
#  define RECNO_BASE	db->array_base
#else
#  define RECNO_BASE	1
#endif

#if DB_VERSION_MAJOR == 2
#  define flagSet_DB2(i, f) i |= f
#else
#  define flagSet_DB2(i, f)
#endif

#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
#  define flagSet(bitmask)        (flags & (bitmask))
#else
#  define flagSet(bitmask)	((flags & DB_OPFLAGS_MASK) == (bitmask))
#endif

#ifdef DB_GET_BOTH_RANGE
#  define flagSetBoth() (flagSet(DB_GET_BOTH) || flagSet(DB_GET_BOTH_RANGE))
#else
#  define flagSetBoth() (flagSet(DB_GET_BOTH))
#endif                            

#ifndef AT_LEAST_DB_4
typedef	int db_timeout_t ;
#endif

#ifdef AT_LEAST_DB_5_2

#  define isHeapDb(db) ((db)->type == DB_HEAP)
#else
#  define isHeapDb(db) (0)

   int __heap_exist __P((void));
#  define DB_HEAP_RID_SZ 1


#endif

#ifndef AT_LEAST_DB_6_0
typedef	int db_off_t;
#endif

#define ERR_BUFF "BerkeleyDB::Error"

#define ZMALLOC(to, typ) ((to = (typ *)safemalloc(sizeof(typ))), \
				Zero(to,1,typ))

#define DBT_clear(x)	Zero(&x, 1, DBT) ;

#if 1
#define getInnerObject(x) (*av_fetch((AV*)SvRV(x), 0, FALSE))
#else
#define getInnerObject(x) ((SV*)SvRV(sv))
#endif

#define my_sv_setpvn(sv, d, s) do { \
                        s ? sv_setpvn(sv, d, s) : sv_setpv(sv, ""); \
                        SvUTF8_off(sv); \
                    } while(0)

#define GetValue_iv(h,k) (((sv = readHash(h, k)) && sv != &PL_sv_undef) \
				? SvIV(sv) : 0)
#define SetValue_iv(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = SvIV(sv)
#define SetValue_io(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = GetFILEptr(sv)
#define SetValue_sv(i, k) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = sv
#define SetValue_pv(i, k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = (t)SvPV(sv,PL_na)
#define SetValue_pvx(i, k, t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) \
				i = (t)SvPVX(sv)
#define SetValue_ov(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				IV tmp = SvIV(getInnerObject(sv)) ;	\
				i = INT2PTR(t, tmp) ;			\
			  }

#define SetValue_ovx(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				HV * hv = (HV *)GetInternalObject(sv);		\
				SV ** svp = hv_fetch(hv, "db", 2, FALSE);\
				IV tmp = SvIV(*svp);			\
				i = INT2PTR(t, tmp) ;				\
			  }

#define SetValue_ovX(i,k,t) if ((sv = readHash(hash, k)) && sv != &PL_sv_undef) {\
				IV tmp = SvIV(GetInternalObject(sv));\
				i = INT2PTR(t, tmp) ;				\
			  }

#define LastDBerror DB_RUNRECOVERY

#define setDUALerrno(var, err)					\
		sv_setnv(var, (double)err) ;			\
		sv_setpv(var, ((err) ? db_strerror(err) : "")) ;\
		SvNOK_on(var);

#define OutputValue(arg, name)                                  \
        { if (RETVAL == 0) {                                    \
              my_sv_setpvn(arg, name.data, name.size) ;         \
              DBM_ckFilter(arg, filter_fetch_value,"filter_fetch_value") ;            \
          }                                                     \
        }

#define OutputValue_B(arg, name)                                  \
        { if (RETVAL == 0) {                                    \
		if (db->type == DB_BTREE && 			\
			flagSet(DB_GET_RECNO)){			\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size) ;   \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_value, "filter_fetch_value");          \
          }                                                     \
        }

#define OutputKey(arg, name)                                    \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (!db->recno_or_queue) {                     	\
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                else                                            \
                    sv_setiv(arg, (I32)*(I32*)name.data - RECNO_BASE);   \
                if (! isHeapDb(db)) \
                    DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKeyBlob(arg, name)                                    \
        { if (RETVAL) 					\
          {                                                     \
              my_sv_setpvn(arg, name.data, name.size) ;         \
              DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#ifdef AT_LEAST_DB_4_3

#define InputKey_seq(arg, var)  \
	{   \
	    SV* my_sv = arg ;   \
	    /* DBM_ckFilter(my_sv, filter_store_key, "filter_store_key"); */ \
	    DBT_clear(var) ;    \
        SvGETMAGIC(arg) ;   \
	    if (seq->db->recno_or_queue) {  \
	        Value = GetRecnoKey(seq->db, SvIV(my_sv)) ;     \
	        var.data = & Value;     \
	        var.size = (int)sizeof(db_recno_t); \
	    }   \
	    else {  \
            STRLEN len; \
	        var.data = SvPV(my_sv, len);    \
	        var.size = (int)len;    \
	    }   \
	}

#define OutputKey_seq(arg, name)                                    \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (!seq->db->recno_or_queue) {                     	\
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                else                                            \
                    sv_setiv(arg, (I32)*(I32*)name.data - RECNO_BASE);   \
          }                                                     \
        }
#else
#define InputKey_seq(arg, var)
#define OutputKey_seq(arg, name) 
#endif

#define OutputKey_B(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->recno_or_queue 	                        \
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKey_Br(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->recno_or_queue || db->primary_recno_or_queue	\
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define OutputKey_Bpr(arg, name)                                  \
        { if (RETVAL == 0) 					\
          {                                                     \
                if (db->primary_recno_or_queue	\
			|| (db->type == DB_BTREE && 		\
			    flagSet(DB_GET_RECNO))){		\
                    sv_setiv(arg, (I32)(*(I32*)name.data) - RECNO_BASE); \
                }                                               \
                else {                                          \
                    my_sv_setpvn(arg, name.data, name.size);    \
                }                                               \
                DBM_ckFilter(arg, filter_fetch_key, "filter_fetch_key") ;            \
          }                                                     \
        }

#define SetPartial(data,db) 					\
	data.flags = db->partial ;				\
	data.dlen  = db->dlen ;					\
	data.doff  = db->doff ;

#define ckActive(active, type) 					\
    {								\
	if (!active)						\
	    softCrash("%s is already closed", type) ;		\
    }

#define ckActive_Environment(a)	ckActive(a, "Environment")
#define ckActive_TxnMgr(a)	ckActive(a, "Transaction Manager")
#define ckActive_Transaction(a) ckActive(a, "Transaction")
#define ckActive_DbStream(a) ckActive(a, "DB_STREAM")
#define ckActive_Database(a) 	ckActive(a, "Database")
#define ckActive_Cursor(a) 	ckActive(a, "Cursor")
#ifdef AT_LEAST_DB_4_3
#define ckActive_Sequence(a) 	ckActive(a, "Sequence")
#else
#define ckActive_Sequence(a) 	
#endif

#define dieIfEnvOpened(e, m) if (e->opened) softCrash("Cannot call method BerkeleyDB::Env::%s after environment has been opened", m);	

#define isSTDOUT_ERR(f) ((f) == stdout || (f) == stderr)


/* Internal Global Data */
#define MY_CXT_KEY "BerkeleyDB::_guts" XS_VERSION

typedef struct {
    db_recno_t	x_Value; 
    db_recno_t	x_zero;
    DBTKEY	x_empty;
#ifndef AT_LEAST_DB_3_2
    BerkeleyDB	x_CurrentDB;
#endif
} my_cxt_t;

START_MY_CXT

#define Value		(MY_CXT.x_Value)
#define zero		(MY_CXT.x_zero)
#define empty		(MY_CXT.x_empty)                             

#ifdef AT_LEAST_DB_3_2
#  define CurrentDB ((BerkeleyDB)db->BackRef) 
#else
#  define CurrentDB	(MY_CXT.x_CurrentDB)
#endif

#ifdef AT_LEAST_DB_3_2
#    define getCurrentDB ((BerkeleyDB)db->BackRef) 
#    define saveCurrentDB(db) 
#else
#    define getCurrentDB (MY_CXT.x_CurrentDB)
#    define saveCurrentDB(db) (MY_CXT.x_CurrentDB) = db
#endif

#if 0
static char	ErrBuff[1000] ;
#endif

#ifdef AT_LEAST_DB_3_3
#    if PERL_REVISION == 5 && PERL_VERSION <= 4

/* saferealloc in perl5.004 will croak if it is given a NULL pointer*/
void *
MyRealloc(void * ptr, size_t size)
{
    if (ptr == NULL ) 
        return safemalloc(size) ; 
    else
        return saferealloc(ptr, size) ;
}

#    else
#        define MyRealloc saferealloc
#    endif
#endif

static char *
my_strdup(const char *s)
{
    if (s == NULL)
        return NULL ;

    {
        MEM_SIZE l = strlen(s) + 1;
        char *s1 = (char *)safemalloc(l);

        Copy(s, s1, (MEM_SIZE)l, char);
        return s1;
    }
}

#if DB_VERSION_MAJOR == 2
static char *
db_strerror(int err)
{
    if (err == 0)
        return "" ;

    if (err > 0)
        return Strerror(err) ;

    switch (err) {
	case DB_INCOMPLETE:
		return ("DB_INCOMPLETE: Sync was unable to complete");
	case DB_KEYEMPTY:
		return ("DB_KEYEMPTY: Non-existent key/data pair");
	case DB_KEYEXIST:
		return ("DB_KEYEXIST: Key/data pair already exists");
	case DB_LOCK_DEADLOCK:
		return (
		    "DB_LOCK_DEADLOCK: Locker killed to resolve a deadlock");
	case DB_LOCK_NOTGRANTED:
		return ("DB_LOCK_NOTGRANTED: Lock not granted");
	case DB_LOCK_NOTHELD:
		return ("DB_LOCK_NOTHELD: Lock not held by locker");
	case DB_NOTFOUND:
		return ("DB_NOTFOUND: No matching key/data pair found");
	case DB_RUNRECOVERY:
		return ("DB_RUNRECOVERY: Fatal error, run database recovery");
	default:
		return "Unknown Error" ;

    }
}
#endif 	/* DB_VERSION_MAJOR == 2 */

#ifdef TRACE
#if DB_VERSION_MAJOR > 2
static char *
my_db_strerror(int err)
{
    static char buffer[1000] ;
    SV * sv = perl_get_sv(ERR_BUFF, FALSE) ;
    sprintf(buffer, "%d: %s", err, db_strerror(err)) ;
    if (err && sv) {
        strcat(buffer, ", ") ;
	strcat(buffer, SvPVX(sv)) ;
    }
    return buffer;
}
#endif
#endif

static void
close_everything(void)
{
#ifdef dTHX
    dTHX;
#endif    
    Trace(("close_everything\n")) ;
    /* Abort All Transactions */
    {
	BerkeleyDB__Txn__Raw 	tid ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Txn", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_txns dirty=%d\n", PL_dirty)) ;
	while ( (he = hv_iternext(hv)) ) {
	    tid = * (BerkeleyDB__Txn__Raw *) hv_iterkey(he, &len) ;
	    Trace(("  Aborting Transaction [%p] in [%p] Active [%d]\n", tid->txn, tid, tid->active));
	    if (tid->active) {
#ifdef AT_LEAST_DB_4
	    tid->txn->abort(tid->txn) ;
#else
	        txn_abort(tid->txn);
#endif
		++ closed ;
	    }
	    tid->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_txns aborted %d of %d transactios\n",closed, all)) ;
    }

#ifdef AT_LEAST_DB_6_0
    /* Close All DB_STREAM */
    {
        BerkeleyDB__DbStream db ;
        HE * he ;
        I32 len ;
        HV * hv = perl_get_hv("BerkeleyDB::Term::DbStream", TRUE);
        int  all = 0 ;
        int  closed = 0 ;
        (void) hv_iterinit(hv) ;
        Trace(("BerkeleyDB::DbStream::close_all_dbstream \n")) ;
        while ( (he = hv_iternext(hv)) ) {
            db = * (BerkeleyDB__DbStream*) hv_iterkey(he, &len) ;
            Trace(("  Closing DbStream [%p] in [%p] Active [%d]\n", db->stream, db, db->active));
            if (db->active) {
                (db->stream->close)(db->stream, 0);
                ++ closed ;
            }
            db->active = FALSE ;
            ++ all ;
        }
        Trace(("End of BerkeleyDB::Term::close_all_dbstream closed %d of %d streams\n",closed, all)) ;
    }
#endif

    /* Close All Cursors */
    {
	BerkeleyDB__Cursor db ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Cursor", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void) hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_cursors \n")) ;
	while ( (he = hv_iternext(hv)) ) {
	    db = * (BerkeleyDB__Cursor*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Cursor [%p] in [%p] Active [%d]\n", db->cursor, db, db->active));
	    if (db->active) {
    	        ((db->cursor)->c_close)(db->cursor) ;
		++ closed ;
	    }
	    db->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_cursors closed %d of %d cursors\n",closed, all)) ;
    }

    /* Close All Databases */
    {
	BerkeleyDB db ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Db", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_dbs\n" )) ;
	while ( (he = hv_iternext(hv)) ) {
	    db = * (BerkeleyDB*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Database [%p] in [%p] Active [%d]\n", db->dbp, db, db->active));
	    if (db->active) {
	        (db->dbp->close)(db->dbp, 0) ;
		++ closed ;
	    }
	    db->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_dbs closed %d of %d dbs\n",closed, all)) ;
    }

    /* Close All Environments */
    {
	BerkeleyDB__Env env ;
	HE * he ;
	I32 len ;
	HV * hv = perl_get_hv("BerkeleyDB::Term::Env", TRUE);
	int  all = 0 ;
	int  closed = 0 ;
	(void)hv_iterinit(hv) ;
	Trace(("BerkeleyDB::Term::close_all_envs\n")) ;
	while ( (he = hv_iternext(hv)) ) {
	    env = * (BerkeleyDB__Env*) hv_iterkey(he, &len) ;
	    Trace(("  Closing Environment [%p] in [%p] Active [%d]\n", env->Env, env, env->active));
	    if (env->active) {
#if DB_VERSION_MAJOR == 2
                db_appexit(env->Env) ;
#else
	        (env->Env->close)(env->Env, 0) ;
#endif
		++ closed ;
	    }
	    env->active = FALSE ;
	    ++ all ;
	}
	Trace(("End of BerkeleyDB::Term::close_all_envs closed %d of %d dbs\n",closed, all)) ;
    }

    Trace(("end close_everything\n")) ;

}

static void
destroyDB(BerkeleyDB db)
{
#ifdef dTHX
    dTHX;
#endif    
    if (! PL_dirty && db->active) {
	if (db->parent_env && db->parent_env->open_dbs)
	    -- db->parent_env->open_dbs ;
      	-- db->open_cursors ;
	((db->dbp)->close)(db->dbp, 0) ;
    }
    if (db->hash)
       	  SvREFCNT_dec(db->hash) ;
    if (db->compare)
       	  SvREFCNT_dec(db->compare) ;
    if (db->dup_compare)
       	  SvREFCNT_dec(db->dup_compare) ;
#ifdef AT_LEAST_DB_3_3
    if (db->associated && !db->secondary_db)
       	  SvREFCNT_dec(db->associated) ;
#endif
#ifdef AT_LEAST_DB_4_8
    if (db->associated_foreign)
       	  SvREFCNT_dec(db->associated_foreign) ;
#endif
    if (db->prefix)
       	  SvREFCNT_dec(db->prefix) ;
#ifdef DBM_FILTERING
    if (db->filter_fetch_key)
          SvREFCNT_dec(db->filter_fetch_key) ;
    if (db->filter_store_key)
          SvREFCNT_dec(db->filter_store_key) ;
    if (db->filter_fetch_value)
          SvREFCNT_dec(db->filter_fetch_value) ;
    if (db->filter_store_value)
          SvREFCNT_dec(db->filter_store_value) ;
#endif
    hash_delete("BerkeleyDB::Term::Db", (char *)db) ;
    if (db->filename)
             Safefree(db->filename) ;
    Safefree(db) ;
}

static int
softCrash(const char *pat, ...)
{
    char buffer1 [500] ;
    char buffer2 [500] ;
    va_list args;
    va_start(args, pat);

    Trace(("softCrash: %s\n", pat)) ;

#define ABORT_PREFIX "BerkeleyDB Aborting: "

    /* buffer = (char*) safemalloc(strlen(pat) + strlen(ABORT_PREFIX) + 1) ; */
    strcpy(buffer1, ABORT_PREFIX) ;
    strcat(buffer1, pat) ;

    vsprintf(buffer2, buffer1, args) ;

    /* Silence warning if -Werror=format-security enabled */
    croak("%s", buffer2);

    /* NOTREACHED */
    va_end(args);
    return 1 ;
}


static I32
GetArrayLength(BerkeleyDB db)
{
    I32		RETVAL = 0 ;
#ifndef AT_LEAST_DB_3_1
    DBT		key ;
    DBT		value ;

    DBC *   	cursor ;

    DBT_clear(key) ;
    DBT_clear(value) ;
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6
    if ( ((db->dbp)->cursor)(db->dbp, db->txn, &cursor) == 0 )
#else
    if ( ((db->dbp)->cursor)(db->dbp, db->txn, &cursor, 0) == 0 )
#endif
    {
        RETVAL = cursor->c_get(cursor, &key, &value, DB_LAST) ;
        if (RETVAL == 0)
            RETVAL = *(I32 *)key.data ;
        else /* No key means empty file */
            RETVAL = 0 ;
        cursor->c_close(cursor) ;
    }
    Trace(("GetArrayLength got %d\n", RETVAL)) ;
    return ((I32)RETVAL) ;

#else
    DB_BTREE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, 0) ;
#else        
#ifdef AT_LEAST_DB_3_3
    db->Status = ((db->dbp)->stat)(db->dbp, &stat, 0) ;
#else
    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, 0) ;
#endif
#endif
    if (db->Status == 0)
    {
        RETVAL = (I32)stat->bt_nkeys ;
    }

    Trace(("GetArrayLength got %d\n", stat->bt_nkeys)) ;
    return (RETVAL);

#endif
}

static I32
GetQueueLength(BerkeleyDB db)
{
#ifndef AT_LEAST_DB_3_3
    return 0;
#else
    I32		RETVAL = 0 ;
    DB_QUEUE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, 0) ;
#else        
#ifdef AT_LEAST_DB_3_3
    db->Status = ((db->dbp)->stat)(db->dbp, &stat, 0) ;
#else
    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, 0) ;
#endif
#endif
    if (db->Status == 0)
    {
        RETVAL = (I32)stat->qs_nkeys ;
    }

    Trace(("GetQueueLength got %d\n", stat->qs_nkeys)) ;
    return (RETVAL);
#endif
}

#if 0

#define GetRecnoKey(db, value)  _GetRecnoKey(db, value)

static db_recno_t
_GetRecnoKey(BerkeleyDB db, I32 value)
{
    Trace(("GetRecnoKey start value = %d\n", value)) ;
    if (db->recno_or_queue && value < 0) {
	/* Get the length of the array */
	I32 length = GetArrayLength(db) ;

	/* check for attempt to write before start of array */
	if (length + value + RECNO_BASE <= 0)
	    softCrash("Modification of non-creatable array value attempted, subscript %ld", (long)value) ;

	value = length + value + RECNO_BASE ;
    }
    else
        ++ value ;

    Trace(("GetRecnoKey end value = %d\n", value)) ;

    return value ;
}

#else /* ! 0 */

#if 0
#ifdef ALLOW_RECNO_OFFSET
#define GetRecnoKey(db, value) _GetRecnoKey(db, value)

static db_recno_t
_GetRecnoKey(BerkeleyDB db, I32 value)
{
    if (value + RECNO_BASE < 1)
	softCrash("key value %d < base (%d)", (value), RECNO_BASE?0:1) ;
    return value + RECNO_BASE ;
}

#else
#endif /* ALLOW_RECNO_OFFSET */
#endif /* 0 */

#define GetRecnoKey(db, value) ((value) + RECNO_BASE )

#endif /* 0 */

#if 0
static SV *
GetInternalObject(SV * sv)
{
    SV * info = (SV*) NULL ;
    SV * s ;
    MAGIC * mg ;

    Trace(("in GetInternalObject %d\n", sv)) ;
    if (sv == NULL || !SvROK(sv))
        return NULL ;

    s = SvRV(sv) ;
    if (SvMAGICAL(s))
    {
        if (SvTYPE(s) == SVt_PVHV || SvTYPE(s) == SVt_PVAV)
            mg = mg_find(s, 'P') ;
        else
            mg = mg_find(s, 'q') ;

	 /* all this testing is probably overkill, but till I know more
	    about global destruction it stays.
	 */
        /* if (mg && mg->mg_obj && SvRV(mg->mg_obj) && SvPVX(SvRV(mg->mg_obj))) */
        if (mg && mg->mg_obj && SvRV(mg->mg_obj) )
            info = SvRV(mg->mg_obj) ;
	else
	    info = s ;
    }

    Trace(("end of GetInternalObject %d\n", info)) ;
    return info ;
}
#endif

static int
#ifdef AT_LEAST_DB_6_0
btree_compare(DB_callback const DBT * key1, const DBT * key2, size_t * locp)
#else
btree_compare(DB_callback const DBT * key1, const DBT * key2 )
#endif
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * data1, * data2 ;
    int retval ;
    int count ;
    /* BerkeleyDB	keepDB = getCurrentDB ; */

    Trace(("In btree_compare \n")) ;
    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    /* SAVESPTR(CurrentDB); */

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->compare, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("in btree_compare - expected 1 return value from compare sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    /* CurrentDB = keepDB ; */
    return (retval) ;

}

static int
#ifdef AT_LEAST_DB_6_0
dup_compare(DB_callback const DBT * key1, const DBT * key2, size_t *locp )
#else
dup_compare(DB_callback const DBT * key1, const DBT * key2 )
#endif
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * data1, * data2 ;
    int retval ;
    int count ;
    /* BerkeleyDB	keepDB = CurrentDB ; */

    Trace(("In dup_compare \n")) ;
    if (!getCurrentDB)
	    softCrash("Internal Error - No CurrentDB in dup_compare") ;
    if (getCurrentDB->dup_compare == NULL)


        softCrash("in dup_compare: no callback specified for database '%s'", getCurrentDB->filename) ;

    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->dup_compare, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("dup_compare: expected 1 return value from compare sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    /* CurrentDB = keepDB ; */
    return (retval) ;

}

static size_t
btree_prefix(DB_callback const DBT * key1, const DBT * key2 )
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * data1, * data2 ;
    int retval ;
    int count ;
    /* BerkeleyDB	keepDB = CurrentDB ; */

    Trace(("In btree_prefix \n")) ;
    data1 = (char*) key1->data ;
    data2 = (char*) key2->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key1->size == 0)
        data1 = "" ;
    if (key2->size == 0)
        data2 = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(data1,key1->size)));
    PUSHs(sv_2mortal(newSVpvn(data2,key2->size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->prefix, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("btree_prefix: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    /* CurrentDB = keepDB ; */

    return (retval) ;
}

static u_int32_t
hash_cb(DB_callback const void * data, u_int32_t size)
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    int retval ;
    int count ;
    /* BerkeleyDB	keepDB = CurrentDB ; */

    Trace(("In hash_cb \n")) ;
#ifndef newSVpvn
    if (size == 0)
        data = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;

    XPUSHs(sv_2mortal(newSVpvn((char*)data,size)));
    PUTBACK ;

    count = perl_call_sv(getCurrentDB->hash, G_SCALAR);

    SPAGAIN ;

    if (count != 1)
        softCrash ("hash_cb: expected 1 return value from hash sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    FREETMPS ;
    LEAVE ;
    /* CurrentDB = keepDB ; */

    return (retval) ;
}

#ifdef AT_LEAST_DB_3_3

static int
associate_cb(DB_callback const DBT * pkey, const DBT * pdata, DBT * skey)
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * pk_dat, * pd_dat ;
    int retval ;
    int count ;
    SV * skey_SV ;
    STRLEN skey_len;
    char * skey_ptr ;

    Trace(("In associate_cb \n")) ;
    if (getCurrentDB->associated == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    skey_SV = newSVpv("",0);


    pk_dat = (char*) pkey->data ;
    pd_dat = (char*) pdata->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (pkey->size == 0)
        pk_dat = "" ;
    if (pdata->size == 0)
        pd_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,3) ;
    PUSHs(sv_2mortal(newSVpvn(pk_dat,pkey->size)));
    PUSHs(sv_2mortal(newSVpvn(pd_dat,pdata->size)));
    PUSHs(sv_2mortal(skey_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    
    if (retval != DB_DONOTINDEX)
    {
        /* retrieve the secondary key */
        DBT_clear(*skey);

        skey->flags = DB_DBT_APPMALLOC;

    #ifdef AT_LEAST_DB_4_6
        if ( SvROK(skey_SV) ) {
            SV *rv = SvRV(skey_SV);

            if ( SvTYPE(rv) == SVt_PVAV ) {
                AV *av = (AV *)rv;
                SV **svs = AvARRAY(av);
                I32 len = av_len(av) + 1;
                I32 i;
                DBT *dbts;

                if ( len == 0 ) {
                    retval = DB_DONOTINDEX;
                } else if ( len == 1 ) {
                    skey_ptr = SvPV(svs[0], skey_len);
                    skey->size = skey_len;
                    skey->data = (char*)safemalloc(skey_len);
                    memcpy(skey->data, skey_ptr, skey_len);
                    Trace(("key is %d -- %.*s\n", skey->size, skey->size, (char*)skey->data));
                } else {
                    skey->flags |= DB_DBT_MULTIPLE ;

                    /* FIXME this will leak if safemalloc fails later... do we care? */
                    dbts = (DBT *) safemalloc(sizeof(DBT) * len);
                    skey->size = len;
                    skey->data = (char *)dbts;

                    for ( i = 0; i < skey->size; i ++ ) {
                        skey_ptr = SvPV(svs[i], skey_len);

                        dbts[i].flags = DB_DBT_APPMALLOC;
                        dbts[i].size = skey_len;
                        dbts[i].data = (char *)safemalloc(skey_len);
                        memcpy(dbts[i].data, skey_ptr, skey_len);

                        Trace(("key is %d -- %.*s\n", dbts[i].size, dbts[i].size, (char*)dbts[i].data));
                    }
                    Trace(("mkey has %d subkeys\n", skey->size));
                }
            } else {
                croak("Not an array reference");
            }
        } else 
    #endif
        {
            skey_ptr = SvPV(skey_SV, skey_len);
            /* skey->size = SvCUR(skey_SV); */
            /* skey->data = (char*)safemalloc(skey->size); */
            skey->size = skey_len;
            skey->data = (char*)safemalloc(skey_len);
            memcpy(skey->data, skey_ptr, skey_len);
        }
    }
    Trace(("key is %d -- %.*s\n", skey->size, skey->size, (char*)skey->data));

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

static int
associate_cb_recno(DB_callback const DBT * pkey, const DBT * pdata, DBT * skey)
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * pk_dat, * pd_dat ;
    int retval ;
    int count ;
    SV * skey_SV ;

    Trace(("In associate_cb_recno \n")) ;
    if (getCurrentDB->associated == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    skey_SV = newSVpv("",0);


    pk_dat = (char*) pkey->data ;
    pd_dat = (char*) pdata->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (pkey->size == 0)
        pk_dat = "" ;
    if (pdata->size == 0)
        pd_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,2) ;
    PUSHs(sv_2mortal(newSVpvn(pk_dat,pkey->size)));
    PUSHs(sv_2mortal(newSVpvn(pd_dat,pdata->size)));
    PUSHs(sv_2mortal(skey_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;
    
    /* retrieve the secondary key */
    DBT_clear(*skey);

    if (retval != DB_DONOTINDEX)
    {
        Value = GetRecnoKey(getCurrentDB, SvIV(skey_SV)) ; 
        skey->flags = DB_DBT_APPMALLOC;
        skey->size = (int)sizeof(db_recno_t);
        skey->data = (char*)safemalloc(skey->size);
        memcpy(skey->data, &Value, skey->size);
    }

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

#endif /* AT_LEAST_DB_3_3 */

#ifdef AT_LEAST_DB_4_8

typedef int (*bt_compress_fcn_type)(DB *db, const DBT *prevKey, 
        const DBT *prevData, const DBT *key, const DBT *data, DBT *dest);

typedef int (*bt_decompress_fcn_type)(DB *db, const DBT *prevKey, 
        const DBT *prevData, DBT *compressed, DBT *destKey, DBT *destData);

#endif /* AT_LEAST_DB_4_8 */

typedef int (*foreign_cb_type)(DB *, const DBT *, DBT *, const DBT *, int *) ;

#ifdef AT_LEAST_DB_4_8

static int
associate_foreign_cb(DB* db, const DBT * key, DBT * data, const DBT * foreignkey, int* changed)
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * k_dat, * d_dat, * f_dat;
    int retval ;
    int count ;
    SV * changed_SV ;
    STRLEN skey_len;
    char * skey_ptr ;
    SV* data_sv ;

    Trace(("In associate_foreign_cb \n")) ;
    if (getCurrentDB->associated_foreign == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    changed_SV = newSViv(*changed);


    k_dat = (char*) key->data ;
    d_dat = (char*) data->data ;
    f_dat = (char*) foreignkey->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key->size == 0)
        k_dat = "" ;
    if (data->size == 0)
        d_dat = "" ;
    if (foreignkey->size == 0)
        f_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,4) ;

    PUSHs(sv_2mortal(newSVpvn(k_dat,key->size)));
    data_sv = newSVpv(d_dat, data->size);
    PUSHs(sv_2mortal(data_sv));
    PUSHs(sv_2mortal(newSVpvn(f_dat,foreignkey->size)));
    PUSHs(sv_2mortal(changed_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated_foreign, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate_foreign: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;

    *changed = SvIV(changed_SV);

    if (*changed)
    {
        DBT_clear(*data);
        data->flags = DB_DBT_APPMALLOC;
        skey_ptr = SvPV(data_sv, skey_len);
        data->size = skey_len;
        data->data = (char*)safemalloc(skey_len);
        memcpy(data->data, skey_ptr, skey_len);
    }
    /*Trace(("key is %d -- %.*s\n", skey->size, skey->size, skey->data));*/

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

static int
associate_foreign_cb_recno(DB* db, const DBT * key, DBT * data, const DBT * foreignkey, int* changed)
{
#ifdef dTHX
    dTHX;
#endif    
    dSP ;
    dMY_CXT ;    
    char * k_dat, * d_dat, * f_dat;
    int retval ;
    int count ;
    SV * changed_SV ;
    SV* data_sv ;

    Trace(("In associate_foreign_cb \n")) ;
    if (getCurrentDB->associated_foreign == NULL){
        Trace(("No Callback registered\n")) ;
        return EINVAL ;
    }

    changed_SV = newSViv(*changed);


    k_dat = (char*) key->data ;
    d_dat = (char*) data->data ;
    f_dat = (char*) foreignkey->data ;

#ifndef newSVpvn
    /* As newSVpv will assume that the data pointer is a null terminated C
       string if the size parameter is 0, make sure that data points to an
       empty string if the length is 0
    */
    if (key->size == 0)
        k_dat = "" ;
    if (data->size == 0)
        d_dat = "" ;
    if (foreignkey->size == 0)
        f_dat = "" ;
#endif

    ENTER ;
    SAVETMPS;

    PUSHMARK(SP) ;
    EXTEND(SP,4) ;

    PUSHs(sv_2mortal(newSVpvn(k_dat,key->size)));
    data_sv = newSVpv(d_dat, data->size);
    PUSHs(sv_2mortal(data_sv));
    PUSHs(sv_2mortal(newSVpvn(f_dat,foreignkey->size)));
    PUSHs(sv_2mortal(changed_SV));
    PUTBACK ;

    Trace(("calling associated cb\n"));
    count = perl_call_sv(getCurrentDB->associated_foreign, G_SCALAR);
    Trace(("called associated cb\n"));

    SPAGAIN ;

    if (count != 1)
        softCrash ("associate_foreign: expected 1 return value from prefix sub, got %d", count) ;

    retval = POPi ;

    PUTBACK ;

    *changed = SvIV(changed_SV);

    if (*changed)
    {
        DBT_clear(*data);
        Value = GetRecnoKey(getCurrentDB, SvIV(data_sv)) ; 
        data->flags = DB_DBT_APPMALLOC;
        data->size = (int)sizeof(db_recno_t);
        data->data = (char*)safemalloc(data->size);
        memcpy(data->data, &Value, data->size);
    }
    /*Trace(("key is %d -- %.*s\n", skey->size, skey->size, skey->data));*/

    FREETMPS ;
    LEAVE ;

    return (retval) ;
}

#endif /* AT_LEAST_DB_3_3 */

static void
#ifdef AT_LEAST_DB_4_3
db_errcall_cb(const DB_ENV* dbenv, const char * db_errpfx, const char * buffer)
#else
db_errcall_cb(const char * db_errpfx, char * buffer)
#endif
{
#ifdef dTHX
    dTHX;
#endif    
    SV * sv;

    Trace(("In errcall_cb \n")) ;
#if 0

    if (db_errpfx == NULL)
	db_errpfx = "" ;
    if (buffer == NULL )
	buffer = "" ;
    ErrBuff[0] = '\0';
    if (strlen(db_errpfx) + strlen(buffer) + 3 <= 1000) {
	if (*db_errpfx != '\0') {
	    strcat(ErrBuff, db_errpfx) ;
	    strcat(ErrBuff, ": ") ;
	}
	strcat(ErrBuff, buffer) ;
    }

#endif

    sv = perl_get_sv(ERR_BUFF, FALSE) ;
    if (sv) {
        if (db_errpfx)
	    sv_setpvf(sv, "%s: %s", db_errpfx, buffer) ;
        else
            sv_setpv(sv, buffer) ;
    }
}

#if defined(AT_LEAST_DB_4_4) && ! defined(_WIN32)

int
db_isalive_cb(DB_ENV *dbenv, pid_t pid, db_threadid_t tid, u_int32_t flags)
{
  bool processAlive = ( kill(pid, 0) == 0 ) || ( errno != ESRCH );
  return processAlive;
}

#endif


static SV *
readHash(HV * hash, char * key)
{
#ifdef dTHX
    dTHX;
#endif    
    SV **       svp;
    svp = hv_fetch(hash, key, strlen(key), FALSE);

    if (svp) {
        if (SvGMAGICAL(*svp))
            mg_get(*svp);
        if (SvOK(*svp))
            return *svp;
    }

    return NULL ;
}

static void
hash_delete(char * hash, char * key)
{
#ifdef dTHX
    dTHX;
#endif    
    HV * hv = perl_get_hv(hash, TRUE);
    (void) hv_delete(hv, (char*)&key, sizeof(key), G_DISCARD);
}

static void
hash_store_iv(char * hash, char * key, IV value)
{
#ifdef dTHX
    dTHX;
#endif    
    HV * hv = perl_get_hv(hash, TRUE);
    (void)hv_store(hv, (char*)&key, sizeof(key), newSViv(value), 0);
    /* printf("hv_store returned %d\n", ret) ; */
}

static void
hv_store_iv(HV * hash, char * key, IV value)
{
#ifdef dTHX
    dTHX;
#endif    
    hv_store(hash, key, strlen(key), newSViv(value), 0);
}

#if 0
static void
hv_store_uv(HV * hash, char * key, UV value)
{
    hv_store(hash, key, strlen(key), newSVuv(value), 0);
}
#endif

static void
GetKey(BerkeleyDB_type * db, SV * sv, DBTKEY * key)
{
#ifdef dTHX
    dTHX;
#endif    
    dMY_CXT ;    
    if (db->recno_or_queue) {
        Value = GetRecnoKey(db, SvIV(sv)) ; 
        key->data = & Value; 
        key->size = (int)sizeof(db_recno_t);
    }
    else {
        key->data = SvPV(sv, PL_na);
        key->size = (int)PL_na;
    }
}

static BerkeleyDB
my_db_open(
		BerkeleyDB	db ,
		SV * 		ref,
		SV *		ref_dbenv ,
		BerkeleyDB__Env	dbenv ,
    	    	BerkeleyDB__Txn txn, 
		const char *	file,
		const char *	subname,
		DBTYPE		type,
		int		flags,
		int		mode,
		DB_INFO * 	info,
		char *		password,
		int		enc_flags,
        HV*     hash
	)
{
#ifdef dTHX
    dTHX;
#endif    
    DB_ENV *	env    = NULL ;
    BerkeleyDB 	RETVAL = NULL ;
    DB *	dbp ;
    int		Status ;
    DB_TXN* 	txnid = NULL ;
    dMY_CXT;

    Trace(("_db_open(dbenv[%p] ref_dbenv [%p] file[%s] subname [%s] type[%d] flags[%d] mode[%d]\n",
		dbenv, ref_dbenv, file, subname, type, flags, mode)) ;

    
    if (dbenv)
	env = dbenv->Env ;

    if (txn)
        txnid = txn->txn;

    Trace(("_db_open(dbenv[%p] ref_dbenv [%p] txn [%p] file[%s] subname [%s] type[%d] flags[%d] mode[%d]\n",
		dbenv, ref_dbenv, txn, file, subname, type, flags, mode)) ;

#if DB_VERSION_MAJOR == 2
    if (subname)
        softCrash("Subname needs Berkeley DB 3 or better") ;
#endif

#ifndef AT_LEAST_DB_4_1
	    if (password)
	        softCrash("-Encrypt needs Berkeley DB 4.x or better") ;
#endif /* ! AT_LEAST_DB_4_1 */

#ifndef AT_LEAST_DB_3_2
    CurrentDB = db ;
#endif

#if DB_VERSION_MAJOR > 2
    Trace(("creating\n"));
    Status = db_create(&dbp, env, 0) ;
    Trace(("db_create returned %s\n", my_db_strerror(Status))) ;
    if (Status)
        return RETVAL ;

#ifdef AT_LEAST_DB_3_2
	dbp->BackRef = db;
#endif

#ifdef AT_LEAST_DB_3_3
    if (! env) {
	dbp->set_alloc(dbp, safemalloc, MyRealloc, safefree) ;
	dbp->set_errcall(dbp, db_errcall_cb) ;
    }
#endif

    {
        /* Btree Compression */
        SV* sv;
        SV* wanted = NULL;

	    SetValue_sv(wanted, "set_bt_compress") ;

        if (wanted)
        {
#ifndef AT_LEAST_DB_4_8
            softCrash("set_bt_compress needs Berkeley DB 4.8 or better") ;
#else
            bt_compress_fcn_type c = NULL;
            bt_decompress_fcn_type u = NULL;
            /*
            SV* compress = NULL;
            SV* uncompress = NULL;

            SetValue_sv(compress, "_btcompress1") ;
            SetValue_sv(uncompress, "_btcompress2") ;
            if (compress)
            {
                c = ;
                db->bt_compress = newSVsv(compress) ;
            }
            */

            Status = dbp->set_bt_compress(dbp, c, u);

            if (Status)
                return RETVAL ;
#endif /* AT_LEAST_DB_4_8 */
        }
    }

#ifdef AT_LEAST_DB_4_1
    /* set encryption */
    if (password)
    {
        Status = dbp->set_encrypt(dbp, password, enc_flags);
        Trace(("DB->set_encrypt passwd = %s, flags %d returned %s\n", 
			      		password, enc_flags,
  					my_db_strerror(Status))) ;
         if (Status)
              return RETVAL ;
    }
#endif	  

    if (info->re_source) {
        Status = dbp->set_re_source(dbp, info->re_source) ;
	Trace(("set_re_source [%s] returned %s\n",
		info->re_source, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_cachesize) {
        Status = dbp->set_cachesize(dbp, 0, info->db_cachesize, 0) ;
	Trace(("set_cachesize [%d] returned %s\n",
		info->db_cachesize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_lorder) {
        Status = dbp->set_lorder(dbp, info->db_lorder) ;
	Trace(("set_lorder [%d] returned %s\n",
		info->db_lorder, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->db_pagesize) {
        Status = dbp->set_pagesize(dbp, info->db_pagesize) ;
	Trace(("set_pagesize [%d] returned %s\n",
		info->db_pagesize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_ffactor) {
        Status = dbp->set_h_ffactor(dbp, info->h_ffactor) ;
	Trace(("set_h_ffactor [%d] returned %s\n",
		info->h_ffactor, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_nelem) {
        Status = dbp->set_h_nelem(dbp, info->h_nelem) ;
	Trace(("set_h_nelem [%d] returned %s\n",
		info->h_nelem, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_minkey) {
        Status = dbp->set_bt_minkey(dbp, info->bt_minkey) ;
	Trace(("set_bt_minkey [%d] returned %s\n",
		info->bt_minkey, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_compare) {
        Status = dbp->set_bt_compare(dbp, info->bt_compare) ;
	Trace(("set_bt_compare [%p] returned %s\n",
		info->bt_compare, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->h_hash) {
        Status = dbp->set_h_hash(dbp, info->h_hash) ;
	Trace(("set_h_hash [%p] returned %s\n",
		info->h_hash, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }


    if (info->dup_compare) {
        Status = dbp->set_dup_compare(dbp, info->dup_compare) ;
	Trace(("set_dup_compare [%p] returned %s\n",
		info->dup_compare, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->bt_prefix) {
        Status = dbp->set_bt_prefix(dbp, info->bt_prefix) ;
	Trace(("set_bt_prefix [%p] returned %s\n",
		info->bt_prefix, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_len) {
        Status = dbp->set_re_len(dbp, info->re_len) ;
	Trace(("set_re_len [%d] returned %s\n",
		info->re_len, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_delim) {
        Status = dbp->set_re_delim(dbp, info->re_delim) ;
	Trace(("set_re_delim [%d] returned %s\n",
		info->re_delim, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->re_pad) {
        Status = dbp->set_re_pad(dbp, info->re_pad) ;
	Trace(("set_re_pad [%d] returned %s\n",
		info->re_pad, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->flags) {
        Status = dbp->set_flags(dbp, info->flags) ;
	Trace(("set_flags [%d] returned %s\n",
		info->flags, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
    }

    if (info->q_extentsize) {
#ifdef AT_LEAST_DB_3_2
        Status = dbp->set_q_extentsize(dbp, info->q_extentsize) ;
	Trace(("set_q_extentsize [%d] returned %s\n",
		info->q_extentsize, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
#else
        softCrash("-ExtentSize needs at least Berkeley DB 3.2.x") ;
#endif
    }

    if (info->heapsize_bytes || info->heapsize_gbytes) {
#ifdef AT_LEAST_DB_5_2
        Status = dbp->set_heapsize(dbp, info->heapsize_gbytes,
                                   info->heapsize_bytes,0) ;
	Trace(("set_heapsize [%d,%d] returned %s\n",
		info->heapsize_gbytes, info->heapsize_bytes, my_db_strerror(Status)));
        if (Status)
            return RETVAL ;
#else
        softCrash("-HeapSize/HeapSizeGb needs at least Berkeley DB 5.2.x") ;
#endif
    }

		if (info->blob_threshold)
#ifndef AT_LEAST_DB_6_0
			softCrash("-BlobThreshold needs Berkeley DB 6.0 or better") ;
#else
	  {
          Status = dbp->set_blob_threshold(dbp, info->blob_threshold, 0);
		  Trace(("ENV->set_blob_threshold value = %d returned %s\n", 
                        info->blob_threshold,
						my_db_strerror(Status))) ;
        if (Status)
            return RETVAL ;
      }

#endif /* ! AT_LEAST_DB_6_0 */
		if (info->blob_dir)
#ifndef AT_LEAST_DB_6_0
			softCrash("-BlobDir needs Berkeley DB 6.0 or better") ;
#else
	  {
          Status = dbp->set_blob_dir(dbp, info->blob_dir);
		  Trace(("ENV->set_blob_dir value = %s returned %s\n", info->blob_dir,
						my_db_strerror(Status))) ;
        if (Status)
            return RETVAL ;
      }
#endif /* ! AT_LEAST_DB_6_0 */

    /* In-memory database need DB_CREATE from 4.4 */
    if (! file)
        flags |= DB_CREATE;

	Trace(("db_open'ing\n"));

#ifdef AT_LEAST_DB_4_1
    if ((Status = (dbp->open)(dbp, txnid, file, subname, type, flags, mode)) == 0) {
#else
    if ((Status = (dbp->open)(dbp, file, subname, type, flags, mode)) == 0) {
#endif /* AT_LEAST_DB_4_1 */
#else /* DB_VERSION_MAJOR == 2 */
    if ((Status = db_open(file, type, flags, mode, env, info, &dbp)) == 0) {
        CurrentDB = db ;
#endif /* DB_VERSION_MAJOR == 2 */


	Trace(("db_opened ok\n"));
	RETVAL = db ;
	RETVAL->dbp  = dbp ;
	RETVAL->txn  = txnid ;
#if DB_VERSION_MAJOR == 2
    	RETVAL->type = dbp->type ;
#else /* DB_VERSION_MAJOR > 2 */
#ifdef AT_LEAST_DB_3_3
    	dbp->get_type(dbp, &RETVAL->type) ;
#else /* DB 3.0 -> 3.2 */
    	RETVAL->type = dbp->get_type(dbp) ;
#endif
#endif /* DB_VERSION_MAJOR > 2 */
    	RETVAL->primary_recno_or_queue = FALSE;
    	RETVAL->recno_or_queue = (RETVAL->type == DB_RECNO ||
	                          RETVAL->type == DB_QUEUE) ;
	RETVAL->filename = my_strdup(file) ;
	RETVAL->Status = Status ;
	RETVAL->active = TRUE ;
	hash_store_iv("BerkeleyDB::Term::Db", (char *)RETVAL, 1) ;
	Trace(("  storing %p %p in BerkeleyDB::Term::Db\n", RETVAL, dbp)) ;
	if (dbenv) {
	    RETVAL->cds_enabled = dbenv->cds_enabled ;
	    RETVAL->parent_env = dbenv ;
	    dbenv->Status = Status ;
	    ++ dbenv->open_dbs ;
	}
    }
    else {
#if DB_VERSION_MAJOR > 2
	(dbp->close)(dbp, 0) ;
#endif
	destroyDB(db) ;
        Trace(("db open returned %s\n", my_db_strerror(Status))) ;
    }

    Trace(("End of _db_open\n"));
    return RETVAL ;
}


#include "constants.h"

#line 2326 "BerkeleyDB.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 2470 "BerkeleyDB.c"

/* INCLUDE:  Including 'constants.xs' from 'BerkeleyDB.xs' */


XS_EUPXS(XS_BerkeleyDB_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./constants.xs"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv;
	/* NV		nv;	Uncomment this if you need to return NVs */
	const char	*pv;
#line 2495 "BerkeleyDB.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./constants.xs"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv, &pv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid BerkeleyDB macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined BerkeleyDB macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
        case PERL_constant_ISPV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break;
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 1);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing BerkeleyDB macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 2572 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'BerkeleyDB.xs' from 'constants.xs' */

#define env_db_version(maj, min, patch) 	db_version(&maj, &min, &patch)

XS_EUPXS(XS_BerkeleyDB_db_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB_db_version)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "maj, min, patch");
    {
	int	maj = (int)SvIV(ST(0))
;
	int	min = (int)SvIV(ST(1))
;
	int	patch = (int)SvIV(ST(2))
;
#line 2327 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2598 "BerkeleyDB.c"
	char *	RETVAL;
	dXSTARG;

	RETVAL = env_db_version(maj, min, patch);
	sv_setiv(ST(0), (IV)maj);
	SvSETMAGIC(ST(0));
	sv_setiv(ST(1), (IV)min);
	SvSETMAGIC(ST(1));
	sv_setiv(ST(2), (IV)patch);
	SvSETMAGIC(ST(2));
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB_has_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB_has_heap)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 2336 "BerkeleyDB.xs"
#ifdef AT_LEAST_DB_5_2
        RETVAL = __heap_exist() ;
#else
        RETVAL = 0 ;
#endif
#line 2630 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB_db_value_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB_db_value_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "value, which");
    {
	int	value = (int)SvIV(ST(0))
;
	int	which = (int)SvIV(ST(1))
;

	Perl_croak(aTHX_ "BerkeleyDB::db_value_set: not implemented yet");
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__db_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__db_remove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 2357 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2666 "BerkeleyDB.c"
	DualType	RETVAL;
#line 2359 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("BerkeleyDB::db_remove needs Berkeley DB 3.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    BerkeleyDB__Env	env 	= NULL ;
	    BerkeleyDB__Txn	txn 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            if (txn) {
#ifdef AT_LEAST_DB_4_1
                if (!env)
                    softCrash("transactional db_remove requires an environment");
                RETVAL = env->Status = env->Env->dbremove(env->Env, txn->txn, db, subdb, flags);
#else
                softCrash("transactional db_remove requires Berkeley DB 4.1 or better");
#endif                
            } else {
                if (env)
                    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
                if (RETVAL == 0) {
                    RETVAL = dbp->remove(dbp, db, subdb, flags) ;
            }
        }
#endif
	}
#line 2706 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__db_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__db_verify)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 2403 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2729 "BerkeleyDB.c"
	DualType	RETVAL;
#line 2405 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
	    softCrash("BerkeleyDB::db_verify needs Berkeley DB 3.1.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    const char *	outfile	= NULL ;
	    FILE *		ofh = NULL;
	    BerkeleyDB__Env	env 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_pv(outfile, "Outfile", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            RETVAL = 0;
            if (outfile){
	        ofh = fopen(outfile, "w");
                if (! ofh)
                    RETVAL = errno;
            }
            if (! RETVAL) {
    	        if (env)
		    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
	        if (RETVAL == 0) {
	            RETVAL = dbp->verify(dbp, db, subdb, ofh, flags) ;
#ifndef AT_LEAST_DB_4_2 
                dbp->close(dbp, 0) ; 
#endif
	        }
	        if (outfile) 
                    fclose(ofh);
            }
#endif
	}
#line 2774 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__db_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__db_rename)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    {
	SV *	ref = ST(0)
;
#line 2454 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2797 "BerkeleyDB.c"
	DualType	RETVAL;
#line 2456 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
	    softCrash("BerkeleyDB::db_rename needs Berkeley DB 3.1.x or better") ;
#else
	    HV *		hash ;
    	    DB *		dbp ;
	    SV * 		sv ;
	    const char *	db = NULL ;
	    const char *	subdb 	= NULL ;
	    const char *	newname	= NULL ;
	    BerkeleyDB__Env	env 	= NULL ;
	    BerkeleyDB__Txn	txn 	= NULL ;
    	    DB_ENV *		dbenv   = NULL ;
	    u_int32_t		flags	= 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(db,    "Filename", char *) ;
	    SetValue_pv(subdb, "Subname", char *) ;
	    SetValue_pv(newname, "Newname", char *) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_ov(env, "Env", BerkeleyDB__Env) ;
            SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
            if (txn) {
#ifdef AT_LEAST_DB_4_1
                if (!env)
                    softCrash("transactional db_rename requires an environment");
                RETVAL = env->Status = env->Env->dbrename(env->Env, txn->txn, db, subdb, newname, flags);
#else
                softCrash("transactional db_rename requires Berkeley DB 4.1 or better");
#endif
            } else {
                if (env)
                    dbenv = env->Env ;
                RETVAL = db_create(&dbp, dbenv, 0) ;
                if (RETVAL == 0) {
                    RETVAL = (dbp->rename)(dbp, db, subdb, newname, flags) ;
            }
        }
#endif
	}
#line 2840 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_create)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "flags=0");
    {
	u_int32_t	flags;
#line 2505 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2862 "BerkeleyDB.c"
	BerkeleyDB__Env__Raw	RETVAL;
	dXSTARG;

	if (items < 1)
	    flags = 0;
	else {
	flags = SvUV(ST(0))
;
	}
#line 2507 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->create needs Berkeley DB 4.1 or better") ;
#else
	    DB_ENV *	env ;
	    int    status;
	    RETVAL = NULL;
	    Trace(("in BerkeleyDB::Env::create flags=%d\n",  flags)) ;
	    status = db_env_create(&env, flags) ;
	    Trace(("db_env_create returned %s\n", my_db_strerror(status))) ;
	    if (status == 0) {
	        ZMALLOC(RETVAL, BerkeleyDB_ENV_type) ;
		RETVAL->Env = env ;
	        RETVAL->active = TRUE ;
	        RETVAL->opened = FALSE;
	        env->set_alloc(env, safemalloc, MyRealloc, safefree) ;
	        env->set_errcall(env, db_errcall_cb) ;
	    }
#endif	    
	}
#line 2893 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_open)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "env, db_home=NULL, flags=0, mode=0777");
    {
	BerkeleyDB__Env	env;
	char *	db_home;
	u_int32_t	flags;
	int	mode;
#line 2537 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2913 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    db_home = NULL;
	else {
	    db_home = (char *)SvPV_nolen(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

	if (items < 4)
	    mode = 0777;
	else {
	    mode = (int)SvIV(ST(3))
;
	}
#line 2539 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->open needs Berkeley DB 4.1 or better") ;
#else
        RETVAL = env->Env->open(env->Env, db_home, flags, mode);
	env->opened = TRUE;
#endif
#line 2954 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_cds_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_cds_enabled)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 2552 "BerkeleyDB.xs"
	  dMY_CXT;
#line 2971 "BerkeleyDB.c"
	bool	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 2554 "BerkeleyDB.xs"
	    RETVAL = env->cds_enabled ;
#line 2985 "BerkeleyDB.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_encrypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, passwd, flags");
    {
	BerkeleyDB__Env	env;
	const char *	passwd;
	u_int32_t        flags = SvUV(ST(2))
;
#line 2565 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3005 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (ST(1) == &PL_sv_undef)
	    passwd = NULL ;
	else {
        STRLEN len;
            passwd = (const char *)SvPV(ST(1),len) ;
	    if (len == 0)
		passwd = NULL ;
	}
;
#line 2567 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_1
	    softCrash("$env->set_encrypt needs Berkeley DB 4.1 or better") ;
#else
        dieIfEnvOpened(env, "set_encrypt");
        RETVAL = env->Env->set_encrypt(env->Env, passwd, flags);
#endif
#line 3035 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_blob_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_blob_threshold)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, bytes, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t        bytes = SvUV(ST(1))
;
	u_int32_t	flags;
#line 2583 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3055 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 2585 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$env->set_blob_threshold needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = env->Env->set_blob_threshold(env->Env, bytes, flags);
#endif
#line 3081 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env__db_appinit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env__db_appinit)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, ref, errfile=NULL");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
	SV *	errfile;
#line 2602 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3102 "BerkeleyDB.c"
	BerkeleyDB__Env__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    errfile = NULL;
	else {
	    errfile = ST(2)
;
	}
#line 2604 "BerkeleyDB.xs"
	{
	    HV *	hash ;
	    SV *	sv ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;
	    char *	home = NULL ;
	    char * 	server = NULL ;
	    char **	config = NULL ;
	    int		flags = 0 ;
	    int		setflags = 0 ;
	    int		cachesize = 0 ;
	    int		lk_detect = 0 ;
            int		tx_max = 0 ;
            int		log_config = 0 ;
            int		max_lockers = 0 ;
            int		max_locks = 0 ;
            int		max_objects = 0 ;
	    long	shm_key = 0 ;
	    char*	data_dir = 0;
	    char*	log_dir = 0;
	    char*	temp_dir = 0;
	    SV *	msgfile = NULL ;
        int     thread_count = 0 ;
        int     blob_threshold = 0 ;
	    char*	blob_dir = 0;
	    SV *	errprefix = NULL;
	    DB_ENV *	env ;
	    int status ;

	    Trace(("in _db_appinit [%s] %p\n", self, ref)) ;
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(home,      "Home", char *) ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;
	    SetValue_pv(config,    "Config", char **) ;
	    SetValue_sv(errprefix, "ErrPrefix") ;
	    SetValue_iv(flags,     "Flags") ;
	    SetValue_iv(setflags,  "SetFlags") ;
	    SetValue_pv(server,    "Server", char *) ;
	    SetValue_iv(cachesize, "Cachesize") ;
	    SetValue_iv(lk_detect, "LockDetect") ;
	    SetValue_iv(tx_max,    "TxMax") ;
	    SetValue_iv(log_config,"LogConfig") ;
	    SetValue_iv(max_lockers,"MaxLockers") ;
	    SetValue_iv(max_locks, "MaxLocks") ;
	    SetValue_iv(max_objects,"MaxObjects") ;
	    SetValue_iv(shm_key,   "SharedMemKey") ;
		SetValue_iv(thread_count,   "ThreadCount") ;
		SetValue_iv(blob_threshold,   "BlobThreshold") ;
	    SetValue_pv(blob_dir,   "BlobDir", char*) ;
	    SetValue_pv(data_dir,   "DB_DATA_DIR", char*) ;
	    SetValue_pv(temp_dir,   "DB_TEMP_DIR", char*) ;
	    SetValue_pv(log_dir,    "DB_LOG_DIR", char*) ;
	    SetValue_sv(msgfile,    "MsgFile") ;
#ifndef AT_LEAST_DB_3_2
	    if (setflags)
	        softCrash("-SetFlags needs Berkeley DB 3.x or better") ;
#endif /* ! AT_LEAST_DB_3 */
#ifndef AT_LEAST_DB_3_1
	    if (shm_key)
	        softCrash("-SharedMemKey needs Berkeley DB 3.1 or better") ;
#endif /* ! AT_LEAST_DB_3_1 */
#if ! defined(AT_LEAST_DB_3_1) || defined(AT_LEAST_DB_5_1)
	    if (server)
	        softCrash("-Server only supported Berkeley DB 3.1 to 5.1") ;
#endif /* ! AT_LEAST_DB_3_1 */
#ifndef AT_LEAST_DB_3_2
	    if (max_lockers)
	        softCrash("-MaxLockers needs Berkeley DB 3.2 or better") ;
	    if (max_locks)
	        softCrash("-MaxLocks needs Berkeley DB 3.2 or better") ;
	    if (max_objects)
	        softCrash("-MaxObjects needs Berkeley DB 3.2 or better") ;
#endif /* ! AT_LEAST_DB_3_2 */
#ifndef AT_LEAST_DB_4_1
	    if (enc_passwd)
	        softCrash("-Encrypt needs Berkeley DB 4.x or better") ;
#endif /* ! AT_LEAST_DB_4_1 */
#ifndef AT_LEAST_DB_4_3
	    if (msgfile)
	        softCrash("-MsgFile needs Berkeley DB 4.3.x or better") ;
#endif /* ! AT_LEAST_DB_4_3 */
#ifdef _WIN32
		if (thread_count)
			softCrash("-ThreadCount not supported on Windows") ;
#endif /* ! _WIN32 */
#ifndef AT_LEAST_DB_4_4
		if (thread_count)
			softCrash("-ThreadCount needs Berkeley DB 4.4 or better") ;
#endif /* ! AT_LEAST_DB_4_4 */
#ifndef AT_LEAST_DB_4_7
		if (log_config)
			softCrash("-LogConfig needs Berkeley DB 4.7 or better") ;
#endif /* ! AT_LEAST_DB_4_7 */
#ifndef AT_LEAST_DB_6_0
		if (blob_threshold)
			softCrash("-BlobThreshold needs Berkeley DB 6.0 or better") ;
		if (blob_dir)
			softCrash("-BlobDir needs Berkeley DB 6.0 or better") ;
#endif /* ! AT_LEAST_DB_6_0 */
	    Trace(("_db_appinit(config=[%p], home=[%s],errprefix=[%p],flags=[%d]\n",
			config, home, errprefix, flags)) ;
#ifdef TRACE
	    if (config) {
	       int i ;
	      for (i = 0 ; i < 10 ; ++ i) {
		if (config[i] == NULL) {
		    printf("    End\n") ;
		    break ;
		}
	        printf("    config = [%s]\n", config[i]) ;
	      }
	    }
#endif /* TRACE */
	    ZMALLOC(RETVAL, BerkeleyDB_ENV_type) ;
	    if (flags & DB_INIT_TXN)
	        RETVAL->txn_enabled = TRUE ;
#if DB_VERSION_MAJOR == 2
	  ZMALLOC(RETVAL->Env, DB_ENV) ;
	  env = RETVAL->Env ;
	  {
	    /* Take a copy of the error prefix */
	    if (errprefix) {
	        Trace(("copying errprefix\n" )) ;
		RETVAL->ErrPrefix = newSVsv(errprefix) ;
		SvPOK_only(RETVAL->ErrPrefix) ;
	    } 
	    if (RETVAL->ErrPrefix)
	        RETVAL->Env->db_errpfx = SvPVX(RETVAL->ErrPrefix) ;

	    if (SvGMAGICAL(errfile))
		    mg_get(errfile);
	    if (SvOK(errfile)) {
	        FILE * ef = GetFILEptr(errfile) ;
	    	if (! ef)
		    croak("Cannot open file ErrFile: %s", Strerror(errno));
		RETVAL->ErrHandle = newSVsv(errfile) ;
	    	env->db_errfile = ef;
	    }
	    SetValue_iv(env->db_verbose, "Verbose") ;
	    env->db_errcall = db_errcall_cb ;
	    RETVAL->active = TRUE ;
	    RETVAL->opened = TRUE;
	    RETVAL->cds_enabled = ((flags & DB_INIT_CDB) != 0 ? TRUE : FALSE) ;
	    status = db_appinit(home, config, env, flags) ;
	    printf("  status = %d errno %d \n", status, errno) ;
	    Trace(("  status = %d env %d Env %d\n", status, RETVAL, env)) ;
	    if (status == 0)
	        hash_store_iv("BerkeleyDB::Term::Env", (char *)RETVAL, 1) ;
	    else {

                if (RETVAL->ErrHandle)
                    SvREFCNT_dec(RETVAL->ErrHandle) ;
                if (RETVAL->ErrPrefix)
                    SvREFCNT_dec(RETVAL->ErrPrefix) ;
                Safefree(RETVAL->Env) ;
                Safefree(RETVAL) ;
		RETVAL = NULL ;
	    }
	  }
#else /* DB_VERSION_MAJOR > 2 */
#ifndef AT_LEAST_DB_3_1
#    define DB_CLIENT	0
#endif
#ifdef AT_LEAST_DB_5_1
#    define DB_CLIENT	0
#else
#  ifdef AT_LEAST_DB_4_2
#    define DB_CLIENT	DB_RPCCLIENT
#  endif
#endif
	  status = db_env_create(&RETVAL->Env, server ? DB_CLIENT : 0) ;
	  Trace(("db_env_create flags = %d returned %s\n", flags,
	  					my_db_strerror(status))) ;
	  env = RETVAL->Env ;
#ifdef AT_LEAST_DB_3_3
	  env->set_alloc(env, safemalloc, MyRealloc, safefree) ;
#endif
#ifdef AT_LEAST_DB_3_1
	  if (status == 0 && shm_key) {
	      status = env->set_shm_key(env, shm_key) ;
	      Trace(("set_shm_key [%ld] returned %s\n", shm_key,
			my_db_strerror(status)));
	  }

	  if (status == 0 && data_dir) {
	      status = env->set_data_dir(env, data_dir) ;
	      Trace(("set_data_dir [%s] returned %s\n", data_dir,
			my_db_strerror(status)));
	  }

	  if (status == 0 && temp_dir) {
	      status = env->set_tmp_dir(env, temp_dir) ;
	      Trace(("set_tmp_dir [%s] returned %s\n", temp_dir,
			my_db_strerror(status)));
	  }

	  if (status == 0 && log_dir) {
	      status = env->set_lg_dir(env, log_dir) ;
	      Trace(("set_lg_dir [%s] returned %s\n", log_dir,
			my_db_strerror(status)));
	  }
#endif	  
	  if (status == 0 && cachesize) {
	      status = env->set_cachesize(env, 0, cachesize, 0) ;
	      Trace(("set_cachesize [%d] returned %s\n",
			cachesize, my_db_strerror(status)));
	  }

	  if (status == 0 && lk_detect) {
	      status = env->set_lk_detect(env, lk_detect) ;
	      Trace(("set_lk_detect [%d] returned %s\n",
	              lk_detect, my_db_strerror(status)));
	  }

	  if (status == 0 && tx_max) {
	      status = env->set_tx_max(env, tx_max) ;
	      Trace(("set_tx_max [%d] returned %s\n",
	              tx_max, my_db_strerror(status)));
	  }
#ifdef AT_LEAST_DB_4_7
	  if (status == 0 && log_config) {
	      status = env->log_set_config(env, log_config, 1) ;
	      Trace(("log_set_config [%d] returned %s\n",
	              log_config, my_db_strerror(status)));
	  }
#endif /* AT_LEAST_DB_4_7 */
#ifdef AT_LEAST_DB_3_2
	  if (status == 0 && max_lockers) {
	      status = env->set_lk_max_lockers(env, max_lockers) ;
	      Trace(("set_lk_max_lockers [%d] returned %s\n",
	              max_lockers, my_db_strerror(status)));
	  }

	  if (status == 0 && max_locks) {
	      status = env->set_lk_max_locks(env, max_locks) ;
	      Trace(("set_lk_max_locks [%d] returned %s\n",
	              max_locks, my_db_strerror(status)));
	  }

	  if (status == 0 && max_objects) {
	      status = env->set_lk_max_objects(env, max_objects) ;
	      Trace(("set_lk_max_objects [%d] returned %s\n",
	              max_objects, my_db_strerror(status)));
	  }
#endif /* AT_LEAST_DB_3_2 */
#ifdef AT_LEAST_DB_4_1
	  /* set encryption */
	  if (enc_passwd && status == 0)
	  {
	      status = env->set_encrypt(env, enc_passwd, enc_flags);
	      Trace(("ENV->set_encrypt passwd = %s, flags %d returned %s\n", 
				      		enc_passwd, enc_flags,
	  					my_db_strerror(status))) ;
	  }
#endif	  
#if ! defined(AT_LEAST_DB_5_1)
#ifdef AT_LEAST_DB_4
	  /* set the server */
	  if (server && status == 0)
	  {
	      status = env->set_rpc_server(env, NULL, server, 0, 0, 0);
	      Trace(("ENV->set_rpc_server server = %s returned %s\n", server,
	  					my_db_strerror(status))) ;
	  }
#else
#  if defined(AT_LEAST_DB_3_1) && ! defined(AT_LEAST_DB_4)
	  /* set the server */
	  if (server && status == 0)
	  {
	      status = env->set_server(env, server, 0, 0, 0);
	      Trace(("ENV->set_server server = %s returned %s\n", server,
	  					my_db_strerror(status))) ;
	  }
#  endif
#endif
#endif
#ifdef AT_LEAST_DB_3_2
	  if (setflags && status == 0)
	  {
	      status = env->set_flags(env, setflags, 1);
	      Trace(("ENV->set_flags value = %d returned %s\n", setflags,
	  					my_db_strerror(status))) ;
	  }
#endif
#if defined(AT_LEAST_DB_4_4) && ! defined(_WIN32)
	  if (thread_count && status == 0)
	  {
		  status = env->set_thread_count(env, thread_count);
		  Trace(("ENV->set_thread_count value = %d returned %s\n", thread_count,
						my_db_strerror(status))) ;
	  }
#endif
#ifdef AT_LEAST_DB_6_0
	  if (blob_threshold && status == 0)
	  {
          status = env->set_blob_threshold(env, blob_threshold, 0);
		  Trace(("ENV->set_blob_threshold value = %d returned %s\n", blob_threshold,
						my_db_strerror(status))) ;
      }
	  if (blob_dir && status == 0)
	  {
          status = env->set_blob_dir(env, blob_dir);
		  Trace(("ENV->set_blob_dir value = %s returned %s\n", blob_dir,
						my_db_strerror(status))) ;
      }
#endif
	  if (status == 0)
	  {
	    int		mode = 0 ;
	    /* Take a copy of the error prefix */
	    if (errprefix) {
	        Trace(("copying errprefix\n" )) ;
		RETVAL->ErrPrefix = newSVsv(errprefix) ;
		SvPOK_only(RETVAL->ErrPrefix) ;
	    }
	    if (RETVAL->ErrPrefix)
	        env->set_errpfx(env, SvPVX(RETVAL->ErrPrefix)) ;

	    if (SvGMAGICAL(errfile))
		    mg_get(errfile);
	    if (SvOK(errfile)) {
	        FILE * ef = GetFILEptr(errfile);
	    	if (! ef)
		    croak("Cannot open file ErrFile: %s", Strerror(errno));
		RETVAL->ErrHandle = newSVsv(errfile) ;
	    	env->set_errfile(env, ef) ;

	    }
#ifdef AT_LEAST_DB_4_3
	    if (msgfile) {
	        if (SvGMAGICAL(msgfile))
		    mg_get(msgfile);
	        if (SvOK(msgfile)) {
	            FILE * ef = GetFILEptr(msgfile);
	    	    if (! ef)
		        croak("Cannot open file MsgFile: %s", Strerror(errno));
		    RETVAL->MsgHandle = newSVsv(msgfile) ;
	    	    env->set_msgfile(env, ef) ;
	        }
	    }
#endif
	    SetValue_iv(mode, "Mode") ;
	    env->set_errcall(env, db_errcall_cb) ;
	    RETVAL->active = TRUE ;
	    RETVAL->cds_enabled = ((flags & DB_INIT_CDB) != 0 ? TRUE : FALSE) ; 
#ifdef IS_DB_3_0_x
	    status = (env->open)(env, home, config, flags, mode) ;
#else /* > 3.0 */
	    status = (env->open)(env, home, flags, mode) ;
#endif
	    Trace(("ENV->open(env=%p,home=%s,flags=%d,mode=%d)\n",env,home,flags,mode)) ;
	    Trace(("ENV->open returned %s\n", my_db_strerror(status))) ;
	  }

	  if (status == 0)
	      hash_store_iv("BerkeleyDB::Term::Env", (char *)RETVAL, 1) ;
	  else {
	      (env->close)(env, 0) ;
#ifdef AT_LEAST_DB_4_3
              if (RETVAL->MsgHandle)
                  SvREFCNT_dec(RETVAL->MsgHandle) ;
#endif
              if (RETVAL->ErrHandle)
                  SvREFCNT_dec(RETVAL->ErrHandle) ;
              if (RETVAL->ErrPrefix)
                  SvREFCNT_dec(RETVAL->ErrPrefix) ;
              Safefree(RETVAL) ;
	      RETVAL = NULL ;
	  }
#endif /* DB_VERSION_MAJOR > 2 */
	  {
	      SV * sv_err = perl_get_sv(ERR_BUFF, FALSE);
	      sv_setpv(sv_err, db_strerror(status));
	  }
	}
#line 3489 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_DB_ENV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_DB_ENV)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 2987 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3506 "BerkeleyDB.c"
	DB_ENV *	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 2989 "BerkeleyDB.xs"
	    if (env->active)
	        RETVAL = env->Env ;
	    else
	        RETVAL = NULL;
#line 3524 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_log_archive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_log_archive)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	u_int32_t	flags;
	BerkeleyDB__Env	env;
#line 3002 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3544 "BerkeleyDB.c"

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3004 "BerkeleyDB.xs"
	{
	  char ** list;
	  char ** file;
	  AV    * av;
#ifndef AT_LEAST_DB_3
          softCrash("log_archive needs at least Berkeley DB 3.x.x");
#else
#  ifdef AT_LEAST_DB_4
	  env->Status = env->Env->log_archive(env->Env, &list, flags) ;
#  else
#    ifdef AT_LEAST_DB_3_3
	  env->Status = log_archive(env->Env, &list, flags) ;
#    else
	  env->Status = log_archive(env->Env, &list, flags, safemalloc) ;
#    endif
#  endif
#ifdef DB_ARCH_REMOVE
	  if (env->Status == 0 && list != NULL && flags != DB_ARCH_REMOVE)
#else
	  if (env->Status == 0 && list != NULL )
#endif
          {
	      for (file = list; *file != NULL; ++file)
	      {
	        XPUSHs(sv_2mortal(newSVpv(*file, 0))) ;
	      }
	      safefree(list);
	  }
#endif
	}
#line 3593 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BerkeleyDB__Env_log_set_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_log_set_config)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, flags=0, onoff=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	onoff;
#line 3041 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3612 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

	if (items < 3)
	    onoff = 0;
	else {
	    onoff = (int)SvIV(ST(2))
;
	}
#line 3043 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_4_7
          softCrash("log_set_config needs at least Berkeley DB 4.7.x");
#else
	  RETVAL = env->Status = env->Env->log_set_config(env->Env, flags, onoff) ;
#endif
	}
#line 3646 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_log_get_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_log_get_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, flags, onoff");
    {
	BerkeleyDB__Env	env;
	u_int32_t        flags = SvUV(ST(1))
;
	int	onoff;
#line 3059 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3671 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3061 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_4_7
      softCrash("log_get_config needs at least Berkeley DB 4.7.x");
#else
	  RETVAL = env->Status = env->Env->log_get_config(env->Env, flags, &onoff) ;
#endif
	}
#line 3691 "BerkeleyDB.c"
	sv_setiv(ST(2), (IV)onoff);
	SvSETMAGIC(ST(2));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env__txn_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env__txn_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, pid=NULL, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Env	env;
	BerkeleyDB__Txn	pid;
#line 3079 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3717 "BerkeleyDB.c"
	BerkeleyDB__Txn__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    pid = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    pid = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    pid = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("pid is not of type BerkeleyDB::Txn")
;
	}
#line 3081 "BerkeleyDB.xs"
	{
	    DB_TXN *txn ;
	    DB_TXN *p_id = NULL ;
	    Trace(("txn_begin pid %p, flags %d\n", pid, flags)) ;
#if DB_VERSION_MAJOR == 2
	    if (env->Env->tx_info == NULL)
		softCrash("Transaction Manager not enabled") ;
#endif
	    if (!env->txn_enabled)
		softCrash("Transaction Manager not enabled") ;
	    if (pid)
		p_id = pid->txn ;
	    env->TxnMgrStatus =
#if DB_VERSION_MAJOR == 2
	    	txn_begin(env->Env->tx_info, p_id, &txn) ;
#else
#  ifdef AT_LEAST_DB_4
	    	env->Env->txn_begin(env->Env, p_id, &txn, flags) ;
#  else
	    	txn_begin(env->Env, p_id, &txn, flags) ;
#  endif
#endif
	    if (env->TxnMgrStatus == 0) {
	      ZMALLOC(RETVAL, BerkeleyDB_Txn_type) ;
	      RETVAL->txn  = txn ;
	      RETVAL->active = TRUE ;
	      Trace(("_txn_begin created txn [%p] in [%p]\n", txn, RETVAL));
	      hash_store_iv("BerkeleyDB::Term::Txn", (char *)RETVAL, 1) ;
	    }
	    else
		RETVAL = NULL ;
	}
#line 3784 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}

#if DB_VERSION_MAJOR == 2
#  define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env->tx_info, k, m)
#else /* DB 3.0 or better */
#  ifdef AT_LEAST_DB_4 
#    define env_txn_checkpoint(e,k,m,f) e->Env->txn_checkpoint(e->Env, k, m, f)
#  else
#    ifdef AT_LEAST_DB_3_1
#      define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env, k, m, 0)
#    else
#      define env_txn_checkpoint(e,k,m,f) txn_checkpoint(e->Env, k, m)
#    endif
#  endif
#endif

XS_EUPXS(XS_BerkeleyDB__Env_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_txn_checkpoint)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "env, kbyte, min, flags=0");
    {
	BerkeleyDB__Env	env;
	long	kbyte = (long)SvIV(ST(1))
;
	long	min = (long)SvIV(ST(2))
;
	u_int32_t	flags;
#line 3137 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3819 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}

	RETVAL = env_txn_checkpoint(env, kbyte, min, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_txn_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_txn_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
	HV *	RETVAL = NULL ;
#line 3144 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3862 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3146 "BerkeleyDB.xs"
	{
	    DB_TXN_STAT *	stat ;
#ifdef AT_LEAST_DB_4
	    if(env->Env->txn_stat(env->Env, &stat, 0) == 0) {
#else
#  ifdef AT_LEAST_DB_3_3
	    if(txn_stat(env->Env, &stat) == 0) {
#  else
#    if DB_VERSION_MAJOR == 2
	    if(txn_stat(env->Env->tx_info, &stat, safemalloc) == 0) {
#    else
	    if(txn_stat(env->Env, &stat, safemalloc) == 0) {
#    endif
#  endif
#endif
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "st_time_ckp", stat->st_time_ckp) ;
		hv_store_iv(RETVAL, "st_last_txnid", stat->st_last_txnid) ;
		hv_store_iv(RETVAL, "st_maxtxns", stat->st_maxtxns) ;
		hv_store_iv(RETVAL, "st_naborts", stat->st_naborts) ;
		hv_store_iv(RETVAL, "st_nbegins", stat->st_nbegins) ;
		hv_store_iv(RETVAL, "st_ncommits", stat->st_ncommits) ;
		hv_store_iv(RETVAL, "st_nactive", stat->st_nactive) ;
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "st_maxnactive", stat->st_maxnactive) ;
		hv_store_iv(RETVAL, "st_regsize", stat->st_regsize) ;
		hv_store_iv(RETVAL, "st_region_wait", stat->st_region_wait) ;
		hv_store_iv(RETVAL, "st_region_nowait", stat->st_region_nowait) ;
#endif
		safefree(stat) ;
	    }
	}
#line 3906 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define EnDis(x)	((x) ? "Enabled" : "Disabled")

XS_EUPXS(XS_BerkeleyDB__Env_printEnv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_printEnv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 3186 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3929 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3188 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 3942 "BerkeleyDB.c"
#line 3190 "BerkeleyDB.xs"
#if 0
	  printf("env             [0x%X]\n", env) ;
	  printf("  ErrPrefix     [%s]\n", env->ErrPrefix
				           ? SvPVX(env->ErrPrefix) : 0) ;
	  printf("  DB_ENV\n") ;
	  printf("    db_lorder   [%d]\n", env->Env.db_lorder) ;
	  printf("    db_home     [%s]\n", env->Env.db_home) ;
	  printf("    db_data_dir [%s]\n", env->Env.db_data_dir) ;
	  printf("    db_log_dir  [%s]\n", env->Env.db_log_dir) ;
	  printf("    db_tmp_dir  [%s]\n", env->Env.db_tmp_dir) ;
	  printf("    lk_info     [%s]\n", EnDis(env->Env.lk_info)) ;
	  printf("    lk_max      [%d]\n", env->Env.lk_max) ;
	  printf("    lg_info     [%s]\n", EnDis(env->Env.lg_info)) ;
	  printf("    lg_max      [%d]\n", env->Env.lg_max) ;
	  printf("    mp_info     [%s]\n", EnDis(env->Env.mp_info)) ;
	  printf("    mp_size     [%d]\n", env->Env.mp_size) ;
	  printf("    tx_info     [%s]\n", EnDis(env->Env.tx_info)) ;
	  printf("    tx_max      [%d]\n", env->Env.tx_max) ;
	  printf("    flags       [%d]\n", env->Env.flags) ;
	  printf("\n") ;
#endif
#line 3965 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__Env_errPrefix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_errPrefix)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, prefix");
    {
	BerkeleyDB__Env	env;
	SV *	prefix = ST(1)
;
#line 3217 "BerkeleyDB.xs"
	  dMY_CXT;
#line 3983 "BerkeleyDB.c"
	SV *	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3219 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 3997 "BerkeleyDB.c"
#line 3221 "BerkeleyDB.xs"
	  if (env->ErrPrefix) {
	      RETVAL = newSVsv(env->ErrPrefix) ;
              SvPOK_only(RETVAL) ;
	      sv_setsv(env->ErrPrefix, prefix) ;
	  }
	  else {
	      RETVAL = NULL ;
	      env->ErrPrefix = newSVsv(prefix) ;
	  }
	  SvPOK_only(env->ErrPrefix) ;
#if DB_VERSION_MAJOR == 2
	  env->Env->db_errpfx = SvPVX(env->ErrPrefix) ;
#else
	  env->Env->set_errpfx(env->Env, SvPVX(env->ErrPrefix)) ;
#endif
#line 4014 "BerkeleyDB.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 3243 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4032 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3245 "BerkeleyDB.xs"
	    RETVAL =  env->Status ;
#line 4046 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_db_appexit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_db_appexit)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 3255 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4069 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3258 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
#line 4083 "BerkeleyDB.c"
#line 3260 "BerkeleyDB.xs"
#ifdef STRICT_CLOSE
	    if (env->open_dbs)
		softCrash("attempted to close an environment with %d open database(s)",
			env->open_dbs) ;
#endif /* STRICT_CLOSE */
#if DB_VERSION_MAJOR == 2
	    RETVAL = db_appexit(env->Env) ;
#else
	    RETVAL = (env->Env->close)(env->Env, 0) ;
#endif
	    env->active = FALSE ;
	    hash_delete("BerkeleyDB::Term::Env", (char *)env) ;
#line 4097 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
	int	RETVAL = 0 ;
#line 3281 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4120 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3283 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::Env::DESTROY\n"));
	  Trace(("    env %p Env %p dirty %d\n", env, &env->Env, PL_dirty)) ;
	  if (env->active)
#if DB_VERSION_MAJOR == 2
              db_appexit(env->Env) ;
#else
	      (env->Env->close)(env->Env, 0) ;
#endif
          if (env->ErrHandle)
              SvREFCNT_dec(env->ErrHandle) ;
#ifdef AT_LEAST_DB_4_3
          if (env->MsgHandle)
              SvREFCNT_dec(env->MsgHandle) ;
#endif
          if (env->ErrPrefix)
              SvREFCNT_dec(env->ErrPrefix) ;
#if DB_VERSION_MAJOR == 2
          Safefree(env->Env) ;
#endif
          Safefree(env) ;
	  hash_delete("BerkeleyDB::Term::Env", (char *)env) ;
	  Trace(("End of BerkeleyDB::Env::DESTROY %d\n", RETVAL)) ;
#line 4154 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__Env__TxnMgr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env__TxnMgr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
#line 3310 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4170 "BerkeleyDB.c"
	BerkeleyDB__TxnMgr__Raw	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3312 "BerkeleyDB.xs"
	    ckActive_Environment(env->active) ;
	    if (!env->txn_enabled)
		softCrash("Transaction Manager not enabled") ;
#line 4187 "BerkeleyDB.c"
#line 3316 "BerkeleyDB.xs"
	    ZMALLOC(RETVAL, BerkeleyDB_TxnMgr_type) ;
	    RETVAL->env  = env ;
	    /* hash_store_iv("BerkeleyDB::Term::TxnMgr", (char *)txn, 1) ; */
#line 4192 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_get_shm_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_get_shm_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, id");
    {
	BerkeleyDB__Env	env;
	long	id;
#line 3327 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4210 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3329 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4225 "BerkeleyDB.c"
#line 3331 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_2
	    softCrash("$env->get_shm_key needs Berkeley DB 4.2 or better") ;
#else
	    RETVAL = env->Env->get_shm_key(env->Env, &id);
#endif	    
#line 4232 "BerkeleyDB.c"
	sv_setiv(ST(1), (IV)id);
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_lg_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_lg_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 3346 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4253 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3348 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4268 "BerkeleyDB.c"
#line 3350 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_lg_dir needs Berkeley DB 3.1 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_dir(env->Env, dir);
#endif
#line 4275 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_lg_bsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_lg_bsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, bsize");
    {
	BerkeleyDB__Env	env;
	u_int32_t        bsize = SvUV(ST(1))
;
#line 3363 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4294 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3365 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4309 "BerkeleyDB.c"
#line 3367 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_lg_bsize needs Berkeley DB 3.0.55 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_bsize(env->Env, bsize);
#endif
#line 4316 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_lg_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_lg_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, lg_max");
    {
	BerkeleyDB__Env	env;
	u_int32_t        lg_max = SvUV(ST(1))
;
#line 3380 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4335 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3382 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4350 "BerkeleyDB.c"
#line 3384 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_lg_max needs Berkeley DB 3.0.55 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_lg_max(env->Env, lg_max);
#endif
#line 4357 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_data_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_data_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 3397 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4376 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3399 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4391 "BerkeleyDB.c"
#line 3401 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_data_dir needs Berkeley DB 3.1 or better") ;
#else
            dieIfEnvOpened(env, "set_data_dir");
	    RETVAL = env->Status = env->Env->set_data_dir(env->Env, dir);
#endif
#line 4399 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_tmp_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_tmp_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	BerkeleyDB__Env	env;
	char *	dir = (char *)SvPV_nolen(ST(1))
;
#line 3415 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4418 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3417 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4433 "BerkeleyDB.c"
#line 3419 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
	    softCrash("$env->set_tmp_dir needs Berkeley DB 3.1 or better") ;
#else
	    RETVAL = env->Status = env->Env->set_tmp_dir(env->Env, dir);
#endif
#line 4440 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_mutexlocks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_mutexlocks)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, do_lock");
    {
	BerkeleyDB__Env	env;
	int	do_lock = (int)SvIV(ST(1))
;
#line 3432 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4459 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3434 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4474 "BerkeleyDB.c"
#line 3436 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_setmutexlocks needs Berkeley DB 3.0 or better") ;
#else
#  ifdef AT_LEAST_DB_4
	    RETVAL = env->Status = env->Env->set_flags(env->Env, DB_NOLOCKING, !do_lock);
#  else
#    if defined(AT_LEAST_DB_3_2_6) || defined(IS_DB_3_0_x)
	    RETVAL = env->Status = env->Env->set_mutexlocks(env->Env, do_lock);
#    else /* DB 3.1 or 3.2.3 */
	    RETVAL = env->Status = db_env_set_mutexlocks(do_lock);
#    endif
#  endif
#endif
#line 4489 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_verbose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_verbose)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, which, onoff");
    {
	BerkeleyDB__Env	env;
	u_int32_t        which = SvUV(ST(1))
;
	int	onoff = (int)SvIV(ST(2))
;
#line 3458 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4510 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3460 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4525 "BerkeleyDB.c"
#line 3462 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3
	    softCrash("$env->set_verbose needs Berkeley DB 3.x or better") ;
#else
	    RETVAL = env->Status = env->Env->set_verbose(env->Env, which, onoff);
#endif
#line 4532 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_flags)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, flags, onoff");
    {
	BerkeleyDB__Env	env;
	u_int32_t        flags = SvUV(ST(1))
;
	int	onoff = (int)SvIV(ST(2))
;
#line 3476 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4553 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3478 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4568 "BerkeleyDB.c"
#line 3480 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_2
	    softCrash("$env->set_flags needs Berkeley DB 3.2.x or better") ;
#else
	    RETVAL = env->Status = env->Env->set_flags(env->Env, flags, onoff);
#endif
#line 4575 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_lsn_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_lsn_reset)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, file, flags");
    {
	BerkeleyDB__Env	env;
	char*	file = (char *)SvPV_nolen(ST(1))
;
	u_int32_t        flags = SvUV(ST(2))
;
#line 3494 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4596 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3496 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4611 "BerkeleyDB.c"
#line 3498 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$env->lsn_reset needs Berkeley DB 4.3.x or better") ;
#else
	    RETVAL = env->Status = env->Env->lsn_reset(env->Env, file, flags);
#endif
#line 4618 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_lock_detect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_lock_detect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, atype=DB_LOCK_DEFAULT, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	atype;
	u_int32_t	flags;
#line 3512 "BerkeleyDB.xs"
       dMY_CXT;
#line 4637 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    atype = DB_LOCK_DEFAULT;
	else {
	atype = SvUV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 3514 "BerkeleyDB.xs"
       ckActive_Database(env->active) ;
#line 4666 "BerkeleyDB.c"
#line 3516 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4
	    softCrash("$env->lock_detect needs Berkeley DB 4.x or better") ;
#else
       RETVAL = env->Status = env->Env->lock_detect(env->Env,flags,atype,NULL);
#endif
#line 4673 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, timeout, flags=0");
    {
	BerkeleyDB__Env	env;
	db_timeout_t        timeout = SvUV(ST(1))
;
	u_int32_t	flags;
#line 3531 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4693 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 3533 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4715 "BerkeleyDB.c"
#line 3535 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4
	    softCrash("$env->set_timeout needs Berkeley DB 4.x or better") ;
#else
	    RETVAL = env->Status = env->Env->set_timeout(env->Env, timeout, flags);
#endif
#line 4722 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_get_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_get_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, timeout, flags=0");
    {
	BerkeleyDB__Env	env;
	db_timeout_t	timeout;
	u_int32_t	flags;
#line 3549 "BerkeleyDB.xs"
	  dMY_CXT;
#line 4741 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 3551 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4763 "BerkeleyDB.c"
#line 3553 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_2
	    softCrash("$env->set_timeout needs Berkeley DB 4.2.x or better") ;
#else
	    RETVAL = env->Status = env->Env->get_timeout(env->Env, &timeout, flags);
#endif
#line 4770 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)timeout);
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_stat_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_stat_print)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 3567 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4809 "BerkeleyDB.c"
#line 3569 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
		softCrash("$env->stat_print needs Berkeley DB 4.3 or better") ;
#else
		RETVAL = env->Status = env->Env->stat_print(env->Env, flags);
#endif
#line 4816 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_lock_stat_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_lock_stat_print)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 3582 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4853 "BerkeleyDB.c"
#line 3584 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
		softCrash("$env->lock_stat_print needs Berkeley DB 4.3 or better") ;
#else
		RETVAL = env->Status = env->Env->lock_stat_print(env->Env, flags);
#endif
#line 4860 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_mutex_stat_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_mutex_stat_print)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 3597 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4897 "BerkeleyDB.c"
#line 3599 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_4
		softCrash("$env->mutex_stat_print needs Berkeley DB 4.4 or better") ;
#else
		RETVAL = env->Status = env->Env->mutex_stat_print(env->Env, flags);
#endif
#line 4904 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_txn_stat_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_txn_stat_print)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 3613 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4941 "BerkeleyDB.c"
#line 3615 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
		softCrash("$env->mutex_stat_print needs Berkeley DB 4.3 or better") ;
#else
		RETVAL = env->Status = env->Env->txn_stat_print(env->Env, flags);
#endif
#line 4948 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_failchk); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_failchk)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, flags=0");
    {
	BerkeleyDB__Env	env;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 3628 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 4985 "BerkeleyDB.c"
#line 3630 "BerkeleyDB.xs"
#if ! defined(AT_LEAST_DB_4_4) || defined(_WIN32)
#ifndef AT_LEAST_DB_4_4
		softCrash("$env->failchk needs Berkeley DB 4.4 or better") ;
#endif
#ifdef _WIN32
		softCrash("$env->failchk not supported on Windows") ;
#endif
#else
		RETVAL = env->Status = env->Env->failchk(env->Env, flags);
#endif
#line 4997 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_set_isalive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_set_isalive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	BerkeleyDB__Env	env;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3647 "BerkeleyDB.xs"
	  ckActive_Database(env->active) ;
#line 5026 "BerkeleyDB.c"
#line 3649 "BerkeleyDB.xs"
#if ! defined(AT_LEAST_DB_4_4) || defined(_WIN32)
#ifndef AT_LEAST_DB_4_4
		softCrash("$env->set_isalive needs Berkeley DB 4.4 or better") ;
#endif
#ifdef _WIN32
		softCrash("$env->set_isalive not supported on Windows") ;
#endif
#else
		RETVAL = env->Status = env->Env->set_isalive(env->Env, db_isalive_cb);
#endif
#line 5038 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_get_blob_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_get_blob_threshold)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, bytes");
    {
	BerkeleyDB__Env	env;
	u_int32_t	bytes;
#line 3668 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5056 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3670 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$env->get_blob_threshold needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = env->Env->get_blob_threshold(env->Env, &bytes);
#endif
#line 5074 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)bytes);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Env_get_blob_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Env_get_blob_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	BerkeleyDB__Env	env;
	char*	dir;
#line 3684 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5099 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 3686 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$env->get_blob_dir needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = env->Env->get_blob_dir(env->Env, (const char**)&dir);
#endif
#line 5117 "BerkeleyDB.c"
	sv_setpv((SV*)ST(1), dir);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Term_close_everything); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Term_close_everything)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 3702 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5140 "BerkeleyDB.c"

	close_everything();
    }
    XSRETURN_EMPTY;
}

#define safeCroak(string)	softCrash(string)

XS_EUPXS(XS_BerkeleyDB__Term_safeCroak); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Term_safeCroak)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string");
    {
	char *	string = (char *)SvPV_nolen(ST(0))
;
#line 3709 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5160 "BerkeleyDB.c"

	safeCroak(string);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__Hash__db_open_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Hash__db_open_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
#line 3718 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5181 "BerkeleyDB.c"
	BerkeleyDB__Hash__Raw	RETVAL;
	dXSTARG;
#line 3720 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

    	    Trace(("_db_open_hash start\n")) ;
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char *) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.h_ffactor, "Ffactor") ;
	    SetValue_iv(info.h_nelem, "Nelem") ;
	    SetValue_iv(info.flags, "Property") ;
#ifdef AT_LEAST_DB_6_0
	    SetValue_iv(info.blob_threshold, "BlobThreshold") ;
	    SetValue_pv(info.blob_dir, "BlobDir", char*) ;
#endif
	    ZMALLOC(db, BerkeleyDB_type) ;
	    if ((sv = readHash(hash, "Hash")) && sv != &PL_sv_undef) {
		info.h_hash = hash_cb ;
		db->hash = newSVsv(sv) ;
	    }
	    /* DB_DUPSORT was introduced in DB 2.5.9 */
	    if ((sv = readHash(hash, "DupCompare")) && sv != &PL_sv_undef) {
#ifdef DB_DUPSORT
		info.dup_compare = dup_compare ;
		db->dup_compare = newSVsv(sv) ;
		info.flags |= DB_DUP|DB_DUPSORT ;
#else
	        croak("DupCompare needs Berkeley DB 2.5.9 or later") ;
#endif
	    }
	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname,
                    DB_HASH, flags, mode, &info, enc_passwd, enc_flags, hash) ;
    	    Trace(("_db_open_hash end\n")) ;
	}
#line 5242 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Hash_db_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Hash_db_stat)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;
#line 3787 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5261 "BerkeleyDB.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 3789 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5281 "BerkeleyDB.c"
#line 3791 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("$db->db_stat for a Hash needs Berkeley DB 3.x or better") ;
#else
	    DB_HASH_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status) {
	        XSRETURN_UNDEF;
	    } else {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "hash_magic", stat->hash_magic) ;
		hv_store_iv(RETVAL, "hash_version", stat->hash_version);
		hv_store_iv(RETVAL, "hash_pagesize", stat->hash_pagesize);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "hash_nkeys", stat->hash_nkeys);
		hv_store_iv(RETVAL, "hash_ndata", stat->hash_ndata);
#else
		hv_store_iv(RETVAL, "hash_nrecs", stat->hash_nrecs);
#endif
#ifndef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "hash_nelem", stat->hash_nelem);
#endif
		hv_store_iv(RETVAL, "hash_ffactor", stat->hash_ffactor);
		hv_store_iv(RETVAL, "hash_buckets", stat->hash_buckets);
		hv_store_iv(RETVAL, "hash_free", stat->hash_free);
		hv_store_iv(RETVAL, "hash_bfree", stat->hash_bfree);
		hv_store_iv(RETVAL, "hash_bigpages", stat->hash_bigpages);
		hv_store_iv(RETVAL, "hash_big_bfree", stat->hash_big_bfree);
		hv_store_iv(RETVAL, "hash_overflows", stat->hash_overflows);
		hv_store_iv(RETVAL, "hash_ovfl_free", stat->hash_ovfl_free);
		hv_store_iv(RETVAL, "hash_dup", stat->hash_dup);
		hv_store_iv(RETVAL, "hash_dup_free", stat->hash_dup_free);
#if DB_VERSION_MAJOR >= 3
		hv_store_iv(RETVAL, "hash_metaflags", stat->hash_metaflags);
#endif
		safefree(stat) ;
	    }
#endif
	}
#line 5330 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Unknown__db_open_unknown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Unknown__db_open_unknown)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ref = ST(0)
;
#line 3848 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5355 "BerkeleyDB.c"
#line 3850 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
	    BerkeleyDB		RETVAL ;
    	    BerkeleyDB__Txn 	txn = NULL ;
#ifdef AT_LEAST_DB_5_2
	    static char * 		Names[] = {"", "Btree", "Hash", "Recno", "Queue", "Unknown", "Heap"} ;
#else
	    static char * 		Names[] = {"", "Btree", "Hash", "Recno", "Queue", "Unknown", "Heap"} ;
#endif
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char *) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.h_ffactor, "Ffactor") ;
	    SetValue_iv(info.h_nelem, "Nelem") ;
	    SetValue_iv(info.flags, "Property") ;
	    ZMALLOC(db, BerkeleyDB_type) ;

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname,
                    DB_UNKNOWN, flags, mode, &info, enc_passwd, enc_flags, hash) ;
	    XPUSHs(sv_2mortal(newSViv(PTR2IV(RETVAL))));
	    if (RETVAL)
	        XPUSHs(sv_2mortal(newSVpv(Names[RETVAL->type], 0))) ;
	    else
	        XPUSHs(sv_2mortal(newSViv((IV)NULL)));
	}
#line 5406 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BerkeleyDB__Btree__db_open_btree); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Btree__db_open_btree)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
#line 3909 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5426 "BerkeleyDB.c"
	BerkeleyDB__Btree__Raw	RETVAL;
	dXSTARG;
#line 3911 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB  	db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    Trace(("In _db_open_btree\n"));
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;
	    SetValue_iv(info.flags, "Property") ;
#ifdef AT_LEAST_DB_6_0
	    SetValue_iv(info.blob_threshold, "BlobThreshold") ;
	    SetValue_pv(info.blob_dir, "BlobDir", char*) ;
#endif
	    ZMALLOC(db, BerkeleyDB_type) ;
	    if ((sv = readHash(hash, "Compare")) && sv != &PL_sv_undef) {
		Trace(("    Parsed Compare callback\n"));
		info.bt_compare = btree_compare ;
		db->compare = newSVsv(sv) ;
	    }
	    /* DB_DUPSORT was introduced in DB 2.5.9 */
	    if ((sv = readHash(hash, "DupCompare")) && sv != &PL_sv_undef) {
#ifdef DB_DUPSORT
		Trace(("    Parsed DupCompare callback\n"));
		info.dup_compare = dup_compare ;
		db->dup_compare = newSVsv(sv) ;
		info.flags |= DB_DUP|DB_DUPSORT ;
#else
	        softCrash("DupCompare needs Berkeley DB 2.5.9 or later") ;
#endif
	    }
	    if ((sv = readHash(hash, "Prefix")) && sv != &PL_sv_undef) {
		Trace(("    Parsed Prefix callback\n"));
		info.bt_prefix = btree_prefix ;
		db->prefix = newSVsv(sv) ;
	    }

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, 
                DB_BTREE, flags, mode, &info, enc_passwd, enc_flags, hash) ;
	}
#line 5493 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Btree_db_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Btree_db_stat)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;
#line 3984 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5512 "BerkeleyDB.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 3986 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5532 "BerkeleyDB.c"
#line 3988 "BerkeleyDB.xs"
	{
	    DB_BTREE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status) {
	        XSRETURN_UNDEF;
	    } else {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "bt_magic", stat->bt_magic);
		hv_store_iv(RETVAL, "bt_version", stat->bt_version);
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "bt_metaflags", stat->bt_metaflags) ;
		hv_store_iv(RETVAL, "bt_flags", stat->bt_metaflags) ;
#else
		hv_store_iv(RETVAL, "bt_flags", stat->bt_flags) ;
#endif
#ifndef AT_LEAST_DB_4_4
		hv_store_iv(RETVAL, "bt_maxkey", stat->bt_maxkey) ;
#endif
		hv_store_iv(RETVAL, "bt_minkey", stat->bt_minkey);
		hv_store_iv(RETVAL, "bt_re_len", stat->bt_re_len);
		hv_store_iv(RETVAL, "bt_re_pad", stat->bt_re_pad);
		hv_store_iv(RETVAL, "bt_pagesize", stat->bt_pagesize);
		hv_store_iv(RETVAL, "bt_levels", stat->bt_levels);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "bt_nkeys", stat->bt_nkeys);
		hv_store_iv(RETVAL, "bt_ndata", stat->bt_ndata);
#else
		hv_store_iv(RETVAL, "bt_nrecs", stat->bt_nrecs);
#endif
		hv_store_iv(RETVAL, "bt_int_pg", stat->bt_int_pg);
		hv_store_iv(RETVAL, "bt_leaf_pg", stat->bt_leaf_pg);
		hv_store_iv(RETVAL, "bt_dup_pg", stat->bt_dup_pg);
		hv_store_iv(RETVAL, "bt_over_pg", stat->bt_over_pg);
		hv_store_iv(RETVAL, "bt_free", stat->bt_free);
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
		hv_store_iv(RETVAL, "bt_freed", stat->bt_freed);
		hv_store_iv(RETVAL, "bt_pfxsaved", stat->bt_pfxsaved);
		hv_store_iv(RETVAL, "bt_split", stat->bt_split);
		hv_store_iv(RETVAL, "bt_rootsplit", stat->bt_rootsplit);
		hv_store_iv(RETVAL, "bt_fastsplit", stat->bt_fastsplit);
		hv_store_iv(RETVAL, "bt_added", stat->bt_added);
		hv_store_iv(RETVAL, "bt_deleted", stat->bt_deleted);
		hv_store_iv(RETVAL, "bt_get", stat->bt_get);
		hv_store_iv(RETVAL, "bt_cache_hit", stat->bt_cache_hit);
		hv_store_iv(RETVAL, "bt_cache_miss", stat->bt_cache_miss);
#endif
		hv_store_iv(RETVAL, "bt_int_pgfree", stat->bt_int_pgfree);
		hv_store_iv(RETVAL, "bt_leaf_pgfree", stat->bt_leaf_pgfree);
		hv_store_iv(RETVAL, "bt_dup_pgfree", stat->bt_dup_pgfree);
		hv_store_iv(RETVAL, "bt_over_pgfree", stat->bt_over_pgfree);
		safefree(stat) ;
	    }
	}
#line 5595 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Heap__db_open_heap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Heap__db_open_heap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
#line 4059 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5620 "BerkeleyDB.c"
	BerkeleyDB__Heap__Raw	RETVAL;
	dXSTARG;
#line 4061 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_5_2
            softCrash("BerkeleyDB::Heap needs Berkeley DB 5.2.x or better");
#else
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB  	db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    Trace(("In _db_open_btree\n"));
	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Filename", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.flags, "Property") ;
	    SetValue_iv(info.heapsize_bytes, "HeapSize") ;
	    SetValue_iv(info.heapsize_gbytes, "HeapSizeGb") ;
#ifdef AT_LEAST_DB_6_0
	    SetValue_iv(info.blob_threshold, "BlobThreshold") ;
	    SetValue_pv(info.blob_dir, "BlobDir", char*) ;
#endif
	    ZMALLOC(db, BerkeleyDB_type) ;
	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, 
                DB_HEAP, flags, mode, &info, enc_passwd, enc_flags, hash) ;
#endif
	}
#line 5670 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Recno__db_open_recno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Recno__db_open_recno)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
#line 4119 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5690 "BerkeleyDB.c"
	BerkeleyDB__Recno__Raw	RETVAL;
	dXSTARG;
#line 4121 "BerkeleyDB.xs"
	{
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Fname", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;

	    SetValue_iv(info.flags, "Property") ;
	    SetValue_pv(info.re_source, "Source", char*) ;
	    if ((sv = readHash(hash, "Len")) && sv != &PL_sv_undef) {
		info.re_len = SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_FIXEDLEN) ;
	    }
	    if ((sv = readHash(hash, "Delim")) && sv != &PL_sv_undef) {
		info.re_delim = SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_DELIMITER) ;
	    }
	    if ((sv = readHash(hash, "Pad")) && sv != &PL_sv_undef) {
		info.re_pad = (u_int32_t)SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_PAD) ;
	    }
	    ZMALLOC(db, BerkeleyDB_type) ;
#ifdef ALLOW_RECNO_OFFSET
	    SetValue_iv(db->array_base, "ArrayBase") ;
	    db->array_base = (db->array_base == 0 ? 1 : 0) ;
#endif /* ALLOW_RECNO_OFFSET */

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, 
                    DB_RECNO, flags, mode, &info, enc_passwd, enc_flags, hash) ;
	}
#line 5749 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Queue__db_open_queue); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Queue__db_open_queue)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ref");
    {
	char *	self = (char *)SvPV_nolen(ST(0))
;
	SV *	ref = ST(1)
;
#line 4187 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5769 "BerkeleyDB.c"
	BerkeleyDB__Queue__Raw	RETVAL;
	dXSTARG;
#line 4189 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3
            softCrash("BerkeleyDB::Queue needs Berkeley DB 3.0.x or better");
#else
	    HV *		hash ;
	    SV * 		sv ;
	    DB_INFO 		info ;
	    BerkeleyDB__Env	dbenv = NULL;
	    SV *		ref_dbenv = NULL;
	    const char *	file = NULL ;
	    const char *	subname = NULL ;
	    int			flags = 0 ;
	    int			mode = 0 ;
    	    BerkeleyDB 		db ;
    	    BerkeleyDB__Txn 	txn = NULL ;
	    char *	enc_passwd = NULL ;
	    int		enc_flags = 0 ;

	    hash = (HV*) SvRV(ref) ;
	    SetValue_pv(file, "Fname", char*) ;
	    SetValue_pv(subname, "Subname", char *) ;
	    SetValue_ov(dbenv, "Env", BerkeleyDB__Env) ;
	    ref_dbenv = sv ;
	    SetValue_ov(txn, "Txn", BerkeleyDB__Txn) ;
	    SetValue_iv(flags, "Flags") ;
	    SetValue_iv(mode, "Mode") ;
	    SetValue_pv(enc_passwd,"Enc_Passwd", char *) ;
	    SetValue_iv(enc_flags, "Enc_Flags") ;

       	    Zero(&info, 1, DB_INFO) ;
	    SetValue_iv(info.db_cachesize, "Cachesize") ;
	    SetValue_iv(info.db_lorder, "Lorder") ;
	    SetValue_iv(info.db_pagesize, "Pagesize") ;
	    SetValue_iv(info.bt_minkey, "Minkey") ;
    	    SetValue_iv(info.q_extentsize, "ExtentSize") ;


	    SetValue_iv(info.flags, "Property") ;
	    if ((sv = readHash(hash, "Len")) && sv != &PL_sv_undef) {
		info.re_len = SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_FIXEDLEN) ;
	    }
	    if ((sv = readHash(hash, "Pad")) && sv != &PL_sv_undef) {
		info.re_pad = (u_int32_t)SvPOK(sv) ? *SvPV(sv,PL_na) : SvIV(sv) ; ;
		flagSet_DB2(info.flags, DB_PAD) ;
	    }
	    ZMALLOC(db, BerkeleyDB_type) ;
#ifdef ALLOW_RECNO_OFFSET
	    SetValue_iv(db->array_base, "ArrayBase") ;
	    db->array_base = (db->array_base == 0 ? 1 : 0) ;
#endif /* ALLOW_RECNO_OFFSET */

	    RETVAL = my_db_open(db, ref, ref_dbenv, dbenv, txn, file, subname, 
                DB_QUEUE, flags, mode, &info, enc_passwd, enc_flags, hash) ;
#endif
	}
#line 5829 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Queue_db_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Queue_db_stat)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	int	flags;
	BerkeleyDB__Common	db;
	HV *	RETVAL = NULL ;
#line 4254 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5848 "BerkeleyDB.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4256 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 5868 "BerkeleyDB.c"
#line 4258 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2
	    softCrash("$db->db_stat for a Queue needs Berkeley DB 3.x or better") ;
#else /* Berkeley DB 3, or better */
	    DB_QUEUE_STAT *	stat ;
#ifdef AT_LEAST_DB_4_3
	    db->Status = ((db->dbp)->stat)(db->dbp, db->txn, &stat, flags) ;
#else        
#ifdef AT_LEAST_DB_3_3
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, flags) ;
#else
	    db->Status = ((db->dbp)->stat)(db->dbp, &stat, safemalloc, flags) ;
#endif
#endif
	    if (db->Status) {
	        XSRETURN_UNDEF;
	    } else {
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "qs_magic", stat->qs_magic) ;
		hv_store_iv(RETVAL, "qs_version", stat->qs_version);
#ifdef AT_LEAST_DB_3_1
		hv_store_iv(RETVAL, "qs_nkeys", stat->qs_nkeys);
		hv_store_iv(RETVAL, "qs_ndata", stat->qs_ndata);
#else
		hv_store_iv(RETVAL, "qs_nrecs", stat->qs_nrecs);
#endif
		hv_store_iv(RETVAL, "qs_pages", stat->qs_pages);
		hv_store_iv(RETVAL, "qs_pagesize", stat->qs_pagesize);
		hv_store_iv(RETVAL, "qs_pgfree", stat->qs_pgfree);
		hv_store_iv(RETVAL, "qs_re_len", stat->qs_re_len);
		hv_store_iv(RETVAL, "qs_re_pad", stat->qs_re_pad);
#ifdef AT_LEAST_DB_3_2
#else
		hv_store_iv(RETVAL, "qs_start", stat->qs_start);
#endif
		hv_store_iv(RETVAL, "qs_first_recno", stat->qs_first_recno);
		hv_store_iv(RETVAL, "qs_cur_recno", stat->qs_cur_recno);
#if DB_VERSION_MAJOR >= 3
		hv_store_iv(RETVAL, "qs_metaflags", stat->qs_metaflags);
#endif
		safefree(stat) ;
	    }
#endif
	}
#line 5914 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_db_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	int	flags;
	BerkeleyDB__Common	db;
#line 4313 "BerkeleyDB.xs"
	  dMY_CXT;
#line 5937 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4315 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
	    saveCurrentDB(db) ;
#line 5959 "BerkeleyDB.c"
#line 4318 "BerkeleyDB.xs"
	    Trace(("BerkeleyDB::Common::db_close %p\n", db));
#ifdef STRICT_CLOSE
	    if (db->txn)
		softCrash("attempted to close a database while a transaction was still open") ;
	    if (db->open_cursors)
		softCrash("attempted to close a database with %d open cursor(s)",
				db->open_cursors) ;
#ifdef AT_LEAST_DB_4_3
	    if (db->open_sequences)
		softCrash("attempted to close a database with %d open sequence(s)",
				db->open_sequences) ;
#endif /* AT_LEAST_DB_4_3 */
#endif /* STRICT_CLOSE */
	    RETVAL =  db->Status = ((db->dbp)->close)(db->dbp, flags) ;
	    if (db->parent_env && db->parent_env->open_dbs)
		-- db->parent_env->open_dbs ;
	    db->active = FALSE ;
	    hash_delete("BerkeleyDB::Term::Db", (char *)db) ;
	    -- db->open_cursors ;
	    Trace(("end of BerkeleyDB::Common::db_close\n"));
#line 5981 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4345 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6003 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4347 "BerkeleyDB.xs"
	  saveCurrentDB(db) ;
	  Trace(("In BerkeleyDB::Common::_DESTROY db %p dirty=%d\n", db, PL_dirty)) ;
	  destroyDB(db) ;
	  Trace(("End of BerkeleyDB::Common::DESTROY \n")) ;
#line 6019 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}

#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 6
#define db_cursor(db, txn, cur,flags)  ((db->dbp)->cursor)(db->dbp, txn, cur)
#else
#define db_cursor(db, txn, cur,flags)  ((db->dbp)->cursor)(db->dbp, txn, cur,flags)
#endif

XS_EUPXS(XS_BerkeleyDB__Common__db_cursor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common__db_cursor)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	BerkeleyDB__Cursor	RETVAL = NULL ;
#line 4363 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6043 "BerkeleyDB.c"
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4366 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6064 "BerkeleyDB.c"
#line 4368 "BerkeleyDB.xs"
	{
	  DBC *	cursor ;
	  saveCurrentDB(db) ;
	  if (ix == 1 && db->cds_enabled) {
#ifdef AT_LEAST_DB_3
	      flags |= DB_WRITECURSOR;
#else	      
	      flags |= DB_RMW;
#endif	      
	  }
	  if ((db->Status = db_cursor(db, db->txn, &cursor, flags)) == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->open_cursors ++ ;
	      RETVAL->parent_db  = db ;
	      RETVAL->cursor  = cursor ;
	      RETVAL->dbp     = db->dbp ;
	      RETVAL->txn     = db->txn ;
              RETVAL->type    = db->type ;
              RETVAL->recno_or_queue    = db->recno_or_queue ;
              RETVAL->cds_enabled    = db->cds_enabled ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
	      RETVAL->secondary_db  = db->secondary_db;
              RETVAL->primary_recno_or_queue = db->primary_recno_or_queue ;
#endif
#ifdef AT_LEAST_DB_4_8
              RETVAL->associated_foreign = db->associated_foreign ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
	}
#line 6117 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common__db_join); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common__db_join)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "db, cursors, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	AV *	cursors;
	BerkeleyDB__Cursor	RETVAL = NULL ;
#line 4429 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6137 "BerkeleyDB.c"
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1))) == SVt_PVAV)
        /* if (sv_isa(ST(1), "AVPtr")) */
            cursors = (AV*)SvRV(ST(1));
        else
            croak("cursors is not an array reference")
;
#line 4431 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6165 "BerkeleyDB.c"
#line 4433 "BerkeleyDB.xs"
	{
#if DB_VERSION_MAJOR == 2 && (DB_VERSION_MINOR < 5 || (DB_VERSION_MINOR == 5 && DB_VERSION_PATCH < 2))
	    softCrash("join needs Berkeley DB 2.5.2 or later") ;
#else /* Berkeley DB >= 2.5.2 */
	  DBC *		join_cursor ;
	  DBC **	cursor_list ;
	  I32		count = av_len(cursors) + 1 ;
	  int		i ;
	  saveCurrentDB(db) ;
	  if (count < 1 )
	      softCrash("db_join: No cursors in parameter list") ;
	  cursor_list = (DBC **)safemalloc(sizeof(DBC*) * (count + 1));
	  for (i = 0 ; i < count ; ++i) {
	      SV * obj = (SV*) * av_fetch(cursors, i, FALSE) ;
	      IV tmp = SvIV(getInnerObject(obj)) ;
	      BerkeleyDB__Cursor cur = INT2PTR(BerkeleyDB__Cursor, tmp);
	      if (cur->dbp == db->dbp)
	          softCrash("attempted to do a self-join");
	      cursor_list[i] = cur->cursor ;
	  }
	  cursor_list[i] = NULL ;
#if DB_VERSION_MAJOR == 2
	  if ((db->Status = ((db->dbp)->join)(db->dbp, cursor_list, flags, &join_cursor)) == 0){
#else
	  if ((db->Status = ((db->dbp)->join)(db->dbp, cursor_list, &join_cursor, flags)) == 0){
#endif
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->open_cursors ++ ;
	      RETVAL->parent_db  = db ;
	      RETVAL->cursor  = join_cursor ;
	      RETVAL->dbp     = db->dbp ;
              RETVAL->type    = db->type ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
	      RETVAL->secondary_db  = db->secondary_db;
              RETVAL->primary_recno_or_queue = db->primary_recno_or_queue ;
#endif
#ifdef AT_LEAST_DB_4_8
              RETVAL->associated_foreign = db->associated_foreign ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
	  safefree(cursor_list) ;
#endif /* Berkeley DB >= 2.5.2 */
	}
#line 6232 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_ArrayOffset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_ArrayOffset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4505 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6249 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4507 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6264 "BerkeleyDB.c"
#line 4509 "BerkeleyDB.xs"
#ifdef ALLOW_RECNO_OFFSET
	    RETVAL = db->array_base ? 0 : 1 ;
#else
	    RETVAL = 0 ;
#endif /* ALLOW_RECNO_OFFSET */
#line 6271 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_cds_enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_cds_enabled)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4522 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6288 "BerkeleyDB.c"
	bool	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4524 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6302 "BerkeleyDB.c"
#line 4526 "BerkeleyDB.xs"
	    RETVAL = db->cds_enabled ;
#line 6305 "BerkeleyDB.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_stat_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_stat_print)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	BerkeleyDB__Common	db;
	u_int32_t	flags;
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 4536 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 6342 "BerkeleyDB.c"
#line 4538 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
		softCrash("$db->stat_print needs Berkeley DB 4.3 or better") ;
#else
		RETVAL = db->dbp->stat_print(db->dbp, flags);
#endif
#line 6349 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4551 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6366 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4553 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6381 "BerkeleyDB.c"
#line 4555 "BerkeleyDB.xs"
	    RETVAL = db->type ;
#line 6384 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_byteswapped); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_byteswapped)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4563 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6401 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4565 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6416 "BerkeleyDB.c"
#line 4567 "BerkeleyDB.xs"
#if DB_VERSION_MAJOR == 2 && DB_VERSION_MINOR < 5
	    softCrash("byteswapped needs Berkeley DB 2.5 or later") ;
#else
#if DB_VERSION_MAJOR == 2
	    RETVAL = db->dbp->byteswapped ;
#else
#ifdef AT_LEAST_DB_3_3
	    db->dbp->get_byteswapped(db->dbp, &RETVAL) ;
#else
	    RETVAL = db->dbp->get_byteswapped(db->dbp) ;
#endif
#endif
#endif
#line 6431 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4587 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6448 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4589 "BerkeleyDB.xs"
	    RETVAL =  db->Status ;
#line 6462 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef DBM_FILTERING
#define setFilter(ftype)				\
	{						\
	    if (db->ftype)				\
	        RETVAL = sv_mortalcopy(db->ftype) ;	\
	    ST(0) = RETVAL ;				\
	    if (db->ftype && (code == &PL_sv_undef)) {	\
                SvREFCNT_dec(db->ftype) ;		\
	        db->ftype = NULL ;			\
	    }						\
	    else if (code) {				\
	        if (db->ftype)				\
	            sv_setsv(db->ftype, code) ;		\
	        else					\
	            db->ftype = newSVsv(code) ;		\
	    }	    					\
	}
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_BerkeleyDB__Common_filter_fetch_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_filter_fetch_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, code");
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1)
;
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4619 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_fetch_key, code) ;
#line 6516 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_filter_store_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_filter_store_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, code");
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1)
;
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4627 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_store_key, code) ;
#line 6545 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_filter_fetch_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_filter_fetch_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, code");
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1)
;
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4635 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_fetch_value, code) ;
#line 6574 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_filter_store_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_filter_store_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, code");
    {
	BerkeleyDB__Common	db;
	SV *	code = ST(1)
;
	SV *	RETVAL = &PL_sv_undef ;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4643 "BerkeleyDB.xs"
	    DBM_setFilter(db->filter_store_value, code) ;
#line 6603 "BerkeleyDB.c"
    }
    XSRETURN(1);
}

#endif /* DBM_FILTERING */

XS_EUPXS(XS_BerkeleyDB__Common_partial_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_partial_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "db, offset, length");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Common	db;
	u_int32_t        offset = SvUV(ST(1))
;
	u_int32_t        length = SvUV(ST(2))
;
#line 4653 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6626 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4655 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6639 "BerkeleyDB.c"
#line 4657 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial = DB_DBT_PARTIAL ;
	    db->doff    = offset ;
	    db->dlen    = length ;
#line 6649 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BerkeleyDB__Common_partial_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_partial_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Common	db;
#line 4671 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6668 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4673 "BerkeleyDB.xs"
	    ckActive_Database(db->active) ;
#line 6681 "BerkeleyDB.c"
#line 4675 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial =
	    db->doff    =
	    db->dlen    = 0 ;
#line 6691 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}

#define db_del(db, key, flags)  \
	(db->Status = ((db->dbp)->del)(db->dbp, db->txn, &key, flags))

XS_EUPXS(XS_BerkeleyDB__Common_db_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_del)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "db, key, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY	key;
#line 4693 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6712 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (! isHeapDb(db))
	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
	        key.size = (int)len;
	    }
	}
	else
	{
            SvGETMAGIC(ST(1)) ;
                SvUPGRADE(ST(1), SVt_PV); SvOOK_off(ST(1)); SvPOK_only(ST(1));
                /* SvPOK_only(ST(1)); */
                SvGROW(ST(1), DB_HEAP_RID_SZ);
	    DBT_clear(key) ;
	        key.data = SvPVX(ST(1));
	        key.size = DB_HEAP_RID_SZ;
	}
;
#line 4695 "BerkeleyDB.xs"
	    Trace(("db_del db[%p] in [%p] txn[%p] key[%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, (char*)key.data, flags)) ;
	    ckActive_Database(db->active) ;
	    saveCurrentDB(db) ;
#line 6764 "BerkeleyDB.c"

	RETVAL = db_del(db, key, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_3
#  ifdef AT_LEAST_DB_3_2
#    define writeToKey() (flagSet(DB_CONSUME)||flagSet(DB_CONSUME_WAIT)||flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#  else
#    define writeToKey() (flagSet(DB_CONSUME)||flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#  endif
#else
#define writeToKey() (flagSet(DB_GET_BOTH)||flagSet(DB_SET_RECNO))
#endif
#define db_get(db, key, data, flags)   \
	(db->Status = ((db->dbp)->get)(db->dbp, db->txn, &key, &data, flags))

XS_EUPXS(XS_BerkeleyDB__Common_db_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_get)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, key, data, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	DBT_OPT	data;
#line 4718 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6802 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;

	DBT_clear(data) ;
	if (flagSetBoth()) {
	   SV* my_sv = ST(2) ;
       STRLEN len;
	   DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
           SvGETMAGIC(ST(2)) ;
	   data.data = SvPV(my_sv, len);
	   data.size = (int)len;
  	   data.flags = db->partial ;
    	   data.dlen  = db->dlen ;
	   data.doff  = db->doff ;
	}
;
#line 4720 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  SetPartial(data,db) ;
	  Trace(("db_get db[%p] in [%p] txn[%p] key [%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, (char*)key.data, flags)) ;
	  RETVAL = db_get(db, key, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#line 6862 "BerkeleyDB.c"
	if (writeToKey()) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	OutputValue(ST(2), data)
	SvSETMAGIC(ST(2));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_exists(db, key, flags)   \
	(db->Status = ((db->dbp)->exists)(db->dbp, db->txn, &key, flags))

XS_EUPXS(XS_BerkeleyDB__Common_db_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_exists)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "db, key, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
#line 4739 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6892 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;
#line 4741 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_6
          softCrash("db_exists needs at least Berkeley DB 4.6");
#else
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  Trace(("db_exists db[%p] in [%p] txn[%p] key [%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, (char*)key.data, flags)) ;
	  RETVAL = db_exists(db, key, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#endif
#line 6941 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_pget(db, key, pkey, data, flags)   \
	(db->Status = ((db->dbp)->pget)(db->dbp, db->txn, &key, &pkey, &data, flags))

XS_EUPXS(XS_BerkeleyDB__Common_db_pget); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_pget)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "db, key, pkey, data, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	DBTKEY_Bpr	pkey;
	DBT_OPT	data;
#line 4764 "BerkeleyDB.xs"
	  dMY_CXT;
#line 6969 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 5)
	    flags = 0;
	else {
	flags = SvUV(ST(4))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;

	{
      if(flagSet(DB_GET_BOTH))
      {
	    SV* my_sv = ST(2) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(pkey) ;
            SvGETMAGIC(ST(2)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        pkey.data = & Value;
	        pkey.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        pkey.data = SvPV(my_sv, len);
	        pkey.size = (int)len;
	    }
      }
      else
      {
       DBT_clear(pkey) ;
      }
	}
;

	DBT_clear(data) ;
	if (flagSetBoth()) {
	   SV* my_sv = ST(3) ;
       STRLEN len;
	   DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
           SvGETMAGIC(ST(3)) ;
	   data.data = SvPV(my_sv, len);
	   data.size = (int)len;
  	   data.flags = db->partial ;
    	   data.dlen  = db->dlen ;
	   data.doff  = db->doff ;
	}
;
#line 4766 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("db_pget needs at least Berkeley DB 3.3");
#else
	  Trace(("db_pget db [%p] in [%p] txn [%p] flags [%d]\n", db->dbp, db, db->txn, flags)) ;
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  SetPartial(data,db) ;
	  RETVAL = db_pget(db, key, pkey, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#endif
#line 7059 "BerkeleyDB.c"
	if (writeToKey()) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	OutputKey_Bpr(ST(2), pkey)
	SvSETMAGIC(ST(2));
	OutputValue(ST(3), data)
	SvSETMAGIC(ST(3));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_put(db,key,data,flag)	\
		(db->Status = (db->dbp->put)(db->dbp,db->txn,&key,&data,flag))

XS_EUPXS(XS_BerkeleyDB__Common_db_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_put)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, key, data, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
	DBTKEY	key;
	DBT	data;
#line 4791 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7092 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (! isHeapDb(db))
	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
	        key.size = (int)len;
	    }
	}
	else
	{
            SvGETMAGIC(ST(1)) ;
                SvUPGRADE(ST(1), SVt_PV); SvOOK_off(ST(1)); SvPOK_only(ST(1));
                /* SvPOK_only(ST(1)); */
                SvGROW(ST(1), DB_HEAP_RID_SZ);
	    DBT_clear(key) ;
	        key.data = SvPVX(ST(1));
	        key.size = DB_HEAP_RID_SZ;
	}
;

	{
	    SV* my_sv = ST(2) ;
        STRLEN len;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
	    DBT_clear(data) ;
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, len);
	    data.size = (int)len;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	}
;
#line 4793 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  /* SetPartial(data,db) ; */
	  Trace(("db_put db[%p] in [%p] txn[%p] key[%.*s] data [%.*s] flags[%d]\n", db->dbp, db, db->txn, key.size, (char*)key.data, data.size, (char*)data.data, flags)) ;
	  RETVAL = db_put(db, key, data, flags);
	  Trace(("  RETVAL %d\n", RETVAL));
#line 7161 "BerkeleyDB.c"
	if (flagSet(DB_APPEND)) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_key_range(db, key, range, flags)   \
	(db->Status = ((db->dbp)->key_range)(db->dbp, db->txn, &key, &range, flags))

XS_EUPXS(XS_BerkeleyDB__Common_db_key_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_key_range)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "db, key, less, equal, greater, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Common	db;
	DBTKEY_B	key;
	double	less = 0.0 ;
	double	equal = 0.0 ;
	double	greater = 0.0 ;
#line 4814 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7192 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 6)
	    flags = 0;
	else {
	flags = SvUV(ST(5))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;
#line 4816 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3_1
          softCrash("key_range needs Berkeley DB 3.1.x or later") ;
#else
          DB_KEY_RANGE range ;
          range.less = range.equal = range.greater = 0.0 ;
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
	  RETVAL = db_key_range(db, key, range, flags);
	  if (RETVAL == 0) {
	        less = range.less ;
	        equal = range.equal;
	        greater = range.greater;
	  }
#endif
	}
#line 7248 "BerkeleyDB.c"
	sv_setnv(ST(2), (double)less);
	SvSETMAGIC(ST(2));
	sv_setnv(ST(3), (double)equal);
	SvSETMAGIC(ST(3));
	sv_setnv(ST(4), (double)greater);
	SvSETMAGIC(ST(4));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_fd(d, x)	(db->Status = (db->dbp->fd)(db->dbp, &x))

XS_EUPXS(XS_BerkeleyDB__Common_db_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_fd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 4844 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7277 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4846 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 7292 "BerkeleyDB.c"
#line 4848 "BerkeleyDB.xs"
	  saveCurrentDB(db) ;
	  db_fd(db, RETVAL) ;
#line 7296 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#define db_sync(db, fl)	(db->Status = (db->dbp->sync)(db->dbp, fl))

XS_EUPXS(XS_BerkeleyDB__Common_db_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_sync)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	u_int	flags;
	BerkeleyDB__Common	db;
#line 4860 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7315 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 4862 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
	  saveCurrentDB(db) ;
#line 7337 "BerkeleyDB.c"

	RETVAL = db_sync(db, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common__Txn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common__Txn)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, txn=NULL");
    {
	BerkeleyDB__Common	db;
	BerkeleyDB__Txn	txn;
#line 4870 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7362 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (items < 2)
	    txn = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    txn = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    txn = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("txn is not of type BerkeleyDB::Txn")
;
	}
#line 4872 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 7389 "BerkeleyDB.c"
#line 4874 "BerkeleyDB.xs"
	   if (txn) {
	       Trace(("_Txn[%p] in[%p] active [%d]\n", txn->txn, txn, txn->active));
	       ckActive_Transaction(txn->active) ;
	       db->txn = txn->txn ;
	   }
	   else {
	       Trace(("_Txn[undef] \n"));
	       db->txn = NULL ;
	   }
#line 7400 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}

#define db_truncate(db, countp, flags)  \
	(db->Status = ((db->dbp)->truncate)(db->dbp, db->txn, &countp, flags))

XS_EUPXS(XS_BerkeleyDB__Common_truncate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_truncate)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "db, countp, flags=0");
    {
	BerkeleyDB__Common	db;
	u_int32_t	countp;
	u_int32_t	flags;
#line 4893 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7420 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 4895 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 7441 "BerkeleyDB.c"
#line 4897 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("truncate needs Berkeley DB 3.3 or later") ;
#else
	  saveCurrentDB(db) ;
	  RETVAL = db_truncate(db, countp, flags);
#endif
#line 7449 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)countp);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4_1
#  define db_associate(db, sec, cb, flags)\
	(db->Status = ((db->dbp)->associate)(db->dbp, db->txn, sec->dbp, &cb, flags))
#else
#  define db_associate(db, sec, cb, flags)\
	(db->Status = ((db->dbp)->associate)(db->dbp, sec->dbp, &cb, flags))
#endif

XS_EUPXS(XS_BerkeleyDB__Common_associate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_associate)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, secondary, callback, flags=0");
    {
	BerkeleyDB__Common	db;
	BerkeleyDB__Common	secondary;
	SV*	callback = ST(2)
;
	u_int32_t	flags;
#line 4921 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7484 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

        if (ST(1) == &PL_sv_undef || ST(1) == NULL)
            secondary = NULL ;
        else if (sv_derived_from(ST(1), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(1))) ;
            secondary = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("secondary is not of type BerkeleyDB::Common")
;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}
#line 4923 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 7515 "BerkeleyDB.c"
#line 4925 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("associate needs Berkeley DB 3.3 or later") ;
#else
	  saveCurrentDB(db) ;
	  /* db->associated = newSVsv(callback) ; */
	  secondary->associated = newSVsv(callback) ;
	  secondary->primary_recno_or_queue = db->recno_or_queue ;
	  /* secondary->dbp->app_private = secondary->associated ; */
	  secondary->secondary_db = TRUE;
      if (secondary->recno_or_queue)
          RETVAL = db_associate(db, secondary, associate_cb_recno, flags);
      else
          RETVAL = db_associate(db, secondary, associate_cb, flags);
#endif
#line 7531 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define db_associate_foreign(db, sec, cb, flags)\
	(db->Status = ((db->dbp)->associate_foreign)(db->dbp, sec->dbp, cb, flags))

XS_EUPXS(XS_BerkeleyDB__Common_associate_foreign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_associate_foreign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "db, secondary, callback, flags");
    {
	BerkeleyDB__Common	db;
	BerkeleyDB__Common	secondary;
	SV*	callback = ST(2)
;
	u_int32_t        flags = SvUV(ST(3))
;
	foreign_cb_type	callback_ptr = NULL;
#line 4952 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7561 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

        if (ST(1) == &PL_sv_undef || ST(1) == NULL)
            secondary = NULL ;
        else if (sv_derived_from(ST(1), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(1))) ;
            secondary = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("secondary is not of type BerkeleyDB::Common")
;
#line 4954 "BerkeleyDB.xs"
	  ckActive_Database(db->active) ;
#line 7585 "BerkeleyDB.c"
#line 4956 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_8
          softCrash("associate_foreign needs Berkeley DB 4.8 or later") ;
#else
	  saveCurrentDB(db) ;
	  if (callback != &PL_sv_undef)
	  {
          //softCrash("associate_foreign does not support callbacks yet") ;
          secondary->associated_foreign = newSVsv(callback) ;
          callback_ptr = ( secondary->recno_or_queue 
                                ? associate_foreign_cb_recno 
                                : associate_foreign_cb);
	  }
	  secondary->primary_recno_or_queue = db->recno_or_queue ;
	  secondary->secondary_db = TRUE;
      RETVAL = db_associate_foreign(db, secondary, callback_ptr, flags);
#endif
#line 7603 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_compact); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_compact)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 6)
       croak_xs_usage(cv,  "db, start=NULL, stop=NULL, c_data=NULL, flags=0, end=NULL");
    {
#line 4978 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7624 "BerkeleyDB.c"
#line 4980 "BerkeleyDB.xs"
        DBTKEY	    end_key;
#line 7627 "BerkeleyDB.c"
	BerkeleyDB__Common	db;
	SVnull*	start;
	SVnull*	stop;
	SVnull*	c_data;
	u_int32_t	flags;
	SVnull*	end;
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (items < 2)
	    start = NULL;
	else {
	    if (ST(1) == NULL || ST(1) == &PL_sv_undef)
		start = NULL ;
	    else
		start = ST(1)
;
	}

	if (items < 3)
	    stop = NULL;
	else {
	    if (ST(2) == NULL || ST(2) == &PL_sv_undef)
		stop = NULL ;
	    else
		stop = ST(2)
;
	}

	if (items < 4)
	    c_data = NULL;
	else {
	    if (ST(3) == NULL || ST(3) == &PL_sv_undef)
		c_data = NULL ;
	    else
		c_data = ST(3)
;
	}

	if (items < 5)
	    flags = 0;
	else {
	flags = SvUV(ST(4))
;
	}

	if (items < 6)
	    end = NULL;
	else {
	    if (ST(5) == NULL || ST(5) == &PL_sv_undef)
		end = NULL ;
	    else
		end = ST(5)
;
	}
#line 4989 "BerkeleyDB.xs"
    {
#ifndef AT_LEAST_DB_4_4
          softCrash("compact needs Berkeley DB 4.4 or later") ;
#else
        DBTKEY	    start_key;
        DBTKEY	    stop_key;
        DBTKEY*	    start_p = NULL;
        DBTKEY*	    stop_p = NULL;
        DBTKEY*	    end_p = NULL;
	    DB_COMPACT cmpt;
	    DB_COMPACT* cmpt_p = NULL;
	    SV * sv;
        HV* hash = NULL;

        DBT_clear(start_key);
        DBT_clear(stop_key);
        DBT_clear(end_key);
        Zero(&cmpt, 1, DB_COMPACT) ;
        ckActive_Database(db->active) ;
        saveCurrentDB(db) ;
        if (start && SvOK(start)) {
            start_p = &start_key;
            DBM_ckFilter(start, filter_store_key, "filter_store_key");
            GetKey(db, start, start_p);
        }
        if (stop && SvOK(stop)) {
            stop_p = &stop_key;
            DBM_ckFilter(stop, filter_store_key, "filter_store_key");
            GetKey(db, stop, stop_p);
        }
        if (end) {
            end_p = &end_key;
        }
        if (c_data && SvOK(c_data)) {
            hash = (HV*) SvRV(c_data) ;
            cmpt_p = & cmpt;
            cmpt.compact_fillpercent = GetValue_iv(hash,"compact_fillpercent") ;
            cmpt.compact_timeout = (db_timeout_t) GetValue_iv(hash, "compact_timeout"); 
        }
        RETVAL = (db->dbp)->compact(db->dbp, db->txn, start_p, stop_p, cmpt_p, flags, end_p);
        if (RETVAL == 0 && hash) {
            hv_store_iv(hash, "compact_deadlock", cmpt.compact_deadlock) ;
            hv_store_iv(hash, "compact_levels",   cmpt.compact_levels) ;
            hv_store_iv(hash, "compact_pages_free", cmpt.compact_pages_free) ;
            hv_store_iv(hash, "compact_pages_examine", cmpt.compact_pages_examine) ;
            hv_store_iv(hash, "compact_pages_truncated", cmpt.compact_pages_truncated) ;
        }
#endif
    }
#line 7742 "BerkeleyDB.c"
	if (RETVAL == 0 && end) OutputValue_B(ST(5), end_key) ;
	SvSETMAGIC(ST(5));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_get_blob_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_get_blob_threshold)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, bytes");
    {
	BerkeleyDB__Common	db;
	u_int32_t	bytes;
#line 5048 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7767 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5050 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$db->get_blob_threshold needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = db->dbp->get_blob_threshold(db->dbp, &bytes);
#endif
#line 7785 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)bytes);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_get_blob_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_get_blob_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, dir");
    {
	BerkeleyDB__Common	db;
	char*	dir;
#line 5064 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7810 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5066 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$db->get_blob_dir needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = db->dbp->get_blob_dir(db->dbp, (const char**)&dir);
#endif
#line 7828 "BerkeleyDB.c"
	sv_setpv((SV*)ST(1), dir);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Cursor__c_dup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor__c_dup)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Cursor	db;
	BerkeleyDB__Cursor	RETVAL = NULL ;
#line 5084 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7854 "BerkeleyDB.c"
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5086 "BerkeleyDB.xs"
	    saveCurrentDB(db->parent_db);
	    ckActive_Database(db->active) ;
#line 7876 "BerkeleyDB.c"
#line 5089 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_3
          softCrash("c_dup needs at least Berkeley DB 3.0.x");
#else
	  DBC *		newcursor ;
	  db->Status = ((db->cursor)->c_dup)(db->cursor, &newcursor, flags) ;
	  if (db->Status == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__Cursor_type) ;
	      db->parent_db->open_cursors ++ ;
	      RETVAL->parent_db  = db->parent_db ;
	      RETVAL->cursor  = newcursor ;
	      RETVAL->dbp     = db->dbp ;
              RETVAL->type    = db->type ;
              RETVAL->recno_or_queue    = db->recno_or_queue ;
              RETVAL->primary_recno_or_queue    = db->primary_recno_or_queue ;
              RETVAL->cds_enabled    = db->cds_enabled ;
              RETVAL->filename    = my_strdup(db->filename) ;
              RETVAL->compare = db->compare ;
              RETVAL->dup_compare = db->dup_compare ;
#ifdef AT_LEAST_DB_3_3
              RETVAL->associated = db->associated ;
#endif
#ifdef AT_LEAST_DB_4_8
              RETVAL->associated_foreign = db->associated_foreign ;
#endif
              RETVAL->prefix  = db->prefix ;
              RETVAL->hash    = db->hash ;
	      RETVAL->partial = db->partial ;
	      RETVAL->doff    = db->doff ;
	      RETVAL->dlen    = db->dlen ;
	      RETVAL->active  = TRUE ;
#ifdef ALLOW_RECNO_OFFSET
	      RETVAL->array_base  = db->array_base ;
#endif /* ALLOW_RECNO_OFFSET */
#ifdef DBM_FILTERING
	      RETVAL->filtering   = FALSE ;
	      RETVAL->filter_fetch_key    = db->filter_fetch_key ;
	      RETVAL->filter_store_key    = db->filter_store_key ;
	      RETVAL->filter_fetch_value  = db->filter_fetch_value ;
	      RETVAL->filter_store_value  = db->filter_store_value ;
#endif /* DBM_FILTERING */
              /* RETVAL->info ; */
	      hash_store_iv("BerkeleyDB::Term::Cursor", (char *)RETVAL, 1) ;
	  }
#endif	
	}
#line 7924 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Cursor__c_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor__c_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Cursor	db;
#line 5142 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7941 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5144 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  hash_delete("BerkeleyDB::Term::Cursor", (char *)db) ;
#line 7957 "BerkeleyDB.c"
#line 5148 "BerkeleyDB.xs"
	  RETVAL =  db->Status =
    	          ((db->cursor)->c_close)(db->cursor) ;
	  db->active = FALSE ;
	  if (db->parent_db->open_cursors)
	      -- db->parent_db->open_cursors ;
#line 7964 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Cursor__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Cursor	db;
#line 5160 "BerkeleyDB.xs"
	  dMY_CXT;
#line 7986 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5162 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  Trace(("In BerkeleyDB::Cursor::_DESTROY db %p dirty=%d active=%d\n", db, PL_dirty, db->active));
	  hash_delete("BerkeleyDB::Term::Cursor", (char *)db) ;
	  if (db->active)
    	      ((db->cursor)->c_close)(db->cursor) ;
	  if (db->parent_db->open_cursors)
	      -- db->parent_db->open_cursors ;
          Safefree(db->filename) ;
          Safefree(db) ;
	  Trace(("End of BerkeleyDB::Cursor::_DESTROY\n")) ;
#line 8008 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__Cursor_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Cursor	db;
#line 5177 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8024 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5179 "BerkeleyDB.xs"
	    RETVAL =  db->Status ;
#line 8038 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define cu_c_del(c,f)	(c->Status = ((c->cursor)->c_del)(c->cursor,f))

XS_EUPXS(XS_BerkeleyDB__Cursor_c_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_c_del)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	int	flags;
	BerkeleyDB__Cursor	db;
#line 5190 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8062 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5192 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
#line 8084 "BerkeleyDB.c"

	RETVAL = cu_c_del(db, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define cu_c_get(c,k,d,f) (c->Status = (c->cursor->c_get)(c->cursor,&k,&d,f))

XS_EUPXS(XS_BerkeleyDB__Cursor_c_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_c_get)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, key, data, flags=0");
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY_B	key;
	DBT_B	data;
#line 5206 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8112 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;

	DBT_clear(data) ;
	if (flagSetBoth()) {
	    SV* my_sv = ST(2) ;
        STRLEN len;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, len);
	    data.size = (int)len;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	}
;
#line 5208 "BerkeleyDB.xs"
	  Trace(("c_get db [%p] in [%p] flags [%d]\n", db->dbp, db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  /* DBT_clear(key); */
	  /* DBT_clear(data); */
      SetPartial(data,db) ;
	  Trace(("c_get end\n")) ;
#line 8173 "BerkeleyDB.c"

	RETVAL = cu_c_get(db, key, data, flags);
	OutputKey_B(ST(1), key)
	SvSETMAGIC(ST(1));
	if (! flagSet(DB_JOIN_ITEM)) OutputValue_B(ST(2), data) ;
	SvSETMAGIC(ST(2));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define cu_c_pget(c,k,p,d,f) (c->Status = (c->secondary_db ? (c->cursor->c_pget)(c->cursor,&k,&p,&d,f) : EINVAL))

XS_EUPXS(XS_BerkeleyDB__Cursor_c_pget); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_c_pget)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "db, key, pkey, data, flags=0");
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY_B	key;
	DBTKEY_Bpr	pkey;
	DBT_B	data;
#line 5229 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8206 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(4))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	    }
	}
;

	{
      if(flagSet(DB_GET_BOTH))
      {
	    SV* my_sv = ST(2) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(pkey) ;
            SvGETMAGIC(ST(2)) ;
	    if (db->recno_or_queue ||
		    (db->type == DB_BTREE && flagSet(DB_SET_RECNO))) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        pkey.data = & Value;
	        pkey.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        pkey.data = SvPV(my_sv, len);
	        pkey.size = (int)len;
	    }
      }
      else
      {
       DBT_clear(pkey) ;
      }
	}
;

	DBT_clear(data) ;
	if (flagSetBoth()) {
	    SV* my_sv = ST(3) ;
        STRLEN len;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
            SvGETMAGIC(ST(3)) ;
	    data.data = SvPV(my_sv, len);
	    data.size = (int)len;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	}
;
#line 5231 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_3
          softCrash("db_c_pget needs at least Berkeley DB 3.3");
#else
	  Trace(("c_pget db [%p] flags [%d]\n", db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  SetPartial(data,db) ;
	  RETVAL = cu_c_pget(db, key, pkey, data, flags);
	  Trace(("c_pget end\n")) ;
#endif
#line 8296 "BerkeleyDB.c"
	if (writeToKey()) OutputKey(ST(1), key) ;
	SvSETMAGIC(ST(1));
	OutputKey_Bpr(ST(2), pkey)
	SvSETMAGIC(ST(2));
	OutputValue_B(ST(3), data)
	SvSETMAGIC(ST(3));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define cu_c_put(c,k,d,f)  (c->Status = (c->cursor->c_put)(c->cursor,&k,&d,f))

XS_EUPXS(XS_BerkeleyDB__Cursor_c_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_c_put)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, key, data, flags=0");
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	DBTKEY	key;
	DBT	data;
#line 5257 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8328 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;

	if (! isHeapDb(db))
	{
	    SV* my_sv = ST(1) ;
	    DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
	    if (db->recno_or_queue) {
	        Value = GetRecnoKey(db, SvIV(my_sv)) ;
	        key.data = & Value;
	        key.size = (int)sizeof(db_recno_t);
	    }
	    else {
            STRLEN len;
	        key.data = SvPV(my_sv, len);
	        key.size = (int)len;
	    }
	}
	else
	{
            SvGETMAGIC(ST(1)) ;
                SvUPGRADE(ST(1), SVt_PV); SvOOK_off(ST(1)); SvPOK_only(ST(1));
                /* SvPOK_only(ST(1)); */
                SvGROW(ST(1), DB_HEAP_RID_SZ);
	    DBT_clear(key) ;
	        key.data = SvPVX(ST(1));
	        key.size = DB_HEAP_RID_SZ;
	}
;

	{
	    SV* my_sv = ST(2) ;
        STRLEN len;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
	    DBT_clear(data) ;
            SvGETMAGIC(ST(2)) ;
	    data.data = SvPV(my_sv, len);
	    data.size = (int)len;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	}
;
#line 5259 "BerkeleyDB.xs"
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  /* SetPartial(data,db) ; */
#line 8394 "BerkeleyDB.c"

	RETVAL = cu_c_put(db, key, data, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#define cu_c_count(c,p,f) (c->Status = (c->cursor->c_count)(c->cursor,&p,f))

XS_EUPXS(XS_BerkeleyDB__Cursor_c_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_c_count)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "db, count, flags=0");
    {
	int	flags;
	BerkeleyDB__Cursor	db;
	u_int32_t	count;
#line 5272 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8421 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5274 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_3_1
          softCrash("c_count needs at least Berkeley DB 3.1.x");
#else
	  Trace(("c_get count [%p] flags [%d]\n", db, flags)) ;
	  saveCurrentDB(db->parent_db);
	  ckActive_Cursor(db->active) ;
	  RETVAL = cu_c_count(db, count, flags) ;
	  Trace(("    c_count got %d duplicates\n", count)) ;
#endif
#line 8450 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)count);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Cursor_partial_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_partial_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "db, offset, length");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Cursor	db;
	u_int32_t        offset = SvUV(ST(1))
;
	u_int32_t        length = SvUV(ST(2))
;
#line 5293 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8480 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5295 "BerkeleyDB.xs"
          ckActive_Cursor(db->active) ;
#line 8493 "BerkeleyDB.c"
#line 5297 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial = DB_DBT_PARTIAL ;
	    db->doff    = offset ;
	    db->dlen    = length ;
#line 8503 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BerkeleyDB__Cursor_partial_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor_partial_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	BerkeleyDB__Cursor	db;
#line 5311 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8522 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5313 "BerkeleyDB.xs"
          ckActive_Cursor(db->active) ;
#line 8535 "BerkeleyDB.c"
#line 5315 "BerkeleyDB.xs"
	    if (GIMME == G_ARRAY) {
		XPUSHs(sv_2mortal(newSViv(db->partial == DB_DBT_PARTIAL))) ;
		XPUSHs(sv_2mortal(newSViv(db->doff))) ;
		XPUSHs(sv_2mortal(newSViv(db->dlen))) ;
	    }
	    db->partial =
	    db->doff    =
	    db->dlen    = 0 ;
#line 8545 "BerkeleyDB.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_BerkeleyDB__Cursor__db_stream); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor__db_stream)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, flags");
    {
	BerkeleyDB__Cursor	db;
	u_int32_t        flags = SvUV(ST(1))
;
	BerkeleyDB__DbStream	RETVAL = NULL ;
#line 5330 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8565 "BerkeleyDB.c"
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;
#line 5332 "BerkeleyDB.xs"
	    saveCurrentDB(db->parent_db);
	    ckActive_Cursor(db->active) ;
#line 8580 "BerkeleyDB.c"
#line 5335 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_6_0
          softCrash("db_stream needs at least Berkeley DB 6.0.x");
#else
	  DB_STREAM * stream = NULL ;
	  db->Status = ((db->cursor)->db_stream)(db->cursor, &stream, flags) ;
	  if (db->Status == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__DbStream_type) ;
	      RETVAL->stream  = stream ;
	      RETVAL->active  = TRUE ;
	      hash_store_iv("BerkeleyDB::Term::DbStream", (char *)RETVAL, 1) ;
	  }
      else
      {
	      Trace(("db_stream [%s]\n", my_db_strerror(db->Status)));
      }
#endif	
	}
#line 8600 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Cursor__c_get_db_stream); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Cursor__c_get_db_stream)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "db, key, cflags, sflags");
    {
	BerkeleyDB__Cursor	db;
	DBTKEY_B4Blob	key;
	u_int32_t        cflags = SvUV(ST(2))
;
	u_int32_t        sflags = SvUV(ST(3))
;
	BerkeleyDB__DbStream	RETVAL = NULL ;
#line 5364 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8623 "BerkeleyDB.c"
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Cursor")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Cursor, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Cursor")
;

	{
	    SV* my_sv = ST(1) ;
	    if (! isHeapDb(db))
	        DBM_ckFilter(my_sv, filter_store_key, "filter_store_key");
	    DBT_clear(key) ;
            SvGETMAGIC(ST(1)) ;
            STRLEN len;
	        key.data = SvPV(my_sv, len);
            key.size = (int)len;
	}
;
#line 5366 "BerkeleyDB.xs"
	    saveCurrentDB(db->parent_db);
	    ckActive_Cursor(db->active) ;
#line 8650 "BerkeleyDB.c"
#line 5369 "BerkeleyDB.xs"
	{
#ifndef AT_LEAST_DB_6_0
          softCrash("db_stream needs at least Berkeley DB 6.0.x");
#else
	  DBT data;
	  DB_STREAM * stream = NULL ;
	  DBT_clear(data); 
      data.flags = DB_DBT_PARTIAL;
      db->Status = (db->cursor->c_get)(db->cursor, &key, &data, cflags);
	  if (db->Status == 0)
          db->Status = ((db->cursor)->db_stream)(db->cursor, &stream, sflags) ;
	  /* if (db->Status == EINVAL){
          db->Status = (db->cursor->c_get)(db->cursor,&key,&data,DB_CURRENT) ;
      } */
	  if (db->Status == 0){
	      ZMALLOC(RETVAL, BerkeleyDB__DbStream_type) ;
	      RETVAL->stream  = stream ;
	      RETVAL->active  = TRUE ;
	      hash_store_iv("BerkeleyDB::Term::DbStream", (char *)RETVAL, 1) ;
	  }
      else
      {
	      Trace(("db_stream [%s]\n", my_db_strerror(db->Status)));
      }
#endif	
	}
#line 8678 "BerkeleyDB.c"
	OutputKeyBlob(ST(1), key)
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__DbStream_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__DbStream_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dbstream");
    {
	BerkeleyDB__DbStream	dbstream;
#line 5405 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8697 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            dbstream = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::DbStream")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            dbstream = INT2PTR(BerkeleyDB__DbStream, tmp);
        }
        else
            croak("dbstream is not of type BerkeleyDB::DbStream")
;
#line 5407 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::DbStream::_DESTROY db %p active=%d\n", dbstream, dbstream->active));
	  hash_delete("BerkeleyDB::Term::DbStream", (char *)dbstream) ;
#ifdef AT_LEAST_DB_6_0
	  if (dbstream->active)
    	      ((dbstream->stream)->close)(dbstream->stream, 0) ;
          Safefree(dbstream) ;
#endif
	  Trace(("End of BerkeleyDB::DbStream::_DESTROY\n")) ;
#line 8717 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__DbStream_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__DbStream_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dbstream, flags=0");
    {
	BerkeleyDB__DbStream	dbstream;
	u_int32_t	flags;
#line 5421 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8734 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            dbstream = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::DbStream")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            dbstream = INT2PTR(BerkeleyDB__DbStream, tmp);
        }
        else
            croak("dbstream is not of type BerkeleyDB::DbStream")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 5423 "BerkeleyDB.xs"
	  ckActive_DbStream(dbstream->active) ;
#line 8755 "BerkeleyDB.c"
#line 5425 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$dbstream->close needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = (dbstream->stream->close)(dbstream->stream, flags);
        dbstream->active = FALSE;
        hash_delete("BerkeleyDB::Term::DbStream", (char *)dbstream) ;
#endif
#line 8764 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__DbStream_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__DbStream_read)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "db, data, offset, size, flags=0");
    {
	BerkeleyDB__DbStream	db;
	DBT_Blob	data;
	db_off_t        offset = SvIV(ST(2))
;
	u_int32_t        size = SvUV(ST(3))
;
	u_int32_t	flags;
#line 5444 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8792 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::DbStream")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__DbStream, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::DbStream")
;

	{
	    SV* my_sv = ST(1) ;
	    DBT_clear(data) ;
        SvGETMAGIC(ST(1)) ;
        STRLEN len;
        SvUPGRADE(ST(1), SVt_PV); SvOOK_off(ST(1)); SvPOK_only(ST(1));
	    data.data = SvPVbyte_force(my_sv, len);
        data.ulen = (int)len;
        data.flags = DB_DBT_APPMALLOC | DB_DBT_USERMEM;
	}
;

	if (items < 5)
	    flags = 0;
	else {
	flags = SvUV(ST(4))
;
	}
#line 5446 "BerkeleyDB.xs"
	  ckActive_DbStream(db->active) ;
#line 8825 "BerkeleyDB.c"
#line 5448 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$dbstream->read needs Berkeley DB 6.0 or better") ;
#else
        data.data = Sv_Grow(ST(1), size);
        data.ulen = size > data.ulen ? size : data.ulen ;
        RETVAL = (db->stream->read)(db->stream, &data, offset, size, flags);
	    Trace(("stream->read [%s]\n", my_db_strerror(db->Status)));
#endif
#line 8835 "BerkeleyDB.c"
	OutputValue(ST(1), data)
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__DbStream_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__DbStream_write)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "db, data, offset=0, flags=0");
    {
	BerkeleyDB__DbStream	db;
	DBT	data;
	db_off_t	offset;
	u_int32_t	flags;
#line 5467 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8862 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::DbStream")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__DbStream, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::DbStream")
;

	{
	    SV* my_sv = ST(1) ;
        STRLEN len;
	    DBM_ckFilter(my_sv, filter_store_value, "filter_store_value");
	    DBT_clear(data) ;
            SvGETMAGIC(ST(1)) ;
	    data.data = SvPV(my_sv, len);
	    data.size = (int)len;
  	    data.flags = db->partial ;
    	    data.dlen  = db->dlen ;
	    data.doff  = db->doff ;
	}
;

	if (items < 3)
	    offset = 0;
	else {
	offset = SvIV(ST(2))
;
	}

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}
#line 5469 "BerkeleyDB.xs"
	  ckActive_DbStream(db->active) ;
#line 8904 "BerkeleyDB.c"
#line 5471 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$dbstream->write needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = (db->stream->write)(db->stream, &data, offset, flags);
#endif
#line 8911 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__DbStream_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__DbStream_size)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dbstream, size, flags=0");
    {
	BerkeleyDB__DbStream	dbstream;
	db_off_t	size;
	u_int32_t	flags;
#line 5485 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8935 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            dbstream = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::DbStream")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            dbstream = INT2PTR(BerkeleyDB__DbStream, tmp);
        }
        else
            croak("dbstream is not of type BerkeleyDB::DbStream")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 5487 "BerkeleyDB.xs"
	  ckActive_DbStream(dbstream->active) ;
#line 8956 "BerkeleyDB.c"
#line 5489 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_6_0
	    softCrash("$dbstream->size needs Berkeley DB 6.0 or better") ;
#else
        RETVAL = dbstream->stream->size(dbstream->stream, &size, flags);
#endif
#line 8963 "BerkeleyDB.c"
        sv_setiv(ST(1), (UV)size);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr__txn_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr__txn_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "txnmgr, pid=NULL, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__TxnMgr	txnmgr;
	BerkeleyDB__Txn	pid;
#line 5506 "BerkeleyDB.xs"
	  dMY_CXT;
#line 8989 "BerkeleyDB.c"
	BerkeleyDB__Txn__Raw	RETVAL;
	dXSTARG;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnmgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnmgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnmgr is not of type BerkeleyDB::TxnMgr")
;

	if (items < 2)
	    pid = NULL;
	else {
	if (ST(1) == &PL_sv_undef || ST(1) == NULL)
	    pid = NULL ;
	else if (sv_derived_from(ST(1), "BerkeleyDB::Txn")) {
	    IV tmp = SvIV(getInnerObject(ST(1))) ;
	    pid = INT2PTR(BerkeleyDB__Txn, tmp);
	}
	else
	    croak("pid is not of type BerkeleyDB::Txn")
;
	}
#line 5508 "BerkeleyDB.xs"
	{
	    DB_TXN *txn ;
	    DB_TXN *p_id = NULL ;
#if DB_VERSION_MAJOR == 2
	    if (txnmgr->env->Env->tx_info == NULL)
		softCrash("Transaction Manager not enabled") ;
#endif
	    if (pid)
		p_id = pid->txn ;
	    txnmgr->env->TxnMgrStatus =
#if DB_VERSION_MAJOR == 2
	    	txn_begin(txnmgr->env->Env->tx_info, p_id, &txn) ;
#else
#  ifdef AT_LEAST_DB_4
	    	txnmgr->env->Env->txn_begin(txnmgr->env->Env, p_id, &txn, flags) ;
#  else
	    	txn_begin(txnmgr->env->Env, p_id, &txn, flags) ;
#  endif
#endif
	    if (txnmgr->env->TxnMgrStatus == 0) {
	      ZMALLOC(RETVAL, BerkeleyDB_Txn_type) ;
	      RETVAL->txn  = txn ;
	      RETVAL->active = TRUE ;
	      Trace(("_txn_begin created txn [%p] in [%p]\n", txn, RETVAL));
	      hash_store_iv("BerkeleyDB::Term::Txn", (char *)RETVAL, 1) ;
	    }
	    else
		RETVAL = NULL ;
	}
#line 9053 "BerkeleyDB.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mgr");
    {
	BerkeleyDB__TxnMgr	mgr;
#line 5545 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9070 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            mgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            mgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("mgr is not of type BerkeleyDB::TxnMgr")
;
#line 5547 "BerkeleyDB.xs"
	    RETVAL =  mgr->env->TxnMgrStatus ;
#line 9084 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mgr");
    {
	BerkeleyDB__TxnMgr	mgr;
#line 5556 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9106 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            mgr = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            mgr = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("mgr is not of type BerkeleyDB::TxnMgr")
;
#line 5558 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::TxnMgr::DESTROY dirty=%d\n", PL_dirty)) ;
          Safefree(mgr) ;
	  Trace(("End of BerkeleyDB::TxnMgr::DESTROY\n")) ;
#line 9121 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "txnp");
    {
	BerkeleyDB__TxnMgr	txnp;

	Perl_croak(aTHX_ "BerkeleyDB::TxnMgr::txn_close: not implemented yet");
    }
    XSRETURN(1);
}

#if DB_VERSION_MAJOR == 2
#  define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env->tx_info, k, m)
#else
#  ifdef AT_LEAST_DB_4 
#    define xx_txn_checkpoint(e,k,m,f) e->env->Env->txn_checkpoint(e->env->Env, k, m, f)
#  else
#    ifdef AT_LEAST_DB_3_1
#      define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env, k, m, 0)
#    else
#      define xx_txn_checkpoint(t,k,m,f) txn_checkpoint(t->env->Env, k, m)
#    endif
#  endif
#endif

XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_checkpoint)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "txnp, kbyte, min, flags=0");
    {
	BerkeleyDB__TxnMgr	txnp;
	long	kbyte = (long)SvIV(ST(1))
;
	long	min = (long)SvIV(ST(2))
;
	u_int32_t	flags;
#line 5588 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9170 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnp = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnp = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnp is not of type BerkeleyDB::TxnMgr")
;

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}

	RETVAL = xx_txn_checkpoint(txnp, kbyte, min, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "txnp");
    {
	BerkeleyDB__TxnMgr	txnp;
	HV *	RETVAL = NULL ;
#line 5595 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9213 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txnp = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::TxnMgr")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txnp = INT2PTR(BerkeleyDB__TxnMgr, tmp);
        }
        else
            croak("txnp is not of type BerkeleyDB::TxnMgr")
;
#line 5597 "BerkeleyDB.xs"
	{
	    DB_TXN_STAT *	stat ;
#ifdef AT_LEAST_DB_4
	    if(txnp->env->Env->txn_stat(txnp->env->Env, &stat, 0) == 0) {
#else
#  ifdef AT_LEAST_DB_3_3
	    if(txn_stat(txnp->env->Env, &stat) == 0) {
#  else
#    if DB_VERSION_MAJOR == 2
	    if(txn_stat(txnp->env->Env->tx_info, &stat, safemalloc) == 0) {
#    else
	    if(txn_stat(txnp->env->Env, &stat, safemalloc) == 0) {
#    endif
#  endif
#endif
	    	RETVAL = (HV*)sv_2mortal((SV*)newHV()) ;
		hv_store_iv(RETVAL, "st_time_ckp", stat->st_time_ckp) ;
		hv_store_iv(RETVAL, "st_last_txnid", stat->st_last_txnid) ;
		hv_store_iv(RETVAL, "st_maxtxns", stat->st_maxtxns) ;
		hv_store_iv(RETVAL, "st_naborts", stat->st_naborts) ;
		hv_store_iv(RETVAL, "st_nbegins", stat->st_nbegins) ;
		hv_store_iv(RETVAL, "st_ncommits", stat->st_ncommits) ;
		hv_store_iv(RETVAL, "st_nactive", stat->st_nactive) ;
#if DB_VERSION_MAJOR > 2
		hv_store_iv(RETVAL, "st_maxnactive", stat->st_maxnactive) ;
		hv_store_iv(RETVAL, "st_regsize", stat->st_regsize) ;
		hv_store_iv(RETVAL, "st_region_wait", stat->st_region_wait) ;
		hv_store_iv(RETVAL, "st_region_nowait", stat->st_region_nowait) ;
#endif
		safefree(stat) ;
	    }
	}
#line 9257 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__TxnMgr_txn_open)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "dir, flags, mode, dbenv");
    {
	int	flags = (int)SvIV(ST(1))
;
	const char *	dir;
	int	mode = (int)SvIV(ST(2))
;
	BerkeleyDB__Env	dbenv;

	Perl_croak(aTHX_ "BerkeleyDB::TxnMgr::txn_open: not implemented yet");
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Txn_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tid");
    {
	BerkeleyDB__Txn	tid;
#line 5648 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9299 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;
#line 5650 "BerkeleyDB.xs"
	    RETVAL =  tid->Status ;
#line 9313 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Txn_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "txn, timeout, flags=0");
    {
	BerkeleyDB__Txn	txn;
	db_timeout_t        timeout = SvUV(ST(1))
;
	u_int32_t	flags;
#line 5660 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9338 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            txn = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            txn = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("txn is not of type BerkeleyDB::Txn")
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 5662 "BerkeleyDB.xs"
	    ckActive_Transaction(txn->active) ;
#line 9360 "BerkeleyDB.c"
#line 5664 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4
	    softCrash("$env->set_timeout needs Berkeley DB 4.x or better") ;
#else
	    RETVAL = txn->Status = txn->txn->set_timeout(txn->txn, timeout, flags);
#endif
#line 9367 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Txn_set_tx_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_set_tx_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	BerkeleyDB__Env	env;
	u_int32_t        max = SvUV(ST(1))
;
#line 5677 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9386 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 5679 "BerkeleyDB.xs"
	    ckActive_Database(env->active) ;
#line 9401 "BerkeleyDB.c"
#line 5681 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_2_3
	    softCrash("$env->set_tx_max needs Berkeley DB 2_3.x or better") ;
#else
            dieIfEnvOpened(env, "set_tx_max");
	    RETVAL = env->Status = env->Env->set_tx_max(env->Env, max);
#endif
#line 9409 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Txn_get_tx_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_get_tx_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	BerkeleyDB__Env	env;
	u_int32_t	max;
#line 5695 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9427 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            env = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Env")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            env = INT2PTR(BerkeleyDB__Env, tmp);
        }
        else
            croak("env is not of type BerkeleyDB::Env")
;
#line 5697 "BerkeleyDB.xs"
	    ckActive_Database(env->active) ;
#line 9442 "BerkeleyDB.c"
#line 5699 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_2_3
	    softCrash("$env->get_tx_max needs Berkeley DB 2_3.x or better") ;
#else
	    RETVAL = env->Status = env->Env->get_tx_max(env->Env, &max);
#endif
#line 9449 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)max);
	SvSETMAGIC(ST(1));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Txn__DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn__DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tid");
    {
	BerkeleyDB__Txn	tid;
#line 5712 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9468 "BerkeleyDB.c"

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;
#line 5714 "BerkeleyDB.xs"
	  Trace(("In BerkeleyDB::Txn::_DESTROY txn [%p] active [%d] dirty=%d\n", tid->txn, tid->active, PL_dirty)) ;
	  if (tid->active)
#ifdef AT_LEAST_DB_4
	    tid->txn->abort(tid->txn) ;
#else
	    txn_abort(tid->txn) ;
#endif
	  hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
          Safefree(tid) ;
	  Trace(("End of BerkeleyDB::Txn::DESTROY\n")) ;
#line 9490 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}

#define xx_txn_unlink(d,f,e)	txn_unlink(d,f,&(e->Env))

XS_EUPXS(XS_BerkeleyDB__Txn_txn_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_txn_unlink)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "dir, force, dbenv");
    {
	const char *	dir;
	int	force = (int)SvIV(ST(1))
;
	BerkeleyDB__Env	dbenv;

	Perl_croak(aTHX_ "BerkeleyDB::Txn::txn_unlink: not implemented yet");
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define xx_txn_prepare(t) (t->Status = t->txn->prepare(t->txn, 0))
#else
#  ifdef AT_LEAST_DB_3_3
#    define xx_txn_prepare(t) (t->Status = txn_prepare(t->txn, 0))
#  else
#    define xx_txn_prepare(t) (t->Status = txn_prepare(t->txn))
#  endif
#endif

XS_EUPXS(XS_BerkeleyDB__Txn_txn_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_txn_prepare)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tid");
    {
	BerkeleyDB__Txn	tid;
#line 5746 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9534 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;
#line 5748 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
#line 9548 "BerkeleyDB.c"

	RETVAL = xx_txn_prepare(tid);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_commit(t,flags) (t->Status = t->txn->commit(t->txn, flags))
#else
#  if DB_VERSION_MAJOR == 2
#    define _txn_commit(t,flags) (t->Status = txn_commit(t->txn))
#  else
#    define _txn_commit(t, flags) (t->Status = txn_commit(t->txn, flags))
#  endif
#endif

XS_EUPXS(XS_BerkeleyDB__Txn__txn_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn__txn_commit)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "tid, flags=0");
    {
	u_int32_t	flags;
	BerkeleyDB__Txn	tid;
#line 5764 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9582 "BerkeleyDB.c"
	DualType	RETVAL;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;
#line 5766 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 9605 "BerkeleyDB.c"

	RETVAL = _txn_commit(tid, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_abort(t) (t->Status = t->txn->abort(t->txn))
#else
#  define _txn_abort(t) (t->Status = txn_abort(t->txn))
#endif

XS_EUPXS(XS_BerkeleyDB__Txn__txn_abort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn__txn_abort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tid");
    {
	BerkeleyDB__Txn	tid;
#line 5779 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9634 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;
#line 5781 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 9650 "BerkeleyDB.c"

	RETVAL = _txn_abort(tid);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define _txn_discard(t,f) (t->Status = t->txn->discard(t->txn, f))
#else
#  ifdef AT_LEAST_DB_3_3_4
#    define _txn_discard(t,f) (t->Status = txn_discard(t->txn, f))
#  else
#    define _txn_discard(t,f) (int)softCrash("txn_discard needs Berkeley DB 3.3.4 or better") ;
#  endif
#endif

XS_EUPXS(XS_BerkeleyDB__Txn__txn_discard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn__txn_discard)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "tid, flags=0");
    {
	BerkeleyDB__Txn	tid;
	u_int32_t	flags;
#line 5799 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9684 "BerkeleyDB.c"
	DualType	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 5801 "BerkeleyDB.xs"
	    ckActive_Transaction(tid->active) ;
	    hash_delete("BerkeleyDB::Term::Txn", (char *)tid) ;
	    tid->active = FALSE ;
#line 9707 "BerkeleyDB.c"

	RETVAL = _txn_discard(tid, flags);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef AT_LEAST_DB_4
#  define xx_txn_id(t) t->txn->id(t->txn)
#else
#  define xx_txn_id(t) txn_id(t->txn)
#endif

XS_EUPXS(XS_BerkeleyDB__Txn_txn_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Txn_txn_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "tid");
    {
	BerkeleyDB__Txn	tid;
#line 5814 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9736 "BerkeleyDB.c"
	u_int32_t	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            tid = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Txn")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            tid = INT2PTR(BerkeleyDB__Txn, tmp);
        }
        else
            croak("tid is not of type BerkeleyDB::Txn")
;

	RETVAL = xx_txn_id(tid);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB___tiedHash_FIRSTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB___tiedHash_FIRSTKEY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 5822 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9767 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5824 "BerkeleyDB.xs"
        {
            DBTKEY      key ;
            DBT         value ;
	    DBC *	cursor ;

	    /*
		TODO!
		set partial value to 0 - to eliminate the retrieval of
		the value need to store any existing partial settings &
		restore at the end.

	     */
            saveCurrentDB(db) ;
	    DBT_clear(key) ;
	    DBT_clear(value) ;
	    /* If necessary create a cursor for FIRSTKEY/NEXTKEY use */
	    if (!db->cursor &&
		(db->Status = db_cursor(db, db->txn, &cursor, 0)) == 0 )
	            db->cursor  = cursor ;

	    if (db->cursor)
	        RETVAL = (db->Status) =
		    ((db->cursor)->c_get)(db->cursor, &key, &value, DB_FIRST);
	    else
		RETVAL = db->Status ;
	    /* check for end of cursor */
	    if (RETVAL == DB_NOTFOUND) {
	      ((db->cursor)->c_close)(db->cursor) ;
	      db->cursor = NULL ;
	    }
            ST(0) = sv_newmortal();
	    OutputKey(ST(0), key)
        }
#line 9814 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB___tiedHash_NEXTKEY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB___tiedHash_NEXTKEY)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, key");
    {
	BerkeleyDB__Common	db;
	DBTKEY	key;
#line 5865 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9831 "BerkeleyDB.c"
	int	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5867 "BerkeleyDB.xs"
        {
            DBT         value ;

            saveCurrentDB(db) ;
	    DBT_clear(key) ;
	    DBT_clear(value) ;
	    key.flags = 0 ;
	    RETVAL = (db->Status) =
		((db->cursor)->c_get)(db->cursor, &key, &value, DB_NEXT);

	    /* check for end of cursor */
	    if (db->Status == DB_NOTFOUND) {
	      ((db->cursor)->c_close)(db->cursor) ;
	      db->cursor = NULL ;
	    }
            ST(0) = sv_newmortal();
	    OutputKey(ST(0), key)
        }
#line 9863 "BerkeleyDB.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Recno_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Recno_FETCHSIZE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 5892 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9879 "BerkeleyDB.c"
	I32	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5894 "BerkeleyDB.xs"
            saveCurrentDB(db) ;
            RETVAL = GetArrayLength(db) ;
#line 9895 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Queue_FETCHSIZE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Queue_FETCHSIZE)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	BerkeleyDB__Common	db;
#line 5905 "BerkeleyDB.xs"
	  dMY_CXT;
#line 9912 "BerkeleyDB.c"
	I32	RETVAL;
	dXSTARG;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;
#line 5907 "BerkeleyDB.xs"
            saveCurrentDB(db) ;
            RETVAL = GetQueueLength(db) ;
#line 9928 "BerkeleyDB.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Common_db_create_sequence); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Common_db_create_sequence)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags=0");
    {
	BerkeleyDB__Common	db;
	u_int32_t	flags;
#line 5920 "BerkeleyDB.xs"
      dMY_CXT;
#line 9946 "BerkeleyDB.c"
	BerkeleyDB__Sequence	RETVAL;

        if (ST(0) == &PL_sv_undef || ST(0) == NULL)
            db = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Common")) {
            IV tmp = SvIV(getInnerObject(ST(0))) ;
            db = INT2PTR(BerkeleyDB__Common, tmp);
        }
        else
            croak("db is not of type BerkeleyDB::Common")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 5922 "BerkeleyDB.xs"
    {
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->create_sequence needs Berkeley DB 4.3.x or better") ;
#else
        DB_SEQUENCE *	seq ;
        saveCurrentDB(db);
        RETVAL = NULL;
        if (db_sequence_create(&seq, db->dbp, flags) == 0)
        {
            ZMALLOC(RETVAL, BerkeleyDB_Sequence_type);
            RETVAL->db = db;
            RETVAL->seq = seq;
            RETVAL->active = TRUE;
            ++ db->open_sequences ;
        }
#endif
    }
#line 9983 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "BerkeleyDB::Sequence", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_open)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "seq, key, flags=0");
    {
	BerkeleyDB__Sequence	seq;
	DBTKEY_seq	key;
	u_int32_t	flags;
#line 5951 "BerkeleyDB.xs"
        dMY_CXT;
#line 10007 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;

    InputKey_seq(ST(1), key)
;

	if (items < 3)
	    flags = 0;
	else {
	flags = SvUV(ST(2))
;
	}
#line 5953 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10031 "BerkeleyDB.c"
#line 5955 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->create_sequence needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->open(seq->seq, seq->db->txn, &key, flags);
#endif
#line 10038 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "seq, flags=0");
    {
	BerkeleyDB__Sequence	seq;
	u_int32_t	flags;
#line 5968 "BerkeleyDB.xs"
        dMY_CXT;
#line 10061 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 5970 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10082 "BerkeleyDB.c"
#line 5972 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->close needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = 0;    
        if (seq->active) {
            -- seq->db->open_sequences;
            RETVAL = (seq->seq->close)(seq->seq, flags);
        }
        seq->active = FALSE;
#endif
#line 10094 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_remove)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "seq, flags=0");
    {
	BerkeleyDB__Sequence	seq;
	u_int32_t	flags;
#line 5990 "BerkeleyDB.xs"
        dMY_CXT;
#line 10117 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;

	if (items < 2)
	    flags = 0;
	else {
	flags = SvUV(ST(1))
;
	}
#line 5992 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10138 "BerkeleyDB.c"
#line 5994 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->remove needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = 0;    
        if (seq->active)
            RETVAL = seq->seq->remove(seq->seq, seq->db->txn, flags);
        seq->active = FALSE;
#endif
#line 10148 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seq");
    {
	BerkeleyDB__Sequence	seq;
#line 6009 "BerkeleyDB.xs"
        dMY_CXT;
#line 10170 "BerkeleyDB.c"

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6011 "BerkeleyDB.xs"
#ifdef AT_LEAST_DB_4_3
        if (seq->active)
            (seq->seq->close)(seq->seq, 0);
        Safefree(seq);
#endif
#line 10187 "BerkeleyDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BerkeleyDB__Sequence_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_get)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "seq, element, delta=1, flags=0");
    {
	BerkeleyDB__Sequence	seq;
	IV	delta;
	db_seq_t	element;
	u_int32_t	flags;
#line 6024 "BerkeleyDB.xs"
        dMY_CXT;
#line 10206 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;

	if (items < 3)
	    delta = 1;
	else {
	    delta = (IV)SvIV(ST(2))
;
	}

	if (items < 4)
	    flags = 0;
	else {
	flags = SvUV(ST(3))
;
	}
#line 6026 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10234 "BerkeleyDB.c"
#line 6028 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->get needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->get(seq->seq, seq->db->txn, delta, &element, flags);
#endif
#line 10241 "BerkeleyDB.c"
        sv_setpvn((SV*)ST(1), (char*)&element, sizeof(db_seq_t));
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_get_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_get_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, key");
    {
	BerkeleyDB__Sequence	seq;
	DBTKEY_seq	key;
#line 6042 "BerkeleyDB.xs"
        dMY_CXT;
#line 10266 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6044 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10280 "BerkeleyDB.c"
#line 6046 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->get_key needs Berkeley DB 4.3.x or better") ;
#else
        DBT_clear(key);
        RETVAL = seq->seq->get_key(seq->seq, &key);
#endif
#line 10288 "BerkeleyDB.c"
	OutputKey_seq(ST(1), key)
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_initial_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_initial_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "seq, low, high=0");
    {
	BerkeleyDB__Sequence	seq;
	int	low = (int)SvIV(ST(1))
;
	int	high;
#line 6062 "BerkeleyDB.xs"
        dMY_CXT;
#line 10315 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;

	if (items < 3)
	    high = 0;
	else {
	    high = (int)SvIV(ST(2))
;
	}
#line 6064 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10336 "BerkeleyDB.c"
#line 6066 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->initial_value needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->initial_value(seq->seq, (db_seq_t)(high << 32 + low));
#endif
#line 10343 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_set_cachesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, size");
    {
	BerkeleyDB__Sequence	seq;
	int32_t        size = SvUV(ST(1))
;
#line 6079 "BerkeleyDB.xs"
        dMY_CXT;
#line 10367 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6081 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10381 "BerkeleyDB.c"
#line 6083 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->set_cachesize needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->set_cachesize(seq->seq, size);
#endif
#line 10388 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_get_cachesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_get_cachesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, size");
    {
	BerkeleyDB__Sequence	seq;
	int32_t	size;
#line 6096 "BerkeleyDB.xs"
        dMY_CXT;
#line 10411 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6098 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10425 "BerkeleyDB.c"
#line 6100 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->get_cachesize needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->get_cachesize(seq->seq, &size);
#endif
#line 10432 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)size);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_set_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, flags");
    {
	BerkeleyDB__Sequence	seq;
	u_int32_t        flags = SvUV(ST(1))
;
#line 6114 "BerkeleyDB.xs"
        dMY_CXT;
#line 10458 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6116 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10472 "BerkeleyDB.c"
#line 6118 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->set_flags needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->set_flags(seq->seq, flags);
#endif
#line 10479 "BerkeleyDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_get_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_get_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, flags");
    {
	BerkeleyDB__Sequence	seq;
	u_int32_t	flags;
#line 6131 "BerkeleyDB.xs"
        dMY_CXT;
#line 10502 "BerkeleyDB.c"
	DualType	RETVAL;

	if (ST(0) == &PL_sv_undef)
	    seq = NULL ;
        else if (sv_derived_from(ST(0), "BerkeleyDB::Sequence")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            seq = INT2PTR(BerkeleyDB__Sequence, tmp);
        }
        else
            croak("seq is not of type BerkeleyDB::Sequence")
;
#line 6133 "BerkeleyDB.xs"
        ckActive_Sequence(seq->active) ;
#line 10516 "BerkeleyDB.c"
#line 6135 "BerkeleyDB.xs"
#ifndef AT_LEAST_DB_4_3
	    softCrash("$seq->get_flags needs Berkeley DB 4.3.x or better") ;
#else
        RETVAL = seq->seq->get_flags(seq->seq, &flags);
#endif
#line 10523 "BerkeleyDB.c"
        sv_setuv(ST(1), (UV)flags);
	SvSETMAGIC(ST(1));
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    setDUALerrno(RETVALSV, RETVAL) ;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_set_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_set_range)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seq");
    {
	BerkeleyDB__Sequence	seq;

	Perl_croak(aTHX_ "BerkeleyDB::Sequence::set_range: not implemented yet");
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BerkeleyDB__Sequence_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BerkeleyDB__Sequence_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seq");
    {
	BerkeleyDB__Sequence	seq;

	Perl_croak(aTHX_ "BerkeleyDB::Sequence::stat: not implemented yet");
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_BerkeleyDB); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_BerkeleyDB)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("BerkeleyDB::constant", XS_BerkeleyDB_constant);
        newXS_deffile("BerkeleyDB::db_version", XS_BerkeleyDB_db_version);
        newXS_deffile("BerkeleyDB::has_heap", XS_BerkeleyDB_has_heap);
        newXS_deffile("BerkeleyDB::db_value_set", XS_BerkeleyDB_db_value_set);
        newXS_deffile("BerkeleyDB::_db_remove", XS_BerkeleyDB__db_remove);
        newXS_deffile("BerkeleyDB::_db_verify", XS_BerkeleyDB__db_verify);
        newXS_deffile("BerkeleyDB::_db_rename", XS_BerkeleyDB__db_rename);
        newXS_deffile("BerkeleyDB::Env::create", XS_BerkeleyDB__Env_create);
        newXS_deffile("BerkeleyDB::Env::open", XS_BerkeleyDB__Env_open);
        newXS_deffile("BerkeleyDB::Env::cds_enabled", XS_BerkeleyDB__Env_cds_enabled);
        newXS_deffile("BerkeleyDB::Env::set_encrypt", XS_BerkeleyDB__Env_set_encrypt);
        newXS_deffile("BerkeleyDB::Env::set_blob_threshold", XS_BerkeleyDB__Env_set_blob_threshold);
        newXS_deffile("BerkeleyDB::Env::_db_appinit", XS_BerkeleyDB__Env__db_appinit);
        newXS_deffile("BerkeleyDB::Env::DB_ENV", XS_BerkeleyDB__Env_DB_ENV);
        newXS_deffile("BerkeleyDB::Env::log_archive", XS_BerkeleyDB__Env_log_archive);
        newXS_deffile("BerkeleyDB::Env::log_set_config", XS_BerkeleyDB__Env_log_set_config);
        newXS_deffile("BerkeleyDB::Env::log_get_config", XS_BerkeleyDB__Env_log_get_config);
        newXS_deffile("BerkeleyDB::Env::_txn_begin", XS_BerkeleyDB__Env__txn_begin);
        newXS_deffile("BerkeleyDB::Env::txn_checkpoint", XS_BerkeleyDB__Env_txn_checkpoint);
        newXS_deffile("BerkeleyDB::Env::txn_stat", XS_BerkeleyDB__Env_txn_stat);
        newXS_deffile("BerkeleyDB::Env::printEnv", XS_BerkeleyDB__Env_printEnv);
        newXS_deffile("BerkeleyDB::Env::errPrefix", XS_BerkeleyDB__Env_errPrefix);
        newXS_deffile("BerkeleyDB::Env::status", XS_BerkeleyDB__Env_status);
        cv = newXS_deffile("BerkeleyDB::Env::close", XS_BerkeleyDB__Env_db_appexit);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("BerkeleyDB::Env::db_appexit", XS_BerkeleyDB__Env_db_appexit);
        XSANY.any_i32 = 0;
        newXS_deffile("BerkeleyDB::Env::_DESTROY", XS_BerkeleyDB__Env__DESTROY);
        newXS_deffile("BerkeleyDB::Env::_TxnMgr", XS_BerkeleyDB__Env__TxnMgr);
        newXS_deffile("BerkeleyDB::Env::get_shm_key", XS_BerkeleyDB__Env_get_shm_key);
        newXS_deffile("BerkeleyDB::Env::set_lg_dir", XS_BerkeleyDB__Env_set_lg_dir);
        newXS_deffile("BerkeleyDB::Env::set_lg_bsize", XS_BerkeleyDB__Env_set_lg_bsize);
        newXS_deffile("BerkeleyDB::Env::set_lg_max", XS_BerkeleyDB__Env_set_lg_max);
        newXS_deffile("BerkeleyDB::Env::set_data_dir", XS_BerkeleyDB__Env_set_data_dir);
        newXS_deffile("BerkeleyDB::Env::set_tmp_dir", XS_BerkeleyDB__Env_set_tmp_dir);
        newXS_deffile("BerkeleyDB::Env::set_mutexlocks", XS_BerkeleyDB__Env_set_mutexlocks);
        newXS_deffile("BerkeleyDB::Env::set_verbose", XS_BerkeleyDB__Env_set_verbose);
        newXS_deffile("BerkeleyDB::Env::set_flags", XS_BerkeleyDB__Env_set_flags);
        newXS_deffile("BerkeleyDB::Env::lsn_reset", XS_BerkeleyDB__Env_lsn_reset);
        newXS_deffile("BerkeleyDB::Env::lock_detect", XS_BerkeleyDB__Env_lock_detect);
        newXS_deffile("BerkeleyDB::Env::set_timeout", XS_BerkeleyDB__Env_set_timeout);
        newXS_deffile("BerkeleyDB::Env::get_timeout", XS_BerkeleyDB__Env_get_timeout);
        newXS_deffile("BerkeleyDB::Env::stat_print", XS_BerkeleyDB__Env_stat_print);
        newXS_deffile("BerkeleyDB::Env::lock_stat_print", XS_BerkeleyDB__Env_lock_stat_print);
        newXS_deffile("BerkeleyDB::Env::mutex_stat_print", XS_BerkeleyDB__Env_mutex_stat_print);
        newXS_deffile("BerkeleyDB::Env::txn_stat_print", XS_BerkeleyDB__Env_txn_stat_print);
        newXS_deffile("BerkeleyDB::Env::failchk", XS_BerkeleyDB__Env_failchk);
        newXS_deffile("BerkeleyDB::Env::set_isalive", XS_BerkeleyDB__Env_set_isalive);
        newXS_deffile("BerkeleyDB::Env::get_blob_threshold", XS_BerkeleyDB__Env_get_blob_threshold);
        newXS_deffile("BerkeleyDB::Env::get_blob_dir", XS_BerkeleyDB__Env_get_blob_dir);
        newXS_deffile("BerkeleyDB::Term::close_everything", XS_BerkeleyDB__Term_close_everything);
        newXS_deffile("BerkeleyDB::Term::safeCroak", XS_BerkeleyDB__Term_safeCroak);
        newXS_deffile("BerkeleyDB::Hash::_db_open_hash", XS_BerkeleyDB__Hash__db_open_hash);
        newXS_deffile("BerkeleyDB::Hash::db_stat", XS_BerkeleyDB__Hash_db_stat);
        newXS_deffile("BerkeleyDB::Unknown::_db_open_unknown", XS_BerkeleyDB__Unknown__db_open_unknown);
        newXS_deffile("BerkeleyDB::Btree::_db_open_btree", XS_BerkeleyDB__Btree__db_open_btree);
        newXS_deffile("BerkeleyDB::Btree::db_stat", XS_BerkeleyDB__Btree_db_stat);
        newXS_deffile("BerkeleyDB::Heap::_db_open_heap", XS_BerkeleyDB__Heap__db_open_heap);
        newXS_deffile("BerkeleyDB::Recno::_db_open_recno", XS_BerkeleyDB__Recno__db_open_recno);
        newXS_deffile("BerkeleyDB::Queue::_db_open_queue", XS_BerkeleyDB__Queue__db_open_queue);
        newXS_deffile("BerkeleyDB::Queue::db_stat", XS_BerkeleyDB__Queue_db_stat);
        newXS_deffile("BerkeleyDB::Common::db_close", XS_BerkeleyDB__Common_db_close);
        newXS_deffile("BerkeleyDB::Common::_DESTROY", XS_BerkeleyDB__Common__DESTROY);
        cv = newXS_deffile("BerkeleyDB::Common::__db_write_cursor", XS_BerkeleyDB__Common__db_cursor);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("BerkeleyDB::Common::_db_cursor", XS_BerkeleyDB__Common__db_cursor);
        XSANY.any_i32 = 0;
        newXS_deffile("BerkeleyDB::Common::_db_join", XS_BerkeleyDB__Common__db_join);
        newXS_deffile("BerkeleyDB::Common::ArrayOffset", XS_BerkeleyDB__Common_ArrayOffset);
        newXS_deffile("BerkeleyDB::Common::cds_enabled", XS_BerkeleyDB__Common_cds_enabled);
        newXS_deffile("BerkeleyDB::Common::stat_print", XS_BerkeleyDB__Common_stat_print);
        newXS_deffile("BerkeleyDB::Common::type", XS_BerkeleyDB__Common_type);
        newXS_deffile("BerkeleyDB::Common::byteswapped", XS_BerkeleyDB__Common_byteswapped);
        newXS_deffile("BerkeleyDB::Common::status", XS_BerkeleyDB__Common_status);
#if XSubPPtmpAAAA
        newXS_deffile("BerkeleyDB::Common::filter_fetch_key", XS_BerkeleyDB__Common_filter_fetch_key);
        newXS_deffile("BerkeleyDB::Common::filter_store_key", XS_BerkeleyDB__Common_filter_store_key);
        newXS_deffile("BerkeleyDB::Common::filter_fetch_value", XS_BerkeleyDB__Common_filter_fetch_value);
        newXS_deffile("BerkeleyDB::Common::filter_store_value", XS_BerkeleyDB__Common_filter_store_value);
#endif
        newXS_deffile("BerkeleyDB::Common::partial_set", XS_BerkeleyDB__Common_partial_set);
        newXS_deffile("BerkeleyDB::Common::partial_clear", XS_BerkeleyDB__Common_partial_clear);
        newXS_deffile("BerkeleyDB::Common::db_del", XS_BerkeleyDB__Common_db_del);
        newXS_deffile("BerkeleyDB::Common::db_get", XS_BerkeleyDB__Common_db_get);
        newXS_deffile("BerkeleyDB::Common::db_exists", XS_BerkeleyDB__Common_db_exists);
        newXS_deffile("BerkeleyDB::Common::db_pget", XS_BerkeleyDB__Common_db_pget);
        newXS_deffile("BerkeleyDB::Common::db_put", XS_BerkeleyDB__Common_db_put);
        newXS_deffile("BerkeleyDB::Common::db_key_range", XS_BerkeleyDB__Common_db_key_range);
        newXS_deffile("BerkeleyDB::Common::db_fd", XS_BerkeleyDB__Common_db_fd);
        newXS_deffile("BerkeleyDB::Common::db_sync", XS_BerkeleyDB__Common_db_sync);
        newXS_deffile("BerkeleyDB::Common::_Txn", XS_BerkeleyDB__Common__Txn);
        newXS_deffile("BerkeleyDB::Common::truncate", XS_BerkeleyDB__Common_truncate);
        newXS_deffile("BerkeleyDB::Common::associate", XS_BerkeleyDB__Common_associate);
        newXS_deffile("BerkeleyDB::Common::associate_foreign", XS_BerkeleyDB__Common_associate_foreign);
        newXS_deffile("BerkeleyDB::Common::compact", XS_BerkeleyDB__Common_compact);
        newXS_deffile("BerkeleyDB::Common::get_blob_threshold", XS_BerkeleyDB__Common_get_blob_threshold);
        newXS_deffile("BerkeleyDB::Common::get_blob_dir", XS_BerkeleyDB__Common_get_blob_dir);
        newXS_deffile("BerkeleyDB::Cursor::_c_dup", XS_BerkeleyDB__Cursor__c_dup);
        newXS_deffile("BerkeleyDB::Cursor::_c_close", XS_BerkeleyDB__Cursor__c_close);
        newXS_deffile("BerkeleyDB::Cursor::_DESTROY", XS_BerkeleyDB__Cursor__DESTROY);
        newXS_deffile("BerkeleyDB::Cursor::status", XS_BerkeleyDB__Cursor_status);
        newXS_deffile("BerkeleyDB::Cursor::c_del", XS_BerkeleyDB__Cursor_c_del);
        newXS_deffile("BerkeleyDB::Cursor::c_get", XS_BerkeleyDB__Cursor_c_get);
        newXS_deffile("BerkeleyDB::Cursor::c_pget", XS_BerkeleyDB__Cursor_c_pget);
        newXS_deffile("BerkeleyDB::Cursor::c_put", XS_BerkeleyDB__Cursor_c_put);
        newXS_deffile("BerkeleyDB::Cursor::c_count", XS_BerkeleyDB__Cursor_c_count);
        newXS_deffile("BerkeleyDB::Cursor::partial_set", XS_BerkeleyDB__Cursor_partial_set);
        newXS_deffile("BerkeleyDB::Cursor::partial_clear", XS_BerkeleyDB__Cursor_partial_clear);
        newXS_deffile("BerkeleyDB::Cursor::_db_stream", XS_BerkeleyDB__Cursor__db_stream);
        newXS_deffile("BerkeleyDB::Cursor::_c_get_db_stream", XS_BerkeleyDB__Cursor__c_get_db_stream);
        newXS_deffile("BerkeleyDB::DbStream::DESTROY", XS_BerkeleyDB__DbStream_DESTROY);
        newXS_deffile("BerkeleyDB::DbStream::close", XS_BerkeleyDB__DbStream_close);
        newXS_deffile("BerkeleyDB::DbStream::read", XS_BerkeleyDB__DbStream_read);
        newXS_deffile("BerkeleyDB::DbStream::write", XS_BerkeleyDB__DbStream_write);
        newXS_deffile("BerkeleyDB::DbStream::size", XS_BerkeleyDB__DbStream_size);
        newXS_deffile("BerkeleyDB::TxnMgr::_txn_begin", XS_BerkeleyDB__TxnMgr__txn_begin);
        newXS_deffile("BerkeleyDB::TxnMgr::status", XS_BerkeleyDB__TxnMgr_status);
        newXS_deffile("BerkeleyDB::TxnMgr::_DESTROY", XS_BerkeleyDB__TxnMgr__DESTROY);
        newXS_deffile("BerkeleyDB::TxnMgr::txn_close", XS_BerkeleyDB__TxnMgr_txn_close);
        newXS_deffile("BerkeleyDB::TxnMgr::txn_checkpoint", XS_BerkeleyDB__TxnMgr_txn_checkpoint);
        newXS_deffile("BerkeleyDB::TxnMgr::txn_stat", XS_BerkeleyDB__TxnMgr_txn_stat);
        newXS_deffile("BerkeleyDB::TxnMgr::txn_open", XS_BerkeleyDB__TxnMgr_txn_open);
        newXS_deffile("BerkeleyDB::Txn::status", XS_BerkeleyDB__Txn_status);
        newXS_deffile("BerkeleyDB::Txn::set_timeout", XS_BerkeleyDB__Txn_set_timeout);
        newXS_deffile("BerkeleyDB::Txn::set_tx_max", XS_BerkeleyDB__Txn_set_tx_max);
        newXS_deffile("BerkeleyDB::Txn::get_tx_max", XS_BerkeleyDB__Txn_get_tx_max);
        newXS_deffile("BerkeleyDB::Txn::_DESTROY", XS_BerkeleyDB__Txn__DESTROY);
        newXS_deffile("BerkeleyDB::Txn::txn_unlink", XS_BerkeleyDB__Txn_txn_unlink);
        newXS_deffile("BerkeleyDB::Txn::txn_prepare", XS_BerkeleyDB__Txn_txn_prepare);
        newXS_deffile("BerkeleyDB::Txn::_txn_commit", XS_BerkeleyDB__Txn__txn_commit);
        newXS_deffile("BerkeleyDB::Txn::_txn_abort", XS_BerkeleyDB__Txn__txn_abort);
        newXS_deffile("BerkeleyDB::Txn::_txn_discard", XS_BerkeleyDB__Txn__txn_discard);
        newXS_deffile("BerkeleyDB::Txn::txn_id", XS_BerkeleyDB__Txn_txn_id);
        newXS_deffile("BerkeleyDB::_tiedHash::FIRSTKEY", XS_BerkeleyDB___tiedHash_FIRSTKEY);
        newXS_deffile("BerkeleyDB::_tiedHash::NEXTKEY", XS_BerkeleyDB___tiedHash_NEXTKEY);
        newXS_deffile("BerkeleyDB::Recno::FETCHSIZE", XS_BerkeleyDB__Recno_FETCHSIZE);
        newXS_deffile("BerkeleyDB::Queue::FETCHSIZE", XS_BerkeleyDB__Queue_FETCHSIZE);
        newXS_deffile("BerkeleyDB::Common::db_create_sequence", XS_BerkeleyDB__Common_db_create_sequence);
        newXS_deffile("BerkeleyDB::Sequence::open", XS_BerkeleyDB__Sequence_open);
        newXS_deffile("BerkeleyDB::Sequence::close", XS_BerkeleyDB__Sequence_close);
        newXS_deffile("BerkeleyDB::Sequence::remove", XS_BerkeleyDB__Sequence_remove);
        newXS_deffile("BerkeleyDB::Sequence::DESTROY", XS_BerkeleyDB__Sequence_DESTROY);
        newXS_deffile("BerkeleyDB::Sequence::get", XS_BerkeleyDB__Sequence_get);
        newXS_deffile("BerkeleyDB::Sequence::get_key", XS_BerkeleyDB__Sequence_get_key);
        newXS_deffile("BerkeleyDB::Sequence::initial_value", XS_BerkeleyDB__Sequence_initial_value);
        newXS_deffile("BerkeleyDB::Sequence::set_cachesize", XS_BerkeleyDB__Sequence_set_cachesize);
        newXS_deffile("BerkeleyDB::Sequence::get_cachesize", XS_BerkeleyDB__Sequence_get_cachesize);
        newXS_deffile("BerkeleyDB::Sequence::set_flags", XS_BerkeleyDB__Sequence_set_flags);
        newXS_deffile("BerkeleyDB::Sequence::get_flags", XS_BerkeleyDB__Sequence_get_flags);
        newXS_deffile("BerkeleyDB::Sequence::set_range", XS_BerkeleyDB__Sequence_set_range);
        newXS_deffile("BerkeleyDB::Sequence::stat", XS_BerkeleyDB__Sequence_stat);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 6158 "BerkeleyDB.xs"
  {
#ifdef dTHX
    dTHX;
#endif       
    SV * sv_err = perl_get_sv(ERR_BUFF, GV_ADD|GV_ADDMULTI) ;
    SV * version_sv = perl_get_sv("BerkeleyDB::db_version", GV_ADD|GV_ADDMULTI) ;
    SV * ver_sv = perl_get_sv("BerkeleyDB::db_ver", GV_ADD|GV_ADDMULTI) ;
    int Major, Minor, Patch ;
    MY_CXT_INIT;
    (void)db_version(&Major, &Minor, &Patch) ;
    /* Check that the versions of db.h and libdb.a are the same */
    if (Major != DB_VERSION_MAJOR || Minor != DB_VERSION_MINOR
		|| Patch != DB_VERSION_PATCH)
        croak("\nBerkeleyDB needs compatible versions of libdb & db.h\n\tyou have db.h version %d.%d.%d and libdb version %d.%d.%d\n",
                DB_VERSION_MAJOR, DB_VERSION_MINOR, DB_VERSION_PATCH,
                Major, Minor, Patch) ;

    if (Major < 2 || (Major == 2 && Minor < 6))
    {
        croak("BerkeleyDB needs Berkeley DB 2.6 or greater. This is %d.%d.%d\n",
		Major, Minor, Patch) ;
    }
    sv_setpvf(version_sv, "%d.%d", Major, Minor) ;
    sv_setpvf(ver_sv, "%d.%03d%03d", Major, Minor, Patch) ;
    sv_setpv(sv_err, "");

    DBT_clear(empty) ;
    empty.data  = &zero ;
    empty.size  =  sizeof(db_recno_t) ;
    empty.flags = 0 ;

  }

#line 10784 "BerkeleyDB.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

